commit 7c791b15504cc86a929acaa88161f012cdbba59f
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Wed Mar 29 13:58:30 2023 +0200

    xserver 21.1.8
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>

commit fb51d5dd53b02422ea3b6f36bd017488d41f472d
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Mon Mar 13 11:08:47 2023 +0100

    composite: Fix use-after-free of the COW
    
    ZDI-CAN-19866/CVE-2023-1393
    
    If a client explicitly destroys the compositor overlay window (aka COW),
    we would leave a dangling pointer to that window in the CompScreen
    structure, which will trigger a use-after-free later.
    
    Make sure to clear the CompScreen pointer to the COW when the latter gets
    destroyed explicitly by the client.
    
    This vulnerability was discovered by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    (cherry picked from commit 26ef545b3502f61ca722a7a3373507e88ef64110)

commit 6bed5cfd515b9634ecf73fb884e4ec3388e8b7eb
Author: Benno Schulenberg <bensberg@telfort.nl>
Date:   Mon Mar 27 20:03:56 2023 +0200

    xkbUtils: use existing symbol names instead of deleted deprecated ones
    
    Symbols `XK_Cyrillic_DZHE` and `XK_Serbian_DZE` were pure synonyms.
    
    (cherry picked from commit 6153c71cfb4698f1a416266564ecc748e4a25f2c)

commit af9111ac7fa399a5a33fbfa145060e1850f41e0e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Feb 7 10:30:37 2023 +1000

    xserver 21.1.7
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit 9ca7d3f61a88ae6cf47fdf139b6215d745db976b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Jan 25 11:41:40 2023 +1000

    Xi: fix potential use-after-free in DeepCopyPointerClasses
    
    CVE-2023-0494, ZDI-CAN-19596
    
    This vulnerability was discovered by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    (cherry picked from commit 0ba6d8c37071131a49790243cdac55392ecf71ec)

commit 4b925d388f76764dcb02dfd1cd7276262dcd7d74
Author: Mike Gorse <mgorse@suse.com>
Date:   Wed Jan 25 02:02:48 2023 +0000

    dix: Use CopyPartialInternalEvent in EnqueueEvent
    
    The event might be a DeviceEvent allocated on the stack, in
    AccessXKeyboardEvent for instance. Fixes out-of-bounds read.
    
    Signed-off-by: Mike Gorse <mgorse@suse.com>
    (cherry picked from commit 2ef5ef57bd37a8bec2ac454053b283c6f87c3b40)

commit 44d6c82ac82a78d904a6d47387ac363d9699b891
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 18 10:38:41 2023 -0800

    darwin: Implement DetermineClientCmd for macOS
    
    Withoug a proper implementation of DetermineClientCmd, clients that
    connect via an ssh tunnel are miscategorized as local.  This results
    in failures when we try to use SCM_RIGHTS (eg: in MIT-SHM).
    
    Fixes: https://github.com/XQuartz/XQuartz/issues/314
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 0ea9b595891f2f31915538192961f3404d9ca699)

commit 1317083fbc407dc9dbb04ba5b98187b75222a16f
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 18 12:19:05 2023 -0800

    os: Use LOCAL_PEERPID from sys/un.h if it is available to detemine the pid when falling back on getpeereids()
    
    This provides a way to determine the pid of a peer connection on
    systems like darwin that do not support getpeerucred() nor
    SO_PEERCRED.
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 8a4ab2287398773a4868c220662d93bf84ec6241)

commit a6c49106cef36e84eb11d64e325465250b7678be
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 18 12:02:54 2023 -0800

    os: Update GetLocalClientCreds to prefer getpeerucred() or SO_PEERCRED over getpeereid()
    
    GetLocalClientCreds() was preferring getpeereid() above other implementations.
    
    getpeereid(), however, only returns the effective uid and gid of the peer,
    leaving the pid unset.  When this happens, we are unable to use the pid to
    determine the peer's command line arguments and incorrectly treat ssh-tunneled
    traffic as local.
    
    To address this, we now prioritize getpeerucred() or SO_PEERCRED as those two
    implementations will return the pid in addition to uid and gid.
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 165d5c1260edcb998c5cf31d3969723c7452aa7f)

commit a220f53cb81248d06fb6f044c102c6ab8bffe2d5
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 18 10:44:27 2023 -0800

    os: Update AllocNewConnection() debug logging to include whether or not the client is local
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 2577291f010e07173d0fc8b310ac355928f8ed7d)

commit 07f9689507eee11bdbc2828ac1319fbde91ad27c
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sun Nov 27 22:25:49 2022 -0800

    Revert "meson: Don't build COMPOSITE for XQuartz"
    
    This will allow us to remove build-time conditionalization on COMPOSITE
    while still allowing XQuartz to disable it and use ROOTLESS.
    
    This reverts commit 5f2d652377995c0c0c3cf07463b5018450661d13
    
    (cherry picked from commit 66e7b7349dffda6fef51ed029fdc91b787ca4c08)

commit 8ea43dd8bf8f8f2cb82a2a1f2c004ee873e7810d
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sun Nov 27 22:23:43 2022 -0800

    xquartz: Disable COMPOSITE at runtime
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 2567388a2957cef526df1b7efb2684aa74feb641)

commit aa0d8d440c39beb276cd26723d822728ce394e01
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Tue Jan 17 07:33:19 2023 -0800

    xquartz: Update the about box copyright to 2023
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 15077090d371a2679d274c5d129a3102762d18ec)

commit 8feba178f8b73b983033c197c384c580a6397a41
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sat Jan 14 23:33:59 2023 -0800

    xquartz: Fix building with autoconf
    
    Regressed-in: 5d302c378d9d21b34db2434425b766ac4f05de89
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit c8ef9e38187e00dbaf956893f987e15e8f42f61c
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Tue Jul 12 14:44:48 2022 +0200

    dix: Fix overzealous caching of ResourceClientBits()
    
    Commit c7311654 cached the value of ResourceClientBits(), but that value
    depends on the `MaxClients` value set either from the command line or
    from the configuration file.
    
    For the latter, a call to ResourceClientBits() is issued before the
    configuration file is read, meaning that the cached value is from the
    default, not from the maximum number of clients set in the configuration
    file.
    
    That obviously causes all sort of issues, including memory corruption
    and crashes of the Xserver when reaching the default limit value.
    
    To avoid that issue, also keep the LimitClient value, and recompute the
    ilog2() value if that changes, as on startup when the value is set from
    the the xorg.conf ServerFlags section.
    
    v2: Drop the `cache == 0` test
        Rename cache vars
    
    Fixes: c7311654 - dix: cache ResourceClientBits() value
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1310
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    (cherry picked from commit 2efa6d659508346358a1ef27b2393e18843f66a3)

commit a0216de2367429788be4ef430026ada215106ff5
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Dec 14 23:45:13 2022 -0800

    rootless: Add additional debug logging to help triage XQuartz fb/rootless/damage crashes
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 07ed1a623a4b36cdb741a322008ba53d913dc765)

commit 264272f3d76e4f1e50d984640c57de77aca9ba37
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Dec 14 17:07:46 2022 -0800

    xquartz: Use xorg_backtrace() instead of rolling our own for debugging
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit d1a9a50792110683ae3f993eeeffeee79cf9cbce)

commit 20f380c6d93be3ef561251584163d1fe1ae2d966
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Dec 21 01:18:11 2022 -0800

    xquartz: Ignore SIGPIPE at process launch
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 9a66690eaf67c19b90e07f39b16436d34b59e27a)

commit 59b6fc88ed9f4b22397a568c2483e4c558856ffa
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Mon Dec 19 10:46:20 2022 +0100

    xserver 21.1.6
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>

commit b7760d41c177983c2f2fca2ebdb8105628291720
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Dec 19 10:06:45 2022 +1000

    Xext: fix invalid event type mask in XTestSwapFakeInput
    
    In commit b320ca0 the mask was inadvertently changed from octal 0177 to
    hexadecimal 0x177.
    
    Fixes commit b320ca0ffe4c0c872eeb3a93d9bde21f765c7c63
      Xtest: disallow GenericEvents in XTestSwapFakeInput
    
    Found by Stuart Cassoff
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    (cherry picked from commit bb1711b7fba42f2a0c7d1c09beee241a1b2bcc30)

commit 69ab3bcaa0f6a5adef6ec19161eb856a4744b32c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Jul 13 11:23:09 2022 +1000

    xkb: fix some possible memleaks in XkbGetKbdByName
    
    GetComponentByName returns an allocated string, so let's free that if we
    fail somewhere.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    (cherry picked from commit 18f91b950e22c2a342a4fbc55e9ddf7534a707d2)

commit 5dbb2b52cfeab212b5c9b7e344692a6384efdc4c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jul 5 12:06:20 2022 +1000

    xkb: proof GetCountedString against request length attacks
    
    GetCountedString did a check for the whole string to be within the
    request buffer but not for the initial 2 bytes that contain the length
    field. A swapped client could send a malformed request to trigger a
    swaps() on those bytes, writing into random memory.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    (cherry picked from commit 11beef0b7f1ed290348e45618e5fa0d2bffcb72e)

commit becf9d51c33a21e7700b18bb2324f466bb966de5
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Dec 14 00:13:34 2022 -0800

    xquartz: Fix some formatting
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 61d18bed664769b1d94ea1320e27f71560a01af2
Author: John D Pell <John+git@gaelicWizard.net>
Date:   Tue Jul 13 23:46:28 2021 -0700

    XQuartz: stub: Call LSOpenApplication instead of fork()/exec()
    
    Reviewed-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit f292fbfaac0c653ee49bbb24deb3add2b5da602f
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Dec 14 11:34:41 2022 +1000

    xserver 21.1.5
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit e860bbce4fdb169e84033529331ae2666e679de7
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Mon Dec 5 15:55:54 2022 +1000

    xkb: reset the radio_groups pointer to NULL after freeing it
    
    Unlike other elements of the keymap, this pointer was freed but not
    reset. On a subsequent XkbGetKbdByName request, the server may access
    already freed memory.
    
    CVE-2022-4283, ZDI-CAN-19530
    
    This vulnerability was discovered by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit ccdd431cd8f1cabae9d744f0514b6533c438908c)

commit 8a1fa008b2f90abce6cabb27d9bc2ed76d07b678
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Nov 29 13:26:57 2022 +1000

    Xi: avoid integer truncation in length check of ProcXIChangeProperty
    
    This fixes an OOB read and the resulting information disclosure.
    
    Length calculation for the request was clipped to a 32-bit integer. With
    the correct stuff->num_items value the expected request size was
    truncated, passing the REQUEST_FIXED_SIZE check.
    
    The server then proceeded with reading at least stuff->num_items bytes
    (depending on stuff->format) from the request and stuffing whatever it
    finds into the property. In the process it would also allocate at least
    stuff->num_items bytes, i.e. 4GB.
    
    The same bug exists in ProcChangeProperty and ProcXChangeDeviceProperty,
    so let's fix that too.
    
    CVE-2022-46344, ZDI-CAN 19405
    
    This vulnerability was discovered by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit 8f454b793e1f13c99872c15f0eed1d7f3b823fe8)

commit 40f431de8a76f737c68ae659fee8472583f15e49
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Nov 29 13:24:00 2022 +1000

    Xi: return an error from XI property changes if verification failed
    
    Both ProcXChangeDeviceProperty and ProcXIChangeProperty checked the
    property for validity but didn't actually return the potential error.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit b8a84cb0f2807b07ab70ca9915fcdee21301b8ca)

commit d6c7de9eadca980c8ce3b3b7752b67bfa95e6f31
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Nov 29 14:53:07 2022 +1000

    Xext: free the screen saver resource when replacing it
    
    This fixes a use-after-free bug:
    
    When a client first calls ScreenSaverSetAttributes(), a struct
    ScreenSaverAttrRec is allocated and added to the client's
    resources.
    
    When the same client calls ScreenSaverSetAttributes() again, a new
    struct ScreenSaverAttrRec is allocated, replacing the old struct. The
    old struct was freed but not removed from the clients resources.
    
    Later, when the client is destroyed the resource system invokes
    ScreenSaverFreeAttr and attempts to clean up the already freed struct.
    
    Fix this by letting the resource system free the old attrs instead.
    
    CVE-2022-46343, ZDI-CAN 19404
    
    This vulnerability was discovered by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit 842ca3ccef100ce010d1d8f5f6d6cc1915055900)

commit 67927cc41f452228188bbe2aa34a9ee4a9ce0c6b
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Wed Nov 30 11:20:40 2022 +1000

    Xext: free the XvRTVideoNotify when turning off from the same client
    
    This fixes a use-after-free bug:
    
    When a client first calls XvdiSelectVideoNotify() on a drawable with a
    TRUE onoff argument, a struct XvVideoNotifyRec is allocated. This struct
    is added twice to the resources:
      - as the drawable's XvRTVideoNotifyList. This happens only once per
        drawable, subsequent calls append to this list.
      - as the client's XvRTVideoNotify. This happens for every client.
    
    The struct keeps the ClientPtr around once it has been added for a
    client. The idea, presumably, is that if the client disconnects we can remove
    all structs from the drawable's list that match the client (by resetting
    the ClientPtr to NULL), but if the drawable is destroyed we can remove
    and free the whole list.
    
    However, if the same client then calls XvdiSelectVideoNotify() on the
    same drawable with a FALSE onoff argument, only the ClientPtr on the
    existing struct was set to NULL. The struct itself remained in the
    client's resources.
    
    If the drawable is now destroyed, the resource system invokes
    XvdiDestroyVideoNotifyList which frees the whole list for this drawable
    - including our struct. This function however does not free the resource
    for the client since our ClientPtr is NULL.
    
    Later, when the client is destroyed and the resource system invokes
    XvdiDestroyVideoNotify, we unconditionally set the ClientPtr to NULL. On
    a struct that has been freed previously. This is generally frowned upon.
    
    Fix this by calling FreeResource() on the second call instead of merely
    setting the ClientPtr to NULL. This removes the struct from the client
    resources (but not from the list), ensuring that it won't be accessed
    again when the client quits.
    
    Note that the assignment tpn->client = NULL; is superfluous since the
    XvdiDestroyVideoNotify function will do this anyway. But it's left for
    clarity and to match a similar invocation in XvdiSelectPortNotify.
    
    CVE-2022-46342, ZDI-CAN 19400
    
    This vulnerability was discovered by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit b79f32b57cc0c1186b2899bce7cf89f7b325161b)

commit a6c0d7b142e762a6b9934a23e060ea91ff5afcea
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Nov 29 13:55:32 2022 +1000

    Xi: disallow passive grabs with a detail > 255
    
    The XKB protocol effectively prevents us from ever using keycodes above
    255. For buttons it's theoretically possible but realistically too niche
    to worry about. For all other passive grabs, the detail must be zero
    anyway.
    
    This fixes an OOB write:
    
    ProcXIPassiveUngrabDevice() calls DeletePassiveGrabFromList with a
    temporary grab struct which contains tempGrab->detail.exact = stuff->detail.
    For matching existing grabs, DeleteDetailFromMask is called with the
    stuff->detail value. This function creates a new mask with the one bit
    representing stuff->detail cleared.
    
    However, the array size for the new mask is 8 * sizeof(CARD32) bits,
    thus any detail above 255 results in an OOB array write.
    
    CVE-2022-46341, ZDI-CAN 19381
    
    This vulnerability was discovered by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit 51eb63b0ee1509c6c6b8922b0e4aa037faa6f78b)

commit 936d34bdff4c479ccd0405fc221ff8e4c6c7014d
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Nov 29 12:55:45 2022 +1000

    Xtest: disallow GenericEvents in XTestSwapFakeInput
    
    XTestSwapFakeInput assumes all events in this request are
    sizeof(xEvent) and iterates through these in 32-byte increments.
    However, a GenericEvent may be of arbitrary length longer than 32 bytes,
    so any GenericEvent in this list would result in subsequent events to be
    misparsed.
    
    Additional, the swapped event is written into a stack-allocated struct
    xEvent (size 32 bytes). For any GenericEvent longer than 32 bytes,
    swapping the event may thus smash the stack like an avocado on toast.
    
    Catch this case early and return BadValue for any GenericEvent.
    Which is what would happen in unswapped setups anyway since XTest
    doesn't support GenericEvent.
    
    CVE-2022-46340, ZDI-CAN 19265
    
    This vulnerability was discovered by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit b320ca0ffe4c0c872eeb3a93d9bde21f765c7c63)

commit 5f2d652377995c0c0c3cf07463b5018450661d13
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sun Nov 27 15:04:13 2022 -0800

    meson: Don't build COMPOSITE for XQuartz
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 9c0373366988cc0b909ba31e61c43cc46e054b40)

commit 3dee0aac2c0ed4538880b65ee528e4633d103592
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Nov 24 10:58:26 2022 -0800

    xquartz: Move default applications list outside of the main executable
    
    This will allow side-wide customization.
    
    Fixes: https://github.com/XQuartz/XQuartz/issues/274
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit e654de80ed560c480efc072d876808b1d78da052)

commit 5d302c378d9d21b34db2434425b766ac4f05de89
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Nov 24 11:04:08 2022 -0800

    xquartz: Remove unused macro (X11LIBDIR)
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 3dbd809c0e2d8da4191dd4a3fd4abdd14be0d838)

commit 6bf62381d0a1fb54226a10f9d0e6b03aff12f3aa
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Tue Jul 12 16:09:23 2022 +0300

    xserver 21.1.4

commit 06b23cccb1166fcccc2f5fe7259b3ef9e1d0f32e
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jul 5 11:11:06 2022 +1000

    xkb: add request length validation for XkbSetGeometry
    
    No validation of the various fields on that report were done, so a
    malicious client could send a short request that claims it had N
    sections, or rows, or keys, and the server would process the request for
    N sections, running out of bounds of the actual request data.
    
    Fix this by adding size checks to ensure our data is valid.
    
    ZDI-CAN 16062, CVE-2022-2319.
    
    This vulnerability was discovered by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    (cherry picked from commit 6907b6ea2b4ce949cb07271f5b678d5966d9df42)

commit e3a530540f2f13739b0233ec51d7a3985a7ec4be
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jul 5 09:50:41 2022 +1000

    xkb: swap XkbSetDeviceInfo and XkbSetDeviceInfoCheck
    
    XKB often uses a FooCheck and Foo function pair, the former is supposed
    to check all values in the request and error out on BadLength,
    BadValue, etc. The latter is then called once we're confident the values
    are good (they may still fail on an individual device, but that's a
    different topic).
    
    In the case of XkbSetDeviceInfo, those functions were incorrectly
    named, with XkbSetDeviceInfo ending up as the checker function and
    XkbSetDeviceInfoCheck as the setter function. As a result, the setter
    function was called before the checker function, accessing request
    data and modifying device state before we ensured that the data is
    valid.
    
    In particular, the setter function relied on values being already
    byte-swapped. This in turn could lead to potential OOB memory access.
    
    Fix this by correctly naming the functions and moving the length checks
    over to the checker function. These were added in 87c64fc5b0 to the
    wrong function, probably due to the incorrect naming.
    
    Fixes ZDI-CAN 16070, CVE-2022-2320.
    
    This vulnerability was discovered by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Introduced in c06e27b2f6fd9f7b9f827623a48876a225264132
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    (cherry picked from commit dd8caf39e9e15d8f302e54045dd08d8ebf1025dc)

commit e75840565775dc95b848b366aeed44066a9d8a28
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Jul 5 12:40:47 2022 +1000

    xkb: switch to array index loops to moving pointers
    
    Most similar loops here use a pointer that advances with each loop
    iteration, let's do the same here for consistency.
    
    No functional changes.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Olivier Fourdan <ofourdan@redhat.com>
    (cherry picked from commit f1070c01d616c5f21f939d5ebc533738779451ac)

commit f3d9c6ff12b5a8a1a9f316b096d5573060747ff9
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Mon Jul 4 14:16:43 2022 -0700

    xquartz: Add missing files to distribution tarball
    
    Fixes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1346
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 147c17fc786c268ec51dc0f0655e69f6493f7ef2
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sat Jul 2 14:15:50 2022 -0700

    XQuartz: Improve type safety for X11Controller's application menu editor
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 4cfdc5af31ae8282903d0f65cff858330b9f9d1a)

commit 9e2fc7e2484be7c577ee5baf3765734beef9adc2
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sat Jul 2 14:17:18 2022 -0700

    xquartz: Fix a possible crash when editing the Application menu due to mutaing immutable arrays
    
    Crashing on exception: -[__NSCFArray replaceObjectAtIndex:withObject:]: mutating method sent to immutable object
    
    Application Specific Backtrace 0:
    0   CoreFoundation                      0x00007ff80d2c5e9b __exceptionPreprocess + 242
    1   libobjc.A.dylib                     0x00007ff80d027e48 objc_exception_throw + 48
    2   CoreFoundation                      0x00007ff80d38167b _CFThrowFormattedException + 194
    3   CoreFoundation                      0x00007ff80d382a25 -[__NSCFArray removeObjectAtIndex:].cold.1 + 0
    4   CoreFoundation                      0x00007ff80d2e6c0b -[__NSCFArray replaceObjectAtIndex:withObject:] + 119
    5   X11.bin                             0x00000001003180f9 -[X11Controller tableView:setObjectValue:forTableColumn:row:] + 169
    
    Fixes: https://github.com/XQuartz/XQuartz/issues/267
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit dfd057996b26420309c324ec844a5ba6dd07eda3)

commit 86ace20398a6c559e89213622538134b72e448b1
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Fri Jul 1 14:26:06 2022 -0700

    xquartz: Use correct defines when building to support Sparkle updates
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit aa636b97c66343b25e508b9c73d8505e8c11b1d9)

commit 855b96a85bc0711460a2542573a9a3959d1bfefa
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun Dec 19 16:51:39 2021 +0200

    xfree86: Fix event data alignment in inputtest driver
    
    This fixes address sanitizer errors when running unit tests. The
    additional copying may reduce performance by a small amount, but we
    don't care about that because this driver is used for testing only.
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>
    (cherry picked from commit 7d2014e7d523e10623203582b9f573303750f087)

commit 9d05ee10c231edacc69b342677ae8c3cc32f97e5
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun Jan 16 10:42:15 2022 +0200

    dix: Don't send touch end to clients that do async grab without touches
    
    GTK3 menu widget creates a selection for touch and other events and
    after receiving touch events creates an async grab that excludes touch
    events. Unfortunately it relies on X server not sending the touch end
    event in order to function properly. Sending touch end event will cause
    it to think that the initiating touch ended and when it actually ends,
    the ButtonRelease event will make it think that the menu should be
    closed. As a result, the menu will be open only for the duration of the
    touch making it useless.
    
    This commit reverts f682e0563f736ed2c2c612ed575e05b6e3db945e.
    
    Fixes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1255
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>
    (cherry picked from commit 43e934a19f644cddedae73602e86429c9dc5074a)

commit b713e717c34d539486f661c03a0f1b35b3208d21
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun Jan 23 22:18:52 2022 +0200

    dix: Correctly save replayed event into GrabInfoRec
    
    When processing events we operate on InternalEvent pointers. They may
    actually refer to a an instance of DeviceEvent, GestureEvent or any
    other event that comprises the InternalEvent union. This works well in
    practice because we always look into event type before doing anything,
    except in the case of copying the event.
    
    *dst_event = *src_event would copy whole InternalEvent event and would
    cause out of bounds read in case the pointed to event was not
    InternalEvent but e.g. DeviceEvent.
    
    This regression has been introduced in
    23a8b62d34344575f9df9d057fb74bfefa94a77b.
    
    Fixes https://gitlab.freedesktop.org/xorg/xserver/-/issues/1261
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>
    (cherry picked from commit 6ef5c05728f8b18170fbc8415d7502495a08670b)

commit cd3d21d8c44a35c22b7eca61a58bb5620b116102
Author: Samuel Thibault <samuel.thibault@ens-lyon.org>
Date:   Wed Jan 26 00:05:55 2022 +0100

    xkb: fix XkbSetMap when changing a keysym without changing a keytype
    
    As the comment says:
    
    "symsPerKey/mapWidths must be filled regardless of client-side flags"
    
    so we always have to call CheckKeyTypes which will notably fill mapWidths
    and nTypes. That is needed for CheckKeySyms to work since it checks the
    width. Without it, any request with XkbKeySymsMask but not
    XkbKeyTypesMask will fail because of the missing width information, for
    instance this:
    
      XkbDescPtr xkb;
      if (!(xkb = XkbGetMap (dpy, XkbKeyTypesMask|XkbKeySymsMask, XkbUseCoreKbd))) {
        fprintf (stderr, "ERROR getting map\n");
        exit(1);
      }
      XFlush (dpy);
      XSync (dpy, False);
    
      XkbMapChangesRec changes = { .changed = 0 };
      int oneGroupType[XkbNumKbdGroups] = { XkbOneLevelIndex };
    
      if (XkbChangeTypesOfKey(xkb, keycode, 1, XkbGroup1Mask, oneGroupType, &changes)) {
        fprintf(stderr, "ERROR changing type of key\n");
        exit(1);
      }
      XkbKeySymEntry(xkb,keycode,0,0) = keysym;
    
      if (!XkbChangeMap(dpy,xkb,&changes)) {
        fprintf(stderr, "ERROR changing map\n");
        exit(1);
      }
    
      XkbFreeKeyboard (xkb, 0, TRUE);
      XFlush (dpy);
      XSync (dpy, False);
    
    This had being going under the radar since about ever until commit
    de940e06f8733d87bbb857aef85d830053442cfe ("xkb: fix key type index check
    in _XkbSetMapChecks") fixed checking the values of kt_index, which was
    previously erroneously ignoring errors and ignoring all other checks, just
    because nTypes was not set, precisely because CheckKeyTypes was not called.
    
    Note: yes, CheckKeyTypes is meant to be callable without XkbKeyTypesMask, it
    does properly check for that and just fills nTypes and mapWidths in that
    case.
    
    Signed-off-by: Samuel Thibault <samuel.thibault@ens-lyon.org>
    (cherry picked from commit 0217cc6e0cf5013366105a90f5f91ccc4bab5425)

commit f575524314e9f20a1ff639f6bd65386cdbd083f4
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Thu Feb 3 20:04:52 2022 +0200

    Revert "os: Try to discover the current seat with the XDG_SEAT var first"
    
    This reverts commit b27eaa72837eebe80adfe6c257a71a6b9eaf66ee.

commit 419fbf639d8f53d39449c157a9554bd5482ed64f
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sun Jun 26 10:31:54 2022 -0700

    XQuartz: Add TCC reason keys to Info.plist
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 9ce7264889e36fddbdf6bac332225ad6f628ad5d)

commit 66ac50090dd191f1b16daf338ca3b46d9147fbbd
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sun Jun 26 02:40:20 2022 -0700

    XQuartz: Build the bundle trampoline when using meson
    
    This brings the change for e1fdc856aedfcb4788011415930a0c6861df5123 into meson based builds
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit b00cf4aef881e00533f995c141c3586749cd7ca1)

commit 033d93a021e86dd5ce9b2b3a1554a72c7031a7f2
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Mon Jun 20 17:08:53 2022 -0700

    meson: Support building Xnest and Xorg on darwin
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit ef8101560eefd6160df6d4b57ddb65ea2328c441)

commit 433f53a1a08390a038176b7c1207512cf1dd3f44
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Mon Jun 20 20:19:06 2022 -0700

    tests: Fix build failure from missing micmap.c
    
    FAILED: test/tests
    clang  -o test/tests test/tests.p/.._mi_miinitext.c.o test/tests.p/fixes.c.o test/tests.p/input.c.o test/tests.p/list.c.o test/tests.p/misc.c.o test/tests.p/signal-logging.c.o test/tests.p/string.c.o test/tests.p/test_xkb.c.o test/tests.p/tests-common.c.o test/tests.p/tests.c.o test/tests.p/touch.c.o test/tests.p/xfree86.c.o test/tests.p/xtest.c.o test/tests.p/hashtabletest.c.o -Wl,-dead_strip_dylibs -Wl,-headerpad_max_install_names -Wl,-undefined,error -fvisibility=hidden -O0 -g3 -gdwarf-2 -mmacosx-version-min=10.9 -Werror=unguarded-availability-new -Werror=format -Werror=objc-method-access -Werror=incompatible-pointer-types -F/Applications/Utilities/XQuartz.app/Contents/Frameworks -isysroot /Library/Developer/CommandLineTools/SDKs/MacOSX10.13.sdk -arch x86_64 -O0 -g3 -gdwarf-2 -mmacosx-version-min=10.9 -Werror=unguarded-availability-new -Werror=format -Werror=objc-method-access -Werror=incompatible-pointer-types -F/Applications/Utilities/XQuartz.app/Contents/Frameworks -isysroot /Library/Developer/CommandLineTools/SDKs/MacOSX10.13.sdk -arch x86_64 -Wl,-rpath,/opt/X11/lib mi/liblibxserver_mi.a dix/liblibxserver_dix.a composite/liblibxserver_composite.a damageext/liblibxserver_damageext.a dbe/liblibxserver_dbe.a randr/liblibxserver_randr.a miext/damage/liblibxserver_miext_damage.a render/liblibxserver_render.a present/liblibxserver_present.a Xext/liblibxserver_xext.a miext/sync/liblibxserver_miext_sync.a xfixes/liblibxserver_xfixes.a Xi/liblibxserver_xi.a xkb/liblibxserver_xkb.a record/liblibxserver_record.a os/liblibxserver_os.a os/liblibxlibc.a glx/liblibglxvnd.a hw/xfree86/common/libxorg_common.a hw/xfree86/loader/libxorg_loader.a hw/xfree86/ddc/libxorg_ddc.a hw/xfree86/xkb/libxorg_xkb.a hw/xfree86/i2c/libxorg_i2c.a hw/xfree86/modes/libxorg_modes.a hw/xfree86/os-support/libxorg_os_support.a hw/xfree86/parser/libxorg_parser.a hw/xfree86/ramdac/libxorg_ramdac.a fb/liblibxserver_fb.a Xext/liblibxserver_xext_vidmode.a dix/liblibxserver_main.a config/liblibxserver_config.a /opt/X11/lib/libpixman-1.dylib /opt/X11/lib/libxcvt.dylib /opt/X11/lib/libxkbfile.dylib /opt/X11/lib/libXfont2.dylib /opt/X11/lib/libXdmcp.dylib -lm /opt/X11/lib/libxshmfence.dylib -ldl -lpthread /opt/X11/lib/libXau.dylib /opt/X11/lib/libGL.dylib
    Undefined symbols for architecture x86_64:
      "_micmapScrPrivateKeyRec", referenced from:
          _DGAInstallCmap in libxorg_common.a(xf86DGA.c.o)
          _xf86HandleColormaps in libxorg_common.a(xf86cmap.c.o)
          _CMapInstallColormap in libxorg_common.a(xf86cmap.c.o)
          _CMapEnterVT in libxorg_common.a(xf86cmap.c.o)
          _CMapSwitchMode in libxorg_common.a(xf86cmap.c.o)
          _CMapSetDGAMode in libxorg_common.a(xf86cmap.c.o)
          _CMapChangeGamma in libxorg_common.a(xf86cmap.c.o)
          ...
    ld: symbol(s) not found for architecture x86_64
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 6645ff59069d603806d749e8af73893cf88d2c06)

commit 3868f364728ae0cc35621bbfdd36bfa2e3f09fda
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Mon Jun 20 20:05:46 2022 -0700

    xf86-input-inputtest: Fix build on systems without SOCK_NONBLOCK
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 707f23dab8787b4154011186206dc9964e2ebc11)

commit afcaaac96767d773422512e755e5ad3691a0627c
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Mon Jun 20 19:51:39 2022 -0700

    print_edid: Fix a format string error
    
    ../hw/xfree86/ddc/print_edid.c:511:20: error: format specifies type 'unsigned short' but the argument has type 'int' [-Werror,-Wformat]
                       det_mon->type - DS_VENDOR);
                       ^~~~~~~~~~~~~~~~~~~~~~~~~
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 199b8c0853c92ce19a589186f326621477401b74)

commit 6bb98fc62ddf8b0dd90f7b0b45978a0d0425ed5a
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Tue Jun 21 11:46:14 2022 -0700

    xquartz: Update autotools-based builds of XQuartz to account for recent changes
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 4ea6f661edbbd84b3f2b308675bd2aa848b53746
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Mon Jun 20 20:32:26 2022 -0700

    Revert "meson: Bump requirement to meson-0.50.0"
    
    This bump is causing issues with our CI.  Sorry about that.
    
    This reverts commit a6a20a7c40f86b5586286aaa614e6b64a5987d82
    
    (cherry picked from commit 8cd0397e5b4c1f0e0add1fea67f82b811214bf3e)

commit a6a20a7c40f86b5586286aaa614e6b64a5987d82
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sun Jun 19 23:06:40 2022 -0700

    meson: Provide options to set CFBundleVersion and CFBundleVersionString in XQuartz
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 4f5999826aa478ba5f138e74cfccdf3b854c8e54)

commit 37285e6252ce3afca5bc205121f83271548dfca9
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sun Jun 19 19:56:26 2022 -0700

    xquartz: Update copyright for 2022
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit b12f5dc62d964d0279e1fa9403259cfd8e491285)

commit 96e7b55c5d6898a6715b62d5e01581617d218997
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sun Jun 19 19:55:44 2022 -0700

    xquartz: Update Sparkle configuration to use SUPublicEDKey
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 1d90bef30c4dfe13dd5e70fea606a02380cbcee6)

commit 6465263be8ae98283f8e99a3e95d04e786386040
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sun Jun 19 22:18:16 2022 -0700

    meson: Bump requirement to meson-0.50.0
    
    WARNING: Project specifies a minimum meson_version '>= 0.47.0' but uses features which were added in newer versions:
     * 0.50.0: {'install arg in configure_file'}
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 0a27f96d1d0e474b308be982fa7069d3ae0d9892)

commit e48acd9c40c09b7c66a7bfc6650afc216ba78cca
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Jun 16 00:10:26 2022 -0700

    XQuartz: Ensure scroll events are delivered to a single window (not both X11 and AppKit)
    
    Fixes: https://github.com/XQuartz/XQuartz/issues/130
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 4532b696c644cb7f21e96cf76d3e6b21ccc0e309)

commit 140d9a0f75194d4079d5cd1e4ad4683c6f47683e
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sat Feb 20 14:21:01 2021 -0800

    xquartz: Fold spaces related preferences into NSUserDefaults+XQuartzDefaults
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit f40610e0b4f2b4ae54ef6bbff756cb4a60e17e3b)

commit 03ec5b132f0b3e07f9340faaacaa2455717fd8d1
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sat Feb 20 14:00:14 2021 -0800

    xquartz pbproxy: Adopt NSUserDefaults+XQuartzDefaults for preferences
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 6134c73aebc3f928639e8f802be49ec8ecc17e66)

commit 6df6178bb917f596ec2f61a3aabf99eea620b6ec
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Fri Feb 19 22:49:11 2021 -0800

    xquartz: Create a separate category for organizing user preferences
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit 963ba6d9adf578ec8d7ed12ae22dece76b895172)

commit c6c1cba397ffa203123a8a6690dee728089e7325
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sat Sep 10 22:32:56 2016 -0700

    os/connection: Improve abstraction for launchd secure sockets
    
    This changes away from hard-coding the /tmp/launch-* path to now
    supporting a generic <absolute path to unix socket>[.<screen>]
    format for $DISPLAY.
    
    cf-libxcb: d978a4f69b30b630f28d07f1003cf290284d24d8
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    CC: Adam Jackson <ajax@kemper.freedesktop.org>
    (cherry picked from commit 83d0d911069d502232d719882cd1c5cd090defa1)

commit 663af2f17eec2cc064f3d1e25e00fb840c441964
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sun Jun 12 22:06:01 2022 -0700

    X11Application: Ensure TIS operations are done on the main thread
    
    Fixes: https://github.com/XQuartz/XQuartz/issues/205
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit b1afcecc61d841f95e786e4f4f84184f91d149f1)

commit bd3564cf377deace41b359740331d84e3086e916
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Fri Apr 23 02:15:30 2021 -0700

    rootless: Dead code removal (ROOTLESS_REDISPLAY_DELAY is already defined)
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
    (cherry picked from commit c11b55f3c0c64645bca964aece825de0bdd92b1f)

commit 53173fdab492f0f638f6616fcf01af0b9ea6338d
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu Jan 20 10:20:38 2022 +0100

    render: Fix build with gcc 12
    
    The xserver fails to compile with the latest gcc 12:
    
     render/picture.c: In function ‘CreateSolidPicture’:
     render/picture.c:874:26: error: array subscript ‘union _SourcePict[0]’ is partly outside array bounds of ‘unsigned char[16]’ [-Werror=array-bounds]
      874 |     pPicture->pSourcePict->type = SourcePictTypeSolidFill;
          |                          ^~
     render/picture.c:868:45: note: object of size 16 allocated by ‘malloc’
      868 |     pPicture->pSourcePict = (SourcePictPtr) malloc(sizeof(PictSolidFill));
          |                                             ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     render/picture.c: In function ‘CreateLinearGradientPicture’:
     render/picture.c:906:26: error: array subscript ‘union _SourcePict[0]’ is partly outside array bounds of ‘unsigned char[32]’ [-Werror=array-bounds]
      906 |     pPicture->pSourcePict->linear.type = SourcePictTypeLinear;
          |                          ^~
     render/picture.c:899:45: note: object of size 32 allocated by ‘malloc’
      899 |     pPicture->pSourcePict = (SourcePictPtr) malloc(sizeof(PictLinearGradient));
          |                                             ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     render/picture.c: In function ‘CreateConicalGradientPicture’:
     render/picture.c:989:26: error: array subscript ‘union _SourcePict[0]’ is partly outside array bounds of ‘unsigned char[32]’ [-Werror=array-bounds]
      989 |     pPicture->pSourcePict->conical.type = SourcePictTypeConical;
          |                          ^~
     render/picture.c:982:45: note: object of size 32 allocated by ‘malloc’
      982 |     pPicture->pSourcePict = (SourcePictPtr) malloc(sizeof(PictConicalGradient));
          |                                             ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     cc1: some warnings being treated as errors
     ninja: build stopped: subcommand failed.
    
    This is because gcc 12 has become stricter and raises a warning now.
    
    Fix the warning/error by allocating enough memory to store the union
    struct.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Acked-by: Michel Dänzer <mdaenzer@redhat.com>
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1256
    (cherry picked from commit c6b0dcb82d4db07a2f32c09a8c09c85a5f57248e)

commit 69774044716039fa70655b3bc6dd6a4ff4535cfd
Author: Błażej Szczygieł <spaz16@wp.pl>
Date:   Thu Jan 13 00:47:27 2022 +0100

    present: Check for NULL to prevent crash
    
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1275
    Signed-off-by: Błażej Szczygieł <spaz16@wp.pl>
    Tested-by: Aaron Plattner <aplattner@nvidia.com>
    (cherry picked from commit 22d5818851967408bb7c903cb345b7ca8766094c)

commit 85397cc2efe8fa73461cd21afe700829b2eca768
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Mon Jan 3 00:23:30 2022 +0200

    xserver 21.1.3
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 001feb6692b77254db6a4906a82fa1bdadfd7b85
Author: Adam Jackson <ajax@redhat.com>
Date:   Tue Oct 26 11:46:37 2021 -0400

    glx/dri: Filter out fbconfigs that don't have a supported pixmap format
    
    For depth 30 in particular it's not uncommon for the DDX to not have
    a configured pixmap format. Since the client expects to back both
    GLXPixmaps and GLXPbuffers with X Pixmaps, trying to use an x2rgb10
    fbconfig would fail along various paths to CreatePixmap. Filter these
    fbconfigs out so the client can't ask for something that we know won't
    work.
    
    (cherry picked from commit f6c070a1ac05801c52ae60efb7dc4b3142653b7d)

commit 66890ca569291a53ea9cdc6ec19070173e522260
Author: Jocelyn Falempe <jfalempe@redhat.com>
Date:   Fri Dec 17 10:18:25 2021 +0100

    xf86/logind: fix missing call to vtenter if the platform device is not paused
    
    If there is one platform device, which is not paused nor resumed,
    systemd_logind_vtenter() will never get called.
    This break suspend/resume, and switching to VT on system with Nvidia
    proprietary driver.
    This is a regression introduced by f5bd039633fa83
    
    So now call systemd_logind_vtenter() if there are no paused
    platform devices.
    
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1271
    Fixes: f5bd0396 - xf86/logind: fix call systemd_logind_vtenter after receiving drm device resume
    
    Signed-off-by: Jocelyn Falempe <jfalempe@redhat.com>
    Tested-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Hans de Goede <hdegoede@redhat.com>

commit fec0e2501b424ec6cfbf4c7983727acfafea0ccb
Author: Jocelyn Falempe <jfalempe@redhat.com>
Date:   Thu Dec 16 15:46:43 2021 +0100

    xf86/logind: Fix compilation error when built without logind/platform bus
    
    This was introduced by commit 8eb1396d
    
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1269
    Fixes: da9d012a9 - xf86/logind: Fix drm_drop_master before vt_reldisp
    
    Signed-off-by: Jocelyn Falempe <jfalempe@redhat.com>
    Reviewed-by: Hans de Goede <hdegoede@redhat.com>

commit 8223a9d6d9ed2b9a4c1e6373f6ab854fdbda9ead
Author: Matthieu Herrb <matthieu@herrb.eu>
Date:   Tue Nov 16 23:38:46 2021 +0100

    Convert more funcs to use InternalEvent.
    
    This fixes a crash when a DeviceEvent struct converted to
    InteralEvent was beeing copied as InternalEvent (and thus
    causing out of bounds reads) in ActivateGrabNoDelivery()
    in events.c: 3876    *grabinfo->sync.event = *real_event;
    
    Possible fix for https://gitlab.freedesktop.org/xorg/xserver/-/issues/1253
    
    Signed-off-by: Matthieu Herrb <matthieu@herrb.eu>
    (cherry picked from commit 5b8817a019845e1066c373022133985a0e2d718f)

commit b27eaa72837eebe80adfe6c257a71a6b9eaf66ee
Author: nerdopolis <bluescreen_avenger@verizon.net>
Date:   Fri Oct 8 18:15:29 2021 -0400

    os: Try to discover the current seat with the XDG_SEAT var first
    
    (cherry picked from commit ca1dfdc9aa4b548de624d3a9af5147a998ba3d79)

commit 9852b29380673484aea25771a3e812c8e8a40393
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Wed Dec 15 15:46:09 2021 +0200

    xserver 21.1.2
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 9fe2991075aca3321d59d03f3e45faca6cb718b8
Author: Sam James <sam@gentoo.org>
Date:   Wed Dec 15 10:41:22 2021 +0200

    hw/xfree86: fix sbus build for SPARC
    
    Initially reported downstream in Gentoo. Manifests with errors like:
    ```
    gnu/bin/ld: hw/xfree86/common/libxorg_common.a(xf86fbBus.c.o): in function `xf86ClaimFbSlot':
    xf86fbBus.c:(.text+0x20): undefined reference to `sbusSlotClaimed'
    /usr/lib/gcc/sparc-unknown-linux-gnu/11.2.0/../../../../sparc-unknown-linux-gnu/bin/ld: xf86fbBus.c:(.text+0x2c): undefined reference to `sbusSlotClaimed'
    ```
    
    While we use the headers in meson.build, we don't reference xf86sbusBus.c
    which defines the missing symbols like sbusSlotClaimed.
    
    Bug: https://bugs.gentoo.org/828513
    Signed-off-by: Sam James <sam@gentoo.org>
    (cherry picked from commit 6c1a1fcc4bff90546ebc954f428c6df97005ea50)

commit 0b67785cd13e65d37416f75ab938bdc49cf4732f
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Wed Dec 15 10:41:21 2021 +0200

    render: Fix out of bounds access in SProcRenderCompositeGlyphs()
    
    ZDI-CAN-14192, CVE-2021-4008
    
    This vulnerability was discovered and the fix was suggested by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>
    (cherry picked from commit ebce7e2d80e7c80e1dda60f2f0bc886f1106ba60)

commit 7209982d2a89f2e27d2f83f8952e9512be813aa4
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Wed Dec 15 10:41:20 2021 +0200

    Xext: Fix out of bounds access in SProcScreenSaverSuspend()
    
    ZDI-CAN-14951, CVE-2021-4010
    
    This vulnerability was discovered and the fix was suggested by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>
    (cherry picked from commit 6c4c53010772e3cb4cb8acd54950c8eec9c00d21)

commit 6f09e7d3913a8188e32062f5e196bebb06bab140
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Wed Dec 15 10:41:19 2021 +0200

    xfixes: Fix out of bounds access in *ProcXFixesCreatePointerBarrier()
    
    ZDI-CAN-14950, CVE-2021-4009
    
    This vulnerability was discovered and the fix was suggested by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>
    (cherry picked from commit b5196750099ae6ae582e1f46bd0a6dad29550e02)

commit a82d523edb30e5856adca9f258ac716108c71f19
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Wed Dec 15 10:41:18 2021 +0200

    record: Fix out of bounds access in SwapCreateRegister()
    
    ZDI-CAN-14952, CVE-2021-4011
    
    This vulnerability was discovered and the fix was suggested by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>
    (cherry picked from commit e56f61c79fc3cee26d83cda0f84ae56d5979f768)

commit a39218d99c6961dda0142d9956eb7404a37d9bd2
Author: Matthieu Herrb <matthieu@herrb.eu>
Date:   Wed Dec 15 10:41:17 2021 +0200

    remove the PRE_RELEASE message.
    
    With the new numbering scheme, XORG_VERISON_SNAP doesn't mean
    a pre-release version anymore.
    
    Signed-off-by: Matthieu Herrb <matthieu@herrb.eu>
    (cherry picked from commit 4de9666b6d3c86660d728ddfc13d88700e5ff20d)

commit fc2eb7e8cc19a41e034f2f4286af58f8b4825d65
Author: Matt Turner <mattst88@gmail.com>
Date:   Tue Dec 7 21:39:58 2021 -0800

    test: #undef NDEBUG so assert is not compiled away
    
    (cherry picked from commit d189102c783653a10931051175de24277a157331)

commit 7caf29ca6607ddf4c19a81d19c0f4acc6deb8936
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sat Nov 13 16:42:36 2021 +0200

    meson: Correctly set DDXOSVERRORF and DDXBEFORERESET on xwin
    
    This worked with autotools, but not meson build system.
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>
    (cherry picked from commit 04c93b98e9e4593aa2e6701bb08f5e27c3544d8a)

commit 101791f80fdefea738421a414177899db7c76e83
Author: Jonathan Gray <jsg@jsg.id.au>
Date:   Fri Dec 3 19:17:18 2021 +1100

    glamor: fix free of uninitialised pointers
    
    Attempting to run fvwm on a x61/965gm with xserver 1.21.1 with the
    modesetting driver on OpenBSD/amd64 would cause the xserver to
    reliably crash.
    
    I tracked this down to the free() calls introduced in
    2906ee5e4a722138cccb3265a615da7705a52589
    (d1ca47e1242b51c79cec7287f52c36c8e494706b in branch).
    
    clang also warns about this:
    glamor_program.c:296:13: warning: variable 'vs_prog_string' is used uninitialized whenever 'if' condition is true [-Wsometimes-uninitialized]
    glamor_program.c:290:9: warning: variable 'vs_prog_string' is used uninitialized whenever 'if' condition is true [-Wsometimes-uninitialized]
    glamor_program.c:288:9: warning: variable 'vs_prog_string' is used uninitialized whenever 'if' condition is true [-Wsometimes-uninitialized]
    glamor_program.c:277:13: warning: variable 'vs_prog_string' is used uninitialized whenever 'if' condition is true [-Wsometimes-uninitialized]
    glamor_program.c:296:13: warning: variable 'fs_prog_string' is used uninitialized whenever 'if' condition is true [-Wsometimes-uninitialized]
    glamor_program.c:290:9: warning: variable 'fs_prog_string' is used uninitialized whenever 'if' condition is true [-Wsometimes-uninitialized]
    glamor_program.c:288:9: warning: variable 'fs_prog_string' is used uninitialized whenever 'if' condition is true [-Wsometimes-uninitialized]
    glamor_program.c:277:13: warning: variable 'fs_prog_string' is used uninitialized whenever 'if' condition is true [-Wsometimes-uninitialized]
    
    Signed-off-by: Jonathan Gray <jsg@jsg.id.au>
    Reviewed-by: Olivier Fourdan <ofourdan@redhat.com>
    Fixes: 2906ee5e4 ("glamor: Fix leak in glamor_build_program()")
    (cherry picked from commit 5ac6319776b13f96a2b336da4b35237618a5b001)

commit 2c6989f81e62bac05a583c39fa09a06172d1ece5
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Dec 2 10:41:03 2021 +1000

    xkb: fix XkbSetMap check for the keytypes count
    
    The previous if/else condition resulted in us always setting the key
    type count to the current number of key types. Split this up correctly.
    
    Regression introduced in de940e06f8733d87bbb857aef85d830053442cfe
    
    Fixes #1249
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    (cherry picked from commit be16bd8543f80ad2933ec9c37f082617c7084165)

commit 49444ce9f7ad34fff6ff94a9db95337f4bfd7b03
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sat Nov 13 17:23:54 2021 +0200

    Revert "hw/xfree86: Propagate physical dimensions from DRM connector"
    
    Quite a lot of applications currently expect the screen DPI exposed by
    the X server to be 96 even when the real display DPI is different.
    Additionally, currently Xwayland completely ignores any hardware
    information and sets the DPI to 96. Accordingly the new behavior, even
    if it fixes a bug, should not be enabled automatically to all users.
    
    A better solution would be to make the default DPI stay as is and enable
    the correct behavior with a command line option (maybe -dpi auto, or
    similar). For now let's just revert the bug fix.
    
    This reverts commit 05b3c681ea2f478c0cb941c2f8279919cf78de6d.
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>
    (cherry picked from commit 35af1299e73483eaf93d913a960e1d1738bc7de6)

commit 6f11b3c803898e0effe6ade2ae951f5758936152
Author: Dave Airlie <airlied@redhat.com>
Date:   Thu Nov 11 06:35:19 2021 +1000

    dri2: add crocus to the list of va_gl users
    
    (cherry picked from commit a7b0a7fabd137183cc42a5edb15697e354c4450c)

commit 8eb1396d3ecfd2bf968105a99759ae9445bdf768
Author: Jocelyn Falempe <jfalempe@redhat.com>
Date:   Thu Nov 18 14:51:21 2021 +0100

    xf86/logind: Fix drm_drop_master before vt_reldisp
    
    When switching to VT, the ioctl DRM_DROP_MASTER must be done before
    the ioctl VT_RELDISP. Otherwise the kernel can't change the modesetting
    reliably, and this leads to the console not showing up in some cases, like
    after unplugging a docking station with a DP or HDMI monitor.
    
    Before doing the VT_RELDISP, send a dbus message to logind, to
    pause the drm device, so logind will do the ioctl DRM_DROP_MASTER.
    
    With this patch, it changes the order logind will send the resume
    event, and drm will be sent last instead of first.
    so there is a also fix to call systemd_logind_vtenter() at the right time.
    
    Signed-off-by: Jocelyn Falempe <jfalempe@redhat.com>
    Reviewed-by: Hans de Goede <hdegoede@redhat.com>
    (cherry picked from commit da9d012a9c760896941769d4127e3cfb1a7a9f03)

commit 6834f977a5eadbc3289f27b2bb83997132a39fdd
Author: Jocelyn Falempe <jfalempe@redhat.com>
Date:   Thu Nov 18 14:45:42 2021 +0100

    xf86/logind: fix call systemd_logind_vtenter after receiving drm device resume
    
    logind send the resume event for input devices and drm device,
    in any order. if we call vt_enter before logind resume the drm device,
    it leads to a driver error, because logind has not done the
    DRM_IOCTL_SET_MASTER on it.
    
    Keep the old workaround to make sure we call systemd_logind_vtenter at
    least once if there are no platform device
    
    Signed-off-by: Jocelyn Falempe <jfalempe@redhat.com>
    Reviewed-by: Hans de Goede <hdegoede@redhat.com>
    (cherry picked from commit f5bd039633fa8360a10bd2aabb0111571f6275b0)

commit 0ed7b1224ef17ff3d27e791e03e0d98dd6373c8a
Author: nerdopolis <bluescreen_avenger@verizon.net>
Date:   Fri Oct 8 21:51:43 2021 -0400

    xfree86: On Linux, while only seat0 can have TTYs, don't assmume all seat0s have TTYs
    
    (cherry picked from commit b8c12aac651d626c5120e6e8e18b42e7528caf43)

commit 6b997fb74e5c9473ee3989fca8d592a3a0d16067
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun Nov 7 01:33:56 2021 +0200

    xserver 21.1.1
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 70a0c48ff3bb7e3392035ef333cc5c8453508f33
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sat Nov 6 20:09:48 2021 +0200

    Makefile.am: Add missing meson build files to release tarball

commit db0da823f55734baf4c1e4de680e7091f33aac17
Author: Matthieu Herrb <matthieu.herrb@laas.fr>
Date:   Sun Oct 31 11:28:28 2021 +0100

    Make xf86CompatOutput() return NULL when there are no privates
    
    Some drivers (mach64 w/o DRI for instance) don't initialize privates.
    
    Signed-off-by: Matthieu Herrb <matthieu.herrb@laas.fr>
    (cherry picked from commit 80eeff3ebac772e25c9107199989e677457dbe06)

commit fdb266ff814f6abb6ce006ecbac5ba78a92cdbca
Author: Jon Turney <jon.turney@dronecode.org.uk>
Date:   Tue Nov 2 14:04:08 2021 +0000

    s/__/@/ in inputtestdrv manpage
    
    Update manpage subsitution style for 2e497bf8
    
    (cherry picked from commit 0099412ea4347b02e61ea21946f309f2535cc07b)

commit 27a0ee32ccef8d621aaa758c804fc9a5ceeb5a56
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Wed Oct 27 13:36:45 2021 +0300

    xserver 21.1
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit d4944ceda1727180bbee1c582b4ac0796c2748cc
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Mon Oct 18 08:14:04 2021 +0200

    Fix RandR leasing for more than 1 simultaneously active lease.
    
    Due to a switched order of parameters in the xorg_list_add()
    call inside ProcRRCreateLease(), adding a new lease for RandR
    output leasing does not actually add the new RRLeasePtr lease
    record to the list of existing leases for a X-Screen, but instead
    replaces the existing list with a new list that has the new lease
    as the only element, and probably leaks a bit of memory.
    
    Therefore the server "forgets" all active leases for a screen,
    except for the last added lease. If multiple leases are created
    in a session, then destruction of all leases but the last one
    will fail in many cases, e.g., during server shutdown in
    RRCloseScreen(), or resource destruction, e.g., in
    RRCrtcDestroyResource().
    
    Most importantly, it fails if a client simply close(fd)'es the
    DRM master descriptor to release a lease, quits, gets killed or
    crashes. In this case the kernel will destroy the lease and shut
    down the display output, then send a lease event via udev to the
    ddx, which e.g., in the modesetting-ddx will trigger a call to
    drmmode_validate_leases().
    
    That function is supposed to detect the released lease and tell
    the server to terminate the lease on the server side as well,
    via xf86CrtcLeaseTerminated(), but this doesn't happen for all
    the leases the server has forgotten. The end result is a dead
    video output, as the server won't reinitialize the crtc's
    corresponding to the terminated but forgotten lease.
    
    This bug was observed when using the amdvlk AMD OSS Vulkan
    driver and trying to lease multiple VKDisplay's, and also
    under Mesa radv, as both Mesa Vulkan/WSI/Display and amdvlk
    terminate leases by simply close()ing the lease fd, not by
    sending explicit RandR protocol requests to free leases.
    
    Leasing worked, but ending a session with multiple active
    leases ended in a lot of unpleasant darkness.
    
    Fixing the wrong argument order to xorg_list_add() fixes the
    problem. Tested on single-X-Screen and dual-X-Screen setups,
    with one, two or three active leases.
    
    Please merge this for the upcoming server 21.1 branch.
    Merging into server 1.20 would also make a lot of sense.
    
    Fixes: e4e3447603b5fd3a38a92c3f972396d1f81168ad
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>
    Cc: Keith Packard <keithp@keithp.com>
    (cherry picked from commit f467f85ca1f780d5c7cf3c20888e399708d761ac)

commit e59faa4b8cc5aaa19474a5e7ca3a99d08006f8c5
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Thu Oct 14 17:33:40 2021 +0300

    xserver 21.1 RC 2

commit 3fb94f3c5ca73f15a78dbc6904380b9b9e402bf4
Author: Alex Richardson <Alexander.Richardson@cl.cam.ac.uk>
Date:   Fri Jul 23 09:23:45 2021 +0100

    dix/privates.c: Avoid undefined behaviour after realloc()
    
    Adding the offset between the realloc result and the old allocation to
    update pointers into the new allocation is undefined behaviour: the
    old pointers are no longer valid after realloc() according to the C
    standard. While this works on almost all architectures and compilers,
    it causes  problems on architectures that track pointer bounds (e.g.
    CHERI or Arm's Morello): the DevPrivateKey pointers will still have the
    bounds of the previous allocation and therefore any dereference will
    result in a run-time trap.
    
    I found this due to a crash (dereferencing an invalid capability) while
    trying to run `XVnc` on a CHERI-RISC-V system. With this commit I can
    successfully connect to the XVnc instance running inside a QEMU with a
    VNC viewer on my host.
    
    This also changes the check whether the allocation was moved to use
    uintptr_t instead of a pointer since according to the C standard:
    "The value of a pointer becomes indeterminate when the object it
    points to (or just past) reaches the end of its lifetime." Casting to an
    integer type avoids this undefined behaviour.
    
    Signed-off-by: Alex Richardson <Alexander.Richardson@cl.cam.ac.uk>
    (cherry picked from commit f9f705bf3cf0d169d54a70f235cc99e106dbda43)

commit b89fdd523e2c9e9b0cdf37b263833c4b0a8868b8
Author: nerdopolis <rbos@rbos>
Date:   Thu Sep 30 08:51:18 2021 -0400

    xf86: Accept devices with the 'simpledrm' driver.
    
    SimpleDRM 'devices' are a fallback device, and do not have a busid
    so they are getting skipped. This will allow simpledrm to work
    with the modesetting driver
    
    (cherry picked from commit b9218fadf3c09d83566549279d68886d8258f79c)

commit fbc690ccaf12d6536951d0ba403dfbb92c7c4115
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Fri Oct 1 09:47:41 2021 +0200

    modesetting: Consider RandR primary output for selectioh of sync crtc.
    
    The "sync crtc" is the crtc used to drive the display timing of a
    drawable under DRI2 and DRI3/Present. If a drawable intersects
    multiple video outputs, then normally the crtc is chosen which has
    the largest intersection area with the drawable.
    
    If multiple outputs / crtc's have exacty the same intersection
    area then the crtc chosen was simply the first one with maximum
    intersection. Iow. the choice was random, depending on plugging
    order of displays.
    
    This adds the ability to choose a preferred output in such a tie
    situation. The RandR output marked as "primary output" is chosen
    on such a tie.
    
    This new behaviour and its implementation is consistent with other
    video ddx drivers. See amdgpu-ddx, ati-ddx and nouveau-ddx for
    reference. This commit is a straightforward port from amdgpu-ddx.
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>
    (cherry picked from commit 4b75e65766a9ef3a26d4c1c9d7af9fc6d1d7be5b)

commit 22f4ff1026eeffc566f87453d7f1f70dc23ad4e0
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Fri Oct 1 08:49:10 2021 +0200

    modesetting: Handle mixed VRR and non-VRR display setups better.
    
    In a setup with both VRR capable and non-VRR capable displays,
    it was so far inconsistent if the driver would allow use of
    VRR support or not, as "is_connector_vrr_capable" was set to
    whatever the capabilities of the last added drm output were.
    Iow. the plugging order of monitors determined the outcome.
    
    Fix this: Now if at least one display is VRR capable, the driver
    will treat an X-Screen as capable for VRR, plugging order no
    longer matters.
    
    Tested with a dual-display setup with one VRR monitor and one
    non-VRR monitor. This is also beneficial with the new Option
    "AsyncFlipSecondaries".
    
    When we are at it, also add some so far missing description of
    the "VariableRefresh" driver option, copied from amdgpu-ddx.
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>
    (cherry picked from commit 017ce263376aa64a495c4d71a140a24b1dff7054)

commit 0d0986bf3b924ccb26e4bc6a8c06aed41f238683
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Fri Oct 1 07:42:01 2021 +0200

    modesetting: Enable GAMMA_LUT for lut's with up to 4096 slots.
    
    A lut size of 4096 slots has been verified to work correctly,
    as tested with amdgpu-kms. Intel Tigerlake Gen12 hw has a very
    large GAMMA_LUT size of 262145 slots, but also issues with its
    current GAMMA_LUT implementation, as of Linux 5.14.
    
    Therefore we keep GAMMA_LUT off for large lut's. This currently
    excludes Intel Icelake, Tigerlake and later.
    
    This can be overriden via the "UseGammaLUT" boolean xorg.conf option
    to force use of GAMMA_LUT on or off.
    
    See following link for the Tigerlake situation:
    https://gitlab.freedesktop.org/drm/intel/-/issues/3916#note_1085315
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>
    (cherry picked from commit 66e5a5bb12c58413a4d71781c5a7f63f675bfe55)

commit bc1327e6de82da560c97f66c9c196d9bbd2d24be
Author: Ray Strode <rstrode@redhat.com>
Date:   Mon Oct 4 14:27:54 2021 -0400

    xkb: Drop check for XkbSetMapResizeTypes
    
    Commit 446ff2d3177087b8173fa779fa5b77a2a128988b added checks to
    prevalidate the size of incoming SetMap requests.
    
    That commit checks for the XkbSetMapResizeTypes flag to be set before
    allowing key types data to be processed.
    
    key types data can be changed or even just sent wholesale unchanged
    without the number of key types changing, however. The check for
    XkbSetMapResizeTypes rejects those legitimate requests. In particular,
    XkbChangeMap never sets XkbSetMapResizeTypes and so always fails now
    any time XkbKeyTypesMask is in the changed mask.
    
    This commit drops the check for XkbSetMapResizeTypes in flags when
    prevalidating the request length.
    
    (cherry picked from commit 8b7f4d3259e8b7d1eb3d8a83e8852989e869596a)

commit b87536682c185b6a825525d01e95e264018c0997
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Tue Sep 14 07:52:33 2021 +0200

    Revert "modesetting: Only use GAMMA_LUT if its size is 1024"
    
    This reverts commit 617f591fc44e24413e1f91017d16734999bbbac1.
    
    The problem described in that commit exists, but the two
    preceeding commits with improvements to the servers RandR
    code should avoid the mentioned problems while allowing the
    use of GAMMA_LUT's instead of legacy gamma lut.
    
    Use of legacy gamma lut's is not a good fix, because it will reduce
    color output precision of gpu's with more than 1024 GAMMA_LUT
    slots, e.g., AMD, ARM MALI and KOMEDA with 4096 slot luts,
    and some Mediathek parts with 512 slot luts. On KOMEDA, legacy
    lut's are completely unsupported by the kms driver, so gamma
    correction gets disabled.
    
    The situation is especially bad on Intel Icelake and later:
    Use of legacy gamma tables will cause the kms driver to switch
    to hardware legacy lut's with 256 slots, 8 bit wide, without
    interpolation. This way color output precision is restricted to
    8 bpc and any deep color / HDR output (10 bpc, fp16, fixed point 16)
    becomes impossible. The latest Intel gen gpu's would have worse
    color precision than parts which are more than 10 years old.
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>
    (cherry picked from commit 545fa90cbf37a4c18f013dabc9f3bfb8310a5a98)

commit 473a48660fc8a326312df2d5925017ce8152c7db
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Tue Sep 14 07:51:46 2021 +0200

    xfree86: Let xf86RandR12CrtcComputeGamma() deal with non-power-of-2 sizes.
    
    The assumption in the upsampling code was that the crtc->gamma_size
    size of the crtc's gamma table is a power of two. This is true for
    almost all current driver + gpu combos at least on Linux, with typical
    sizes of 256, 512, 1024 or 4096 slots.
    
    However, Intel Gen-11 Icelake and later are outliers, as their gamma
    table has 2^18 + 1 slots, very big and not a power of two!
    
    Try to make upsampling behave at least reasonable: Replicate the
    last gamma value to fill up remaining crtc->gamma_red/green/blue
    slots, which would normally stay uninitialized. This is important,
    because while the intel display driver does not actually use all
    2^18+1 values passed as part of a GAMMA_LUT, it does need the
    very last slot, which would not get initialized by the old code.
    
    This should hopefully create reasonable behaviour with Icelake+
    but is untested on the actual Intel hw due to lack of suitable
    hw.
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>
    (cherry picked from commit 7326e131df3d1373dd796d9e2d931e81a3536bad)

commit b33f487a7ca276e11214eb45b87aab970ca43d79
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Tue Sep 14 07:40:49 2021 +0200

    xfree86: Avoid crash in xf86RandR12CrtcSetGamma() memcpy path.
    
    If randrp->palette_size is zero, the memcpy() path can read past the
    end of the randr_crtc's gammaRed/Green/Blue tables if the hw crtc's
    gamma_size is greater than the randr_crtc's gammaSize.
    
    Avoid this by clamping the to-be-copied size to the smaller of both
    sizes.
    
    Note that during regular server startup, the memcpy() path is only
    taken initially twice, but then a suitable palette is created for
    use during a session. Therefore during an actual running X-Session,
    the xf86RandR12CrtcComputeGamma() will be used, which makes sure that
    data is properly up- or down-sampled for mismatching source and
    target crtc gamma sizes.
    
    This should avoid reading past randr_crtc gamma memory for gpu's
    with big crtc->gamma_size, e.g., AMD/MALI/KOMEDA 4096 slots, or
    Intel Icelake and later with 262145 slots.
    
    Tested against modesetting-ddx and amdgpu-ddx under screen color
    depth 24 (8 bpc) and 30 (10 bpc) to make sure that clamping happens
    properly.
    
    This is an alternative fix for the one attempted in commit
    617f591fc44e24413e1f91017d16734999bbbac1.
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>
    (cherry picked from commit 966f567432e91762382db09129f8fb4e2e434437)

commit d1ca47e1242b51c79cec7287f52c36c8e494706b
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Tue Sep 14 16:32:45 2021 +0200

    glamor: Fix leak in glamor_build_program()
    
    Fix the possible leak of `vs_prog_string` and `fs_prog_string` in case
    of failure, as reported by covscan.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    (cherry picked from commit 2906ee5e4a722138cccb3265a615da7705a52589)

commit d00e7dfc9da165810a578fa0910475686e1fa51c
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Tue Sep 21 23:35:42 2021 +0300

    xserver 21.1 RC 1
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 4ee66f574a70948ca90a5db94dd666a389a5ff3e
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Wed Sep 15 21:49:17 2021 +0300

    Drop XWayland DDX

commit 72c5d153c920d769802ed73a1b9bfd0d32e7c178
Author: Aaron Plattner <aplattner@nvidia.com>
Date:   Fri Sep 10 11:02:00 2021 -0700

    xfree86: NUL-terminate strings in hwEnableIO
    
    The Linux version of xf86EnableIO calls a helper function called hwEnableIO().
    Except on Alpha, this function reads /proc/ioports looking for the 'keyboard'
    and 'timer' ports, extracts the port ranges, and enables access to them. It does
    this by reading 4 bytes from the string for the start port number and 4 bytes
    for the last port number, passing those to atoi(). However, it doesn't add a
    fifth byte for a NUL terminator, so some implementations of atoi() read past the
    end of this string, triggering an AddressSanitizer error:
    
      ==1383==ERROR: AddressSanitizer: stack-buffer-overflow on address 0x7fff71fd5b74 at pc 0x7fe1be0de3e0 bp 0x7fff71fd5ae0 sp 0x7fff71fd5288
      READ of size 5 at 0x7fff71fd5b74 thread T0
          #0 0x7fe1be0de3df in __interceptor_atoi /build/gcc/src/gcc/libsanitizer/asan/asan_interceptors.cpp:520
          #1 0x564971adcc45 in hwEnableIO ../hw/xfree86/os-support/linux/lnx_video.c:138
          #2 0x564971adce87 in xf86EnableIO ../hw/xfree86/os-support/linux/lnx_video.c:174
          #3 0x5649719f6a30 in InitOutput ../hw/xfree86/common/xf86Init.c:439
          #4 0x564971585924 in dix_main ../dix/main.c:190
          #5 0x564971b6246e in main ../dix/stubmain.c:34
          #6 0x7fe1bdab6b24 in __libc_start_main (/usr/lib/libc.so.6+0x27b24)
          #7 0x564971490e9d in _start (/home/aaron/git/x/xserver/build.asan/hw/xfree86/Xorg+0xb2e9d)
    
      Address 0x7fff71fd5b74 is located in stack of thread T0 at offset 100 in frame
          #0 0x564971adc96a in hwEnableIO ../hw/xfree86/os-support/linux/lnx_video.c:118
    
        This frame has 3 object(s):
          [32, 40) 'n' (line 120)
          [64, 72) 'buf' (line 122)
          [96, 100) 'target' (line 122) <== Memory access at offset 100 overflows this variable
      HINT: this may be a false positive if your program uses some custom stack unwind mechanism, swapcontext or vfork
            (longjmp and C++ exceptions *are* supported)
      SUMMARY: AddressSanitizer: stack-buffer-overflow /build/gcc/src/gcc/libsanitizer/asan/asan_interceptors.cpp:520 in __interceptor_atoi
      Shadow bytes around the buggy address:
        0x10006e3f2b10: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
        0x10006e3f2b20: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
        0x10006e3f2b30: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
        0x10006e3f2b40: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
        0x10006e3f2b50: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
      =>0x10006e3f2b60: 00 00 f1 f1 f1 f1 00 f2 f2 f2 00 f2 f2 f2[04]f3
        0x10006e3f2b70: f3 f3 00 00 00 00 00 00 00 00 00 00 00 00 00 00
        0x10006e3f2b80: 00 00 00 00 00 00 00 00 00 00 00 00 f1 f1 f1 f1
        0x10006e3f2b90: f1 f1 f8 f2 00 f2 f2 f2 f8 f3 f3 f3 00 00 00 00
        0x10006e3f2ba0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 f1 f1
        0x10006e3f2bb0: f1 f1 00 f3 f3 f3 00 00 00 00 00 00 00 00 00 00
      Shadow byte legend (one shadow byte represents 8 application bytes):
        Addressable:           00
        Partially addressable: 01 02 03 04 05 06 07
        Heap left redzone:       fa
        Freed heap region:       fd
        Stack left redzone:      f1
        Stack mid redzone:       f2
        Stack right redzone:     f3
        Stack after return:      f5
        Stack use after scope:   f8
        Global redzone:          f9
        Global init order:       f6
        Poisoned by user:        f7
        Container overflow:      fc
        Array cookie:            ac
        Intra object redzone:    bb
        ASan internal:           fe
        Left alloca redzone:     ca
        Right alloca redzone:    cb
        Shadow gap:              cc
      ==1383==ABORTING
    
    Fix this by NUL-terminating the string.
    
    Fixes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1193#note_1053306
    Signed-off-by: Aaron Plattner <aplattner@nvidia.com>

commit 617f591fc44e24413e1f91017d16734999bbbac1
Author: Aaron Plattner <aplattner@nvidia.com>
Date:   Thu Sep 9 15:29:50 2021 -0700

    modesetting: Only use GAMMA_LUT if its size is 1024
    
    GAMMA_LUT sizes other than 1024 cause a crash during startup if the memcpy()
    calls in xf86RandR12CrtcSetGamma() read past the end of the legacy X11 /
    XVidMode gamma ramp.
    
    This is a problem on Intel ICL / GEN11 platforms because they report a GAMMA_LUT
    size of 262145. Since it's not clear that the modesetting driver will generate a
    proper gamma ramp at that size even if xf86RandR12CrtcSetGamma() is fixed, just
    disable use of GAMMA_LUT for sizes other than 1024 for now. This will cause the
    modesetting driver to disable the CTM property and fall back to the legacy gamma
    LUT.
    
    Signed-off-by: Aaron Plattner <aplattner@nvidia.com>
    Fixes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1193
    Tested-by: Mark Herbert

commit e59e24c8779de65db87b8c07bc3f2abb479be082
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Mon Sep 6 22:41:32 2021 +0300

    glamor: Fix handling of 1-bit pixmaps
    
    Since 8702c938b33b9ec180d64754eb922515c7c4a98b the pixmap formats are
    handled in a single place. In the process of conversion the difference
    between pixmap formats that can be uploaded and those that can be
    rendered on GL side has been lost. This affects only 1-bit pixmaps: as
    they aren't supported on GL, but can be converted to a R8 or A8 format
    for rendering (see glamor_get_tex_format_type_from_pictformat()).
    
    To work around this we add a separate flag that specifies whether the
    format actually supports rendering in GL, convert all checks to use this
    flag and then add 1-bit pixmap formats that don't support rendering in
    GL.
    
    Fixes: 8702c938b33b9ec180d64754eb922515c7c4a98b
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1210
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>
    Tested-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 68f01c0f02ece4f6efe9ce18be81244246a1e114
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Mon Aug 30 05:42:04 2021 +0200

    modesetting: Add option for non-vsynced flips for "secondary" outputs.
    
    Whenever an unredirected fullscreen window uses pageflipping for a
    DRI3/Present PresentPixmap() operation and the X-Screen has more than
    one active output, multiple crtc's need to execute pageflips. Only
    after the last flip has completed can the PresentPixmap operation
    as a whole complete.
    
    If a sync_flip is requested for the present, then the current
    implementation will synchronize each pageflip to the vblank of
    its associated crtc. This provides tear-free image presentation
    across all outputs, but introduces a different artifact, if not
    all outputs run at the same refresh rate with perfect synchrony:
    The slowest output throttles the presentation rate, and present
    completion is delayed to flip completion of the "latest" output
    to complete. This means degraded performance, e.g., a dual-display
    setup with a 144 Hz monitor and a 60 Hz monitor will always be
    throttled to at most 60 fps. It also means non-constant present
    rate if refresh cycles drift against each other, creating complex
    "beat patterns", tremors, stutters and periodic slowdowns - quite
    irritating!
    
    Such a scenario will be especially annoying if one uses multiple
    outputs in "mirror mode" aka "clone mode". One output will usually
    be the "production output" with the highest quality and fastest
    display attached, whereas a secondary mirror output just has a
    cheaper display for monitoring attached. Users care about perfect
    and perfectly timed tear-free presentation on the "production output",
    but cares less about quality on the secondary "mirror output". They
    are willing to trade quality on secondary outputs away in exchange
    for better presentation timing on the "production output".
    
    One example use case for such production + monitoring displays are
    neuroscience / medical science applications where one high quality
    display device is used to present visual animations to test subjects
    or patients in a fMRI scanner room (production display), whereas
    an operator monitors the same visual animations from a control room
    on a lower quality display. Presentation timing needs to be perfect,
    and animations high-speed and tear-free for the production display,
    whereas quality and timing don't matter for the monitoring display.
    
    This commit gives users the option to choose such a trade-off as
    opt-in:
    
    It adds a new boolean option "AsyncFlipSecondaries" to the device section
    of xorg.conf. If this option is specified as true, then DRI3 pageflip
    behaviour changes as follows:
    
    1. The "reference crtc" for a windows PresentPixmap operation does a
       vblank synced flip, or a DRM_MODE_PAGE_FLIP_ASYNC non-synchronized
       flip, as requested by the caller, just as in the past. Typically
       flips will be requested to be vblank synchronized for tear-free
       presentation. The "reference crtc" is the one chosen by the caller
       to drive presentation timing (as specified by PresentPixmap()'s
       "target_msc", "divisor", "remainder" parameters and implemented by
       vblank events) and to deliver Present completion timestamps (msc
       and ust) extracted from its pageflip completion event.
    
    2. All other crtc's, which also page-flip in a multi-display configuration,
       will try to flip with DRM_MODE_PAGE_FLIP_ASYNC, ie. immediately and
       not synchronized to vblank. This allows the PresentPixmap operation
       to complete with little delay compared to a single-display present,
       especially if the different crtc's run at different video refresh
       rates or their refresh cycles are not perfectly synchronized, but
       drift against each other. The downside is potential tearing artifacts
       on all outputs apart from the one of the "reference crtc".
    
    Successfully tested on a AMD gpu with single-display, dual-display and
    triple-display setups, and with single-X-Screen as well as dual-X-Screen
    "ZaphodHeads" configurations.
    
    Please consider merging this commit for the upcoming server 1.21 branch.
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>

commit 1fd5dec11bbb85e87f70a39f1c1b59af95a7feaf
Author: Ignacio Casal Quinteiro <qignacio@amazon.com>
Date:   Tue Sep 7 16:58:10 2021 +0200

    touchevents: set the screen pointer after checking the device is enabled
    
    If the device is disabled the sprite is NULL so we get a seg fault

commit b3b81c8c2090cd49410960a021baf0d27fdd2ab3
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Fri Sep 3 14:33:15 2021 +0300

    Drop DMX DDX
    
    It turns out xdmx currently crashes when any client attempts to use GL
    and it has been in such state for about 14 years. There was a patch to
    fix the problem [1] 4 years ago, but it never got merged. The last
    activity on any bugs referring to xdmx has been more than 4 years ago.
    
    Given such situation, I find it unlikely that anyone is still using xdmx
    and just having the code is a drain of resources.
    
    [1]: https://lists.x.org/archives/xorg-devel/2017-June/053919.html
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 8f8ebf870b55c9875b7cfd8ef69c1df02d589b4a
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Sat Aug 28 02:27:20 2021 +0200

    modesetting: Allow Present flips with mismatched stride on atomic drivers.
    
    When using DRI3+Present with PRIME render offload, sometimes there is
    a mismatch between the stride of the to-be-presented Pixmap and the
    frontbuffer. The current code would reject a pageflip present in this
    case if atomic modesetting is not enabled, ie. always, as atomic
    modesetting is disabled by default due to brokeness in the current
    modesetting-ddx.
    
    Fullscreen presents without page flipping however trigger the copy
    path as fallback, which causes not only unreliable presentation timing
    and degraded performance, but also massive tearing artifacts due to
    rendering to the framebuffer without any hardware sync to vblank.
    Tearing is extra awful on modesetting-ddx because glamor afaics seems
    to use drawing of a textured triangle strip for the copy implementation,
    not a dedicated blitter engine. The rasterization pattern creates extra
    awful tearing artifacts.
    
    We can do better: According to a tip from Michel Daenzer (thanks!),
    at least atomic modesetting capable kms drivers should be able to
    reliably change scanout stride during a pageflip, even if atomic
    modesetting is not actually enabled for the modesetting client.
    
    This commit adds detection logic to find out if the underlying kms
    driver is atomic_modeset_capable, and if so, it no longer rejects
    page flip presents on mismatched stride between new Pixmap and
    frontbuffer.
    
    We (ab)use a call to drmSetClientCap(ms->fd, DRM_CLIENT_CAP_ATOMIC, 0);
    for this purpose. The call itself has no practical effect, as it
    requests disabling atomic mode, although atomic mode is disabled by
    default. However, the return value of drmSetClientCap() tells us if the
    underlying kms driver is atomic modesetting capable: An atomic driver
    will return 0 for success. A legacy non-atomic driver will return a
    non-zero error code, either -EINVAL for early atomic Linux versions
    4.0 - 4.19 (or for non-atomic Linux 3.x and earlier), or -EOPNOTSUPP
    for Linux 4.20 and later.
    
    Testing on a MacBookPro 2017 with Intel Kabylake display server gpu +
    AMD Polaris11 as prime renderoffload gpu, X-Server master + Mesa 21.0.3
    show improvement from unbearable tearing to perfect, despite a stride
    mismatch between display gpu and Pixmap of 11776 Bytes vs. 11520
    Bytes. That this is correct behaviour was also confirmed by comparing the
    behaviour and .check_flip implementation of the patched modesetting-ddx
    against the current intel-ddx SNA Present implementation.
    
    Please consider merging this patch before the server-1.21 branch point.
    This patch could also be cherry-picked into the server 1.20 branch to
    fix the same limitation.
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>

commit 7d34b1f2b7c612c3171e0b9758b5fc094bc33f63
Author: Simon Ser <contact@emersion.fr>
Date:   Fri Jun 18 11:04:45 2021 +0200

    xwayland: add -noTouchPointerEmulation
    
    In some scenarios, the Wayland compositor might have more knowledge
    than the X11 server and may be able to perform pointer emulation for
    touch events better. Add a command-line switch to allow compositors
    to turn Xwayland pointer emulation off.
    
    Signed-off-by: Simon Ser <contact@emersion.fr>

commit 7c63c582a17b206a33b57a70dd61e7919a6ef9fe
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Thu Aug 26 17:06:49 2021 +0200

    Revert "glamor: Enable modifier support for xfree86 too"
    
    This reverts commit 9b8999411033c9473cd68e92e4690a91aecf5b95.
    
    Turns out that defaulting glamor_egl->dmabuf_capable = TRUE
    breaks kms page-flipping on various Mesa+Linux/DRM-KMS+hardware
    combos, resulting in broken presentation timing, degraded performance
    and awful tearing. E.g., my testing shows that X-Server master +
    Mesa 21.2 + Linux 5.3 on Intel Kabylake has broken pageflipping.
    Similar behaviour was observed in the past on RaspberryPi 4/400
    with VideoCore-6 by myself and others, and iirc by myself on some
    AMD gpu's, although my memories of the latter are a bit dim.
    
    Cfe. https://gitlab.freedesktop.org/mesa/mesa/-/issues/3601 and
    possibly https://gitlab.freedesktop.org/xorg/xserver/-/merge_requests/254
    for related problems.
    
    The reason for pageflip failure on the modesetting-ddx under
    DRI3/Present seems to be the following sequence:
    
    1. Atomic modesetting for the modesetting-ddx is broken and therefore
       both disabled by default in the modesetting-ddx itself and also
       force-disabled by the Linux kernel since quite a while. If the kernel
       detects drmSetClientCap(fd, DRM_CLIENT_CAP_ATOMIC, 1); from the
       X-Server, it will reject the request, as a countermeasure to all the
       past and current brokeness.
    
    2. Without DRM_CLIENT_CAP_ATOMIC we don't get the implied universal
       planes support (DRM_CLIENT_CAP_UNIVERSAL_PLANES).
    
    3. Without DRM_CLIENT_CAP_UNIVERSAL_PLANES, drmModeGetPlaneResources()
       will only return overlay planes, but not primary- or cursor planes.
    
    4. As modesetting-ddx drmmode_crtc_create_planes() function can only
       operate on primary planes, but can't get any from drmModeGetPlaneResources(),
       the drmmode_crtc_create_planes() mostly turns into a no-op, never
       executes populate_format_modifiers() and therefore the Linux kernels
       DRM-KMS driver is not ever queried for the list of scanout/pageflip
       capable DRM format modifiers. Iow. the drmmode_crtc->formats[i].modifiers
       list stays empty with zero drmmode_crtc->formats[i].num_modifiers.
    
    5. The list from step 4 provides the format+modifiers for intersection
       which would get returned by the X-Servers DRI3 backend as response to
       a xcb_dri3_get_supported_modifiers_window_modifiers() request. Given
       an empty list was returned in step 4, this will lead to return of an
       empty modifiers list by xcb_dri3_get_supported_modifiers_window_modifiers().
    
    6. Both Mesa's DRI3/Present OpenGL backbuffer allocation logic and iirc
       Mesa/Vulkan/WSI/X11's swapchain image allocation logic use the list
       from xcb_dri3_get_supported_modifiers_window_modifiers() for format+
       modifier selection for scanout/pageflip capable buffers. Cfe. Mesa's
       dri3_alloc_render_buffer() function.
    
       Due to the empty list, the Mesa code falls back to the format+modifiers
       reported by xcb_dri3_get_supported_modifiers_screen_modifiers()
       instead. This list contains all modifiers reported by GLAMOR as
       result of glamor_get_formats() and glamor_get_modifiers(), which
       in turn are query results from Mesa eglQueryDmaBufFormatsEXT()
       and eglQueryDmaBufModifiersEXT(). Iow. all format+modifiers which
       are supported for rendering are considered for the OpenGL backbuffers
       and Vulkan swapchain buffers.
    
    7. Depending on kms driver + gpu combo and Mesa version, such buffers
       are often not direct-scanout / pageflip capable, and so pageflipping
       can't be used for DRI3/Present of fullscreen windows. Whenever the
       system has to fallback to copies instead of pageflips, the results
       are broken presentation timing, degraded performance and quite
       horrible tearing, as the current DRI3/Present implementation does not
       perform any hardware synchronization of copy presents to the start
       of vblank or similar.
    
    By defaulting glamor_egl->dmabuf_capable = FALSE instead, as the server
    1.20 branch does, we avoid this failure:
    
    1. glamor_get_modifiers() turns into a no-op and returns false, not
       reporting any supported dmabuf modifiers to the servers DRI3 code,
       ie. the servers cache_formats_and_modifiers() function can't retrieve
       and cache any format+modifiers. Therefore the servers DRI3 code now
       also reports an empty format+modifiers list when Mesa does a
       xcb_dri3_get_supported_modifiers_screen_modifiers() query.
    
    2. Mesa's buffer allocation code therefore falls back to using the old
       DRI image extensions createImage() function to allocate buffers
       with use flags __DRI_IMAGE_USE_SCANOUT | __DRI_IMAGE_USE_BACKBUFFER
       and our OpenGL backbuffers / Vulkan swapchain images get allocated
       in a direct-scanout / pageflip capable format. Pageflipping works,
       timing and performance is good, presentation is tear-free.
    
    Please consider merging this for branching the X-Server 1.21 branch.
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>

commit c5a9287dcf8d77ab104d56ac27ad6b1ff957fdfb
Author: Jon Turney <jon.turney@dronecode.org.uk>
Date:   Wed May 12 16:51:26 2021 +0100

    Don't underlink inputtest on targets which require complete linkage
    
    Don't underlink inputtest on targets which require complete linkage
    (e.g. when building for PE/COFF)

commit d68b50ec032fe4f02bde817abfd30328ec96a11c
Author: Jon Turney <jon.turney@dronecode.org.uk>
Date:   Sat Jul 10 17:38:01 2021 +0100

    Fix compilation with windows.h from latest w32api
    
    misc.h has complex logic (checking MAXSHORT is undefined etc.)
    controlling if it includes assert.h or not.
    
    Including windows.h from w32api 9.0.0 now trips over that, causing
    assert.h to not be included, causing various errors, e.g.
    
    In file included from ../include/cursor.h:53,
                     from ../include/dix.h:54,
                     from ../os/osdep.h:139,
                     from ../hw/xwin/winauth.c:40:
    ../include/privates.h: In function ‘dixGetPrivateAddr’:
    ../include/privates.h:121:5: error: implicit declaration of function ‘assert’ [-Werror=implicit-function-declaration]
    
    Fix this by IWYU in privates.h

commit ab86be0ed9233d6683daf00d359c562b12e137c8
Author: Mario Kleiner <mario.kleiner.de@gmail.com>
Date:   Fri Aug 27 19:27:29 2021 +0200

    modesetting: Fix VRR window property handling.
    
    A misplaced error check can cause this failure scenario, and does
    so reliably as tested on Ubuntu 21.04 with KDE Plasma 5 desktop
    within the first few seconds of login session startup, rendering
    VRR under modesetting-ddx unusable:
    
    1. Some X11 client application changes some window property.
    
    2. ms_change_property() is called as part of the property change
       handling call chain (client->requestVector[X_ChangeProperty]).
       It removes itself temporarily from the call chain - or so it
       thinks, hooking up saved_change_property instead.
    
    3. ret = saved_change_property(client) is called and fails
       temporarily for some non-critical reason.
    
    4. The misplaced error check returns early (error abort), without
       first restoring ms_change_property() as initial X_ChangeProperty
       handler in the call chain again.
    
    -> Now ms_change_property() has removed itself permanently from the
       property handler call chain for the remainder of the X session
       and VRR property changes on windows are no longer handled, ie.
       VRR no longer gets enabled/disabled in response to window VRR
       property changes.
    
    Place the error check at the proper place, just as it is correctly
    done by amdgpu-ddx, and in modesetting-ddx ms_delete_property()
    function.
    
    Verified to fix VRR handling with an AMD gpu under KDE desktop
    session.
    
    Please consider merging before branching the server 1.21 branch.
    
    Signed-off-by: Mario Kleiner <mario.kleiner.de@gmail.com>

commit 18d3131f9a332096825c09106a931c427246ddb7
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Thu Aug 5 22:43:54 2021 +0300

    meson: Implement developer documentation build
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 722da1c62caad961ce09fc226daf84465f4b7a7e
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Fri Aug 6 15:21:53 2021 +0300

    meson: Add option to disable libdrm support
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 1f720dc9a319bb66e2f5f28568614e81aa9e9e4d
Author: Adam Jackson <ajax@redhat.com>
Date:   Tue Aug 17 16:06:57 2021 -0400

    dmx: Fix some redeclaration warnings from gcc 11
    
    Of the form:
    
        ../hw/dmx/config/xdmxconfig.c:68:26: warning: redundant redeclaration of ‘dmxConfigEntry’ [-Wredundant-decls]
           68 | extern DMXConfigEntryPtr dmxConfigEntry;
              |                          ^~~~~~~~~~~~~~

commit b49f0f9b323d66056aa9cd88f9ca1a124037bf32
Author: Adam Jackson <ajax@redhat.com>
Date:   Tue Aug 17 16:04:40 2021 -0400

    xkb: Silence a warning from gcc 11
    
    I get this:
    
        In function ‘TryCopyStr’,
            inlined from ‘CopyISOLockArgs’ at ../xkb/xkbtext.c:875:9:
        ../xkb/xkbtext.c:720:13: warning: ‘tbuf’ may be used uninitialized [-Wmaybe-uninitialized]
          720 |             strcat(to, from);
              |             ^~~~~~~~~~~~~~~~
        ../xkb/xkbtext.c: In function ‘CopyISOLockArgs’:
        <built-in>: note: by argument 1 of type ‘const char *’ to ‘__builtin_strlen’ declared here
        ../xkb/xkbtext.c:871:10: note: ‘tbuf’ declared here
          871 |     char tbuf[64];
              |          ^~~~
    
    Just initialize tbuf so it definitely works.

commit c1138d8ec8d029de54261e355c0e5da0b001044a
Author: Adam Jackson <ajax@redhat.com>
Date:   Fri Jul 9 15:30:16 2021 -0400

    xinput: Silence a warning from gcc 11
    
    [45/388] Compiling C object Xi/liblibxserver_xi.a.p/xichangehierarchy.c.o
    ../Xi/xichangehierarchy.c:61:32: warning: argument 1 of type ‘int[256]’ with mismatched bound [-Warray-parameter=]
       61 | XISendDeviceHierarchyEvent(int flags[MAXDEVICES])
          |                            ~~~~^~~~~~~~~~~~~~~~~
    In file included from ../Xi/xichangehierarchy.c:54:
    ../Xi/xichangehierarchy.h:42:37: note: previously declared as ‘int[]’
       42 | void XISendDeviceHierarchyEvent(int flags[]);
          |                                 ~~~~^~~~~~~

commit f3a98334e6a56858853f3894b0f48ee040741410
Author: Adam Jackson <ajax@redhat.com>
Date:   Fri Jul 9 15:26:47 2021 -0400

    selinux: Stop using security_context_t
    
    This is apparently deprecated now and is and was always just char *.

commit 6f63873da55de33e51c1f6849a65501e380f19bc
Author: Simon Ser <contact@emersion.fr>
Date:   Mon Jul 5 15:30:16 2021 +0200

    xwayland: fix xdg_output leak
    
    The xdg_output wasn't cleaned up when destroying the xwl_output.
    
    Signed-off-by: Simon Ser <contact@emersion.fr>

commit 659260a0b7c1cef6060bd62a83deb03e3fa472b1
Author: Demi Marie Obenour <demi@invisiblethingslab.com>
Date:   Fri Aug 6 13:23:08 2021 -0400

    More missing version checks in SProcs
    
    The bug in XFixes was also found in GenericEvent and Damage.

commit e4dabe8d9395d60699aa9831626920adaa847680
Author: Roman Gilg <subdiff@gmail.com>
Date:   Sat Aug 7 14:15:07 2021 +0200

    Remove build-only include from public header
    
    The dix-config.h file is not installed, but dix.h is. The include makes the
    compilation of external drivers fail (for example the libinput driver).
    
    The Xserver compilation also works without the include, so just remove it.
    
    Signed-off-by: Roman Gilg <subdiff@gmail.com>

commit 31fb35a7afc782e857bf60e524e7d966dbcd2551
Author: Demi Marie Obenour <demi@invisiblethingslab.com>
Date:   Tue Jul 20 22:58:42 2021 -0400

    XFixes: add version check for byteswapped clients
    
    The version check for byteswapped clients was missing.

commit 7eba412072afdc9d27896410872e40364a8010bf
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Mar 26 15:48:23 2021 +0100

    xfree86: Move xf86CVTMode() function
    
    The xf86CVTMode() was implemented in a standalone source file because it
    was being used for both the xfree86 API and the standalone cvt utility.
    
    Now that the cvt utility is removed (as part of libxcvt) we can move the
    small xf86CVTMode() function with the rest of the xf86Modes sources.
    
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1142
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Matt Turner <mattst88@gmail.com>

commit f2781e95369583259991cd3add6f90f33be32171
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu Mar 25 10:27:31 2021 +0100

    xfree86/cvt: Drop cvt utility
    
    The cvt utility is now replaced by the standalone version found in
    libxcvt, no need to build the one in xfree86 anymore.
    
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1142
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Matt Turner <mattst88@gmail.com>

commit f788289bdcc4f04bd2fb62552df1c8c1ae0aea45
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu Mar 25 10:19:55 2021 +0100

    xfree86: Use libxcvt
    
    Replace the local implementation of the VESA CVT standard timing
    modelines generator with the one from libxct to avoid code duplication.
    
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1142
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Matt Turner <mattst88@gmail.com>

commit 6ea2c001f9d23c91113b937fb99053e262d21df6
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu Mar 25 10:17:49 2021 +0100

    xwayland: Use libxcvt
    
    Xwayland is using a copy of the CVT generator found in Xorg.
    
    Rather than duplicating the code within the xserver tree, use the
    libxcvt implementation instead.
    
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1142
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Matt Turner <mattst88@gmail.com>

commit a4ab57cb748674823744a8ef5a0b416ee553efe8
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu Mar 25 10:16:31 2021 +0100

    build: Add dependency on libxcvt
    
    libxcvt is a library providing a standalone version of the X server
    implementation of the VESA CVT standard timing modelines generator.
    
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1142
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Matt Turner <mattst88@gmail.com>

commit 84897891e5e7eb44068cda22284dca70c6cfd1a2
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Jul 9 15:11:51 2021 +0200

    ci: Install libxcvt from git
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>

commit 5c2592cbb19f996c4bb87bca4e4e46ab911d4bec
Author: Demi Marie Obenour <demi@invisiblethingslab.com>
Date:   Tue Jul 20 22:37:26 2021 -0400

    Add do-while loops to DIX macros
    
    This ensures they will behave properly in conditionals and always
    require a trailing semicolon.

commit d83c84bd9dc7fbd3588ce70b0c8bf0f63ed29ff3
Author: Alex Richardson <Alexander.Richardson@cl.cam.ac.uk>
Date:   Fri Jul 23 09:24:50 2021 +0100

    Mark the dixChangeWindowProperty() value argument as const
    
    It is copied using memcpy() and not modified so we can add const. This
    fixes a -Wincompatible-pointer-types-discards-qualifiers compiler warning
    that was failing a -Werror XVnc build for me.
    
    Signed-off-by: Alex Richardson <Alexander.Richardson@cl.cam.ac.uk>

commit fb5322ce2819260c07e06ab22b47df0a5d19f07d
Author: Zoltán Böszörményi <zboszor@gmail.com>
Date:   Thu Jul 8 06:14:21 2021 +0200

    glamoregl: Initialize glamor on the main device
    
    This allows e.g. an UDL device (driven by llvmpipe) to be automatically
    set up with GPU acceleration via reverse PRIME.
    
    The result is e.g.:
    
      # DISPLAY=:0.2 xrandr --listproviders
      Providers: number : 2
      Provider 0: id: 0xec cap: 0xf, Source Output, Sink Output, Source Offload, Sink Offload crtcs: 1 outputs: 1 associated providers: 1 name:modesetting
      Provider 1: id: 0x12c cap: 0xb, Source Output, Sink Output, Sink Offload crtcs: 2 outputs: 2 associated providers: 1 name:Intel
    
    Signed-off-by: Zoltán Böszörményi <zboszor@gmail.com>

commit f08bc32f5abc23ea715c15e8e86150434cc99e4f
Author: Zoltán Böszörményi <zboszor@gmail.com>
Date:   Thu Jul 8 06:13:24 2021 +0200

    xf86: Assign GPUs to screens according to configuration
    
    If there is an explicit configuration, assign the RandR provider
    of the GPUDevice to the screen it was specified for.
    
    If there is no configuration (default case) the screen number is
    still 0 so it doesn't change behaviour.
    
    The result is e.g:
    
      # DISPLAY=:0.2 xrandr --listproviders
      Providers: number : 2
      Provider 0: id: 0xd2 cap: 0x2, Sink Output crtcs: 1 outputs: 1 associated providers: 0 name:modesetting
      Provider 1: id: 0xfd cap: 0xb, Source Output, Sink Output, Sink Offload crtcs: 2 outputs: 2 associated providers: 0 name:Intel
    
    Signed-off-by: Zoltán Böszörményi <zboszor@gmail.com>

commit cd567415cc5645f8cdc78e85e8887e5cce76e6d7
Author: Zoltán Böszörményi <zboszor@gmail.com>
Date:   Thu Jul 8 06:09:44 2021 +0200

    xf86: Extract screen configuration matching into its own function
    
    Signed-off-by: Zoltán Böszörményi <zboszor@gmail.com>

commit 16571b8926a5a7ba5a1885b36a16857addbe8f41
Author: Boris-Barboris <ismailsiege@gmail.com>
Date:   Tue Jun 22 00:51:08 2021 +0300

    Don't hardcode fps for fake screen
    
    Currently, when main hardware screen is powered-off,
    X server initializes fake screen's timer with
    1 second update interval.
    
    Streaming software like Nomachine or Vnc, as well as
    desktop input automation suffers from it, since it
    will forever be stuck on 1 fps until the display is
    turned back on.
    
    This commit adds command line option -fakescreenfps <int>
    that allows the user to change the default fake screen
    timer.
    
    Signed-off-by: Baranin Alexander <ismailsiege@gmail.com>

commit 8836b9d243444031b6396d39d345f2f83b5fa6a9
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Thu Jul 22 13:12:05 2021 +0200

    modesetting: unflip not possible when glamor is not set
    
    This is fixing crashes of xfce when running under qemu

commit d6c02ffd9c910637f6b3b7249507998e9e45f93c
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Mon Jul 19 14:25:28 2021 +0200

    present: fallback get_crtc to return crtc belonging to screen with present extension
    
    Since crtc can belong to secondary output that may not have present
    extension enabled we should fallback to first enabled crtc or fake crtc.
    
    Fix for issue xorg/xserver#1195

commit f6f2f203bcde47c334836191982d77bbbbbf533c
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Thu May 20 19:00:10 2021 +0200

    present: Drop flip_idler member from present_vblank_rec
    
    It's redundant with the pixmap member of struct xwl_present_event.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 212cfbcf68d279f2b3494e79fe8e3fbaabeba77c
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Wed May 12 15:25:51 2021 +0200

    xwayland/present: Use present_vblank_ptr instead of xwl_present_event*
    
    Where the latter isn't really needed.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit fe8c7855f3a85f156c792a3f18a175138407054b
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Wed May 12 12:51:32 2021 +0200

    xwayland/present: Fold xwl_present_release_event into _free_event
    
    The only difference was unhooking from the vblank.event_queue list,
    which is already done by xwl_present_flip_notify_vblank in
    xwl_present_msc_bump.

commit 31d2ebca77fcabec81194ae6dcd724c699b1b513
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Mon May 10 18:33:43 2021 +0200

    xwayland/present: Drop target_msc member from struct xwl_present_event
    
    Use present_vblank_rec::exec_msc instead.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 495ec596640e26b6995c93eedc922d2702ad64ad
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Mon May 10 19:04:07 2021 +0200

    xwayland/present: Drop pending member from struct xwl_present_event
    
    We are handling two cases here: the active flip or the pending flip.
    
    For the pending flip (event->pending == TRUE), we called
    xwl_present_release_pixmap.
    
    For the active flip (event->pending == FALSE), we called
    xwl_present_release_event. However, xwl_present_flip_notify_vblank
    already unhooked event->vblank.event_queue. So this was effectively the
    same as calling xwl_present_release_pixmap.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit f73340445fe1da9ae9bc3197eb2ef41589aa2a4e
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Fri May 7 18:16:23 2021 +0200

    xwayland/present: Drop list member from struct xwl_present_event
    
    Use present_vblank_rec::event_queue instead.
    
    The changes in xwl_present_execute shouldn't really be needed, since
    we should never hit queue_vblank in present_execute_wait. But let's be
    safe rather than sorry, plus this simplifies the code.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit aac31d2758d4e84774b633ec108d18f0bad6ef64
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Fri May 7 17:58:27 2021 +0200

    xwayland/present: Drop exec_queue member from struct xwl_present_window
    
    Doesn't serve any purpose anymore.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit f8c086b2145d1c9364e9b43ff4d796791d8af169
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Fri May 7 17:55:13 2021 +0200

    xwayland/present: Fold xwl_present_event_notify into its caller
    
    Can just call xwl_present_execute directly.
    
    This allows dropping the window member from struct xwl_present_window as
    well.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit c30f3d08acb01a41df0fe7176f237137f3039480
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Fri May 7 17:49:07 2021 +0200

    xwayland/present: Use exec_queue for deferring completion events
    
    We clear the vblank->pixmap field, so next time xwl_present_execute
    falls through to present_execute_post.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 4503c8d9ea7df5bda470501e638a730d91d718c9
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Fri May 7 12:56:30 2021 +0200

    xwayland/present: Fold xwl_present_idle_notify into its caller
    
    Allows simplification by avoiding indirection.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit b2a06e0700fa48c1e77fc687e6af39a4bb7c2ceb
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Fri May 7 12:34:49 2021 +0200

    xwayland/present: Drop sync_flip member of struct xwl_present_window
    
    The same information can be determined from the flip queue.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit fc53e3c536b5a338c595b5724c7d0b4734e45871
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Thu May 6 18:42:46 2021 +0200

    xwaland/present: Drop flip_pending member of struct xwl_present_window
    
    Use the first element of the flip_queue list for the same purpose.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit c592c66625d964e8ed1f3fcfc01a245e4c8a8015
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Fri May 7 12:21:44 2021 +0200

    xwayland/present: Fold xwl_present_flip_notify into its callers
    
    No need for them to be separate anymore.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 42301760802ea1cbe3698797c2bfb3a91ee02430
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Fri Apr 23 12:59:55 2021 +0200

    xwayland/present: Embed present_vblank_rec in xwl_present_event
    
    This allows for various simplifications.
    
    Use the pointer to the struct memory as the event ID. In contrast to
    the SCMD code for Xorg (where pending DRM events cannot be cancelled),
    this is safe here, because we can destroy pending Wayland callbacks. So
    we can't get a callback with a stale pointer to freed memory.
    
    Remove xwl_present_window::release_list in favour of
    present_vblank_rec::window_list.
    
    Remove xwl_present_event::xwl_present_window in favour of
    present_vblank_rec::window.
    
    xwl_present_free_event is never called for a NULL pointer anymore, no
    need to check.
    
    v2:
    * Restore DestroyWindow wrapping order to make sure
      present_destroy_window doesn't call xwl_present_abort_vblank.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 61cc5d96ed281a082d8dd414506dea0084e446fd
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Wed May 5 15:02:25 2021 +0200

    present: Refactor present_vblank_init helper ouf of _vblank_create
    
    Allows embedding into another struct.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 35f173ddb606f9fbac7957e427fe28a377204cfe
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Thu Apr 29 18:44:04 2021 +0200

    xwayland/present: Drop abort member of struct xwl_present_event
    
    We can call xwl_present_free_event unconditionally from
    xwl_present_abort_vblank, since the sync_callback is already destroyed
    in xwl_present_cleanup.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 0517460301cbf9c6ed3020ef1dd0cd1df94ea178
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Tue May 11 12:56:53 2021 +0200

    xwayland/present: Simplify calls to Xwayland-private functions
    
    Change parameter types to what's really needed, or just fold the
    function into its only caller.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 490248ea70d3fe923446e17312880ae63590d45c
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Mon Apr 19 12:59:56 2021 +0200

    xwayland/present: Rename present_wnmd_* functions to xwl_present_*
    
    The WNMD indirection is gone.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 0c0cbbc7cb4fa917a2b33494efb6dc03e5de9051
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Wed Apr 21 17:15:27 2021 +0200

    present: Remove present_wnmd_info_rec
    
    Doesn't serve any purpose anymore.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 561c63d0f13a8c6379ed05338172570f93dbce37
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Mon Apr 19 18:41:59 2021 +0200

    xwayland/present: Merge present_wnmd_flips_stop & xwl_present_flips_stop
    
    Just use the latter instead of the former elsewhere. No need for them
    to be separate anymore.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit a67f16fde1ff094c3ec4fffe8a7269b30c7b8668
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Mon Apr 19 18:53:36 2021 +0200

    xwayland/present: Fold present_wnmd_get_ust_msc into its callers
    
    Just use xwl_present_get_ust_msc directly. No need for the indirection
    anymore.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 080c1ca3f57b4226f34624b0cd2171ffbbc2be4f
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Mon Apr 19 18:46:23 2021 +0200

    xwayland/present: Fold present_wnmd_queue_vblank into its callers
    
    Just use xwl_present_queue_vblank directly. No need for the indirection
    anymore.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit c22887bc7a83e9b8ad112aadaec069b0366fc38e
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Mon Apr 19 18:51:06 2021 +0200

    xwayland/present: Fold present_wnmd_get_crtc into present_wnmd_pixmap
    
    And use xwl_present_get_crtc directly.
    
    No need for them to be separate anymore.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit cb35ff596ec4e4fc6a4e96d55e280cdf399791e1
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Mon Apr 19 18:34:07 2021 +0200

    xwayland/present: Fold present_wnmd_check_flip into its callers
    
    Mainly into xwl_present_check_flip, and call that from
    present_wnmd_check_flip_window.
    
    No need for them to be separate anymore.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 7b78cf6b3ae386b9df2483692041dfa38a91bedb
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Mon Apr 19 18:26:55 2021 +0200

    xwayland/present: Simplify query_capabilities
    
    No need for the WNMD indirection anymore.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 244403ec8718d782d57a830ece9357a75a0dd70b
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Mon Apr 19 18:01:52 2021 +0200

    xwayland/present: Fold present_wnmd_abort_vblank into its only caller
    
    No need for them to be separate anymore.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit f7adbc2166b7a4662cbd69507d8cbac11034c87e
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Mon Apr 19 18:06:22 2021 +0200

    xwayland/present: Drop present_wnmd_flush in favour of xwl_present_flush
    
    No need for the indirection anymore.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 7fd114365d694360540bc46cd615aa47373be0a8
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Mon Apr 19 19:02:32 2021 +0200

    xwayland/present: Fold present_wnmd_flip into present_wnmd_execute
    
    No need for the indirection anymore.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 2e1dcd731f98a8beceee699cc57b7082f98916c4
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Tue Apr 20 19:01:12 2021 +0200

    xwayland/present: Fold present_wnmd_screen_init into xwl_present_init
    
    No need for them to be separate anymore.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit b6419359b6b11ec659f59cc74075fcf049591425
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Wed Apr 21 12:50:02 2021 +0200

    present: Move present_wnmd.c contents to hw/xwayland/xwayland-present.c
    
    This will allow eliminating indirections and making the Xwayland Present
    code more efficient and easier to follow.
    
    While this technically changes the Xorg video driver ABI, I don't know
    of any drivers using the dropped present_wnmd_* symbols, and I doubt a
    Xorg driver could make use of them as is anyway.
    
    (As a bonus, Xorg no longer links any Xwayland specific Present code)
    
    v2:
    * Wrap DestroyWindow before initializing Present, so that
      present_destroy_window runs before xwl_present_cleanup. Avoids crash
      due to present_destroy_window calling xwl_present_* functions when
      xwl_present_window was already freed. (Olivier Fourdan)
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit c35a716b02921e2fcae5fe89295a99c6dd5dec8c
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Fri Apr 16 18:45:39 2021 +0200

    present: Fold wnmd_init_mode_hooks into wnmd_screen_init
    
    Preparation for moving WNMD code to hw/xwayland. No functional change
    intended.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 10bdd87fe49cbd9b4c4b584024d663b928d3f1be
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Fri Apr 16 18:43:48 2021 +0200

    present: Move present_wnmd_screen_init to present_wnmd.c
    
    Now all WNMD code is in present_wnmd.c.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit b6d54b0f5d2fb3dc8a4b2812bfee94112c332256
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Wed Apr 21 17:01:36 2021 +0200

    present: Dispatch clear_window_flip via present_screen_priv hook
    
    Eliminates special cases in present_destroy_window.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 93666ebe37a9c8d64b814c7af6b895f89ca5ff88
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Wed Apr 21 18:39:36 2021 +0200

    present: Remove create_event_id hook
    
    Each present_vblank_create caller generates and sets the ID afterwards.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 44f705a5b6b4f79682c5e649eb718a193e01ec47
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Mon Apr 19 18:19:30 2021 +0200

    present: Pass capabilities to present_vblank_create by value
    
    Preparation for moving WNMD code to hw/xwayland. No functional change
    intended.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 86e645bcfaea63bc3f91e4ccbbc19569929b92c3
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Fri Jul 2 12:41:34 2021 +0200

    xwayland/eglstream: Drop xwl_eglstream_set_window_pixmap
    
    Not sure why we'd need to abandon a pending stream for a pixmap just
    because it's no longer a window pixmap. Let's try not to.
    
    Reviewed-by: Olivier Fourdan <ofourdan@redhat.com>

commit ba8763c27b2ebc91850abfcaf32ae972e80142e7
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Fri Jul 2 12:57:21 2021 +0200

    xwayland/eglstream: Consolidate pending_cb destruction
    
    Into a new xwl_eglstream_destroy_pending_stream helper.
    
    Reviewed-by: Olivier Fourdan <ofourdan@redhat.com>

commit 204f10c29e0f323e7829ecf48e0f002be96e194d
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Wed Jul 7 18:53:35 2021 +0200

    xwayland: Call RRTellChanged if the RandR configuration may have changed
    
    This makes sure RandR events are sent to interested clients as needed.
    This was happening implicitly in some cases, but not in others, e.g. if
    the root window size didn't change.
    
    If this were to call RRTellChanged more often than necessary in some
    cases, that should be harmless, as it only sends events if something
    has actually changed since last time.
    
    Should fix https://bugzilla.redhat.com/show_bug.cgi?id=1979892 .
    
    v2:
    * Call RRTellChanged at the very end of update_screen_size, just in
      case.
    
    Reviewed-by: Olivier Fourdan <ofourdan@redhat.com>

commit a6d178b6af4bb4cd7ba28299c3ddd9d90bcbaaa5
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Wed Jul 7 18:51:02 2021 +0200

    randr: Bail from RRTellChanged if there's no root window yet
    
    This can happen if RRTellChanged is called during initialization.
    
    Continuing in that case makes no sense conceptually:
    
    * Any event sent over the wire requires a corresponding window.
    * No root window probably means there can't be any clients which could
      receive the events.
    
    In practice, it would result in a crash down the road due to
    dereferencing the NULL ScreenRec::root pointer.
    
    Reviewed-by: Olivier Fourdan <ofourdan@redhat.com>

commit 7e20c8b7b8357eb8986f89e85be22ab1c29f2ca4
Author: Matt Turner <mattst88@gmail.com>
Date:   Thu Jul 8 12:15:13 2021 -0700

    Build xz tarballs instead of bzip2
    
    Signed-off-by: Matt Turner <mattst88@gmail.com>

commit a9552868697cae02e37e67ae774a072885f202f8
Author: Dave Airlie <airlied@redhat.com>
Date:   Thu Jul 1 06:48:55 2021 +1000

    glamor: add EXT_gpu_shader4 support
    
    This enables a number of the GLSL 1.30 paths on GPUs that have
    EXT_gpu_shader4 but don't have GLSL 1.30 exposed.
    
    (Intel gen4/5 mainly)
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>

commit a2f5b917f511fca1c9b1501495664e2f63c2e1b0
Author: Dave Airlie <airlied@redhat.com>
Date:   Fri Jul 2 04:52:23 2021 +1000

    glamor: add glamor_glsl_has_ints wrapper
    
    This should make adding gpu shader4 support cleaner
    
    Reviewed-by: Adam Jackson <ajax@redhat.com>

commit b4f55712da4d7294bfeb6cffc45b572fd999d800
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Mon Jul 5 21:40:55 2021 +0300

    xserver 21.0.99.1
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit b67e514dbb59bffc23b75d47ca7f24e96c4aeb05
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sat Jun 26 09:44:39 2021 +0300

    meson: Fix warnings when reading back and checking feature flags
    
    Meson does not like comparing things of different types which is a
    problem when reading back values of feature flags as they may contain
    either false (bool) or 1 (string).
    
    Since there is a strong reason why we use false when the feature does
    not exist, we work around this issue by always converting the returned
    value to int via to_int().
    
    Fixes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1190
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit b2a0de4f072fdcc0fb20a0853f7edaf714add9d9
Author: Adam Jackson <ajax@redhat.com>
Date:   Tue Jun 22 12:39:56 2021 -0400

    xfixes: Allow the client to upgrade the fixes protocol version
    
    If you say FixesQueryVersion twice we remember whatever the second
    version number was. With just libXfixes this isn't an issue because the
    request is hidden in extension setup, but libxcb-xfixes doesn't do that
    for you, which means the second one can _lower_ the requested fixes
    version, disabling requests that the client thought it had enabled.
    
    Paper over this by allowing the version number to be raised but not
    lowered. Also go ahead and delete the minor version number from the
    client state since xfixes doesn't have minor versions (yet, anyway).

commit 7d509b6f342d9732b567dc4efa867ea24919853b
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Apr 30 09:56:05 2021 +0200

    xwayland/eglstream: Remove stream validity
    
    To avoid an EGL stream in the wrong state, if the window pixmap changed
    before the stream was connected, we would still keep the pending stream
    but mark it as invalid. Once the callback is received, the pending would
    be simply discarded.
    
    But all of this is actually to avoid a bug in egl-wayland, there should
    not be any problem with Xwayland destroying an EGL stream while the
    compositor is still using it.
    
    With that bug now fixed in egl-wayland 1.1.7, we can safely drop all
    that logic from Xwayland EGLstream backend.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1189

commit 2be9f795bc15012dc912f595003e01bb6aa66f54
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Wed Jun 23 11:35:17 2021 +0200

    xwayland/eglstream: Keep pending stream if the pixmap didn't change
    
    If the pixmap does not actually change in set_window_pixmap(), there is
    no need to invalidate the pending stream, if there's one.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Suggested-by: Michel Dänzer <mdaenzer@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>

commit 2531ee02450e3be3549daa09407557c3addeba02
Author: orbea <orbea@riseup.net>
Date:   Wed Jun 23 05:50:21 2021 -0700

    hw/dmx/config: Link directly with libdmxconfig.a
    
    When building xserver with slibtool (https://dev.midipix.org/cross/slibtool)
    the build will fail.
    
      /usr/bin/ld: cannot find -ldmxconfig
    
    This is because xserver creates libdmxconfig.a internally and then links with
    the linker flag -ldmxconfig. However according to automake documentation the
    -lfoo linker flags should only be used for external dependencies and all
    internal libraries should be linked with the libtool archive file (.la) or
    the static archive (.a) when the former is not available.
    
    GNU libtool is far more permissive and happens to silently obscure this issue
    while slibtool fails because it instead sees '-L./.libs -ldmxconfig'.

commit 2f53d1cf7304574a516f6868822307648bc35333
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Wed Apr 7 18:22:05 2021 +0300

    config: Fix platform busid parsing when there is no ID_PATH prop
    
    On at least Lenovo Thinkpad E585 udev does not have ID_PATH property for
    the drm node (see
    https://gitlab.freedesktop.org/xorg/xserver/-/issues/993). While this is
    likely udev bug, this causes the device to be not recognized as
    attribs->busid is NULL, which causes platform_find_pci_info to be not
    called and corresponding xf86_platform_devices[i]->pdev to be NULL.
    
    At this moment pdev being NULL will cause a crash, but this is a
    different bug.
    
    Fixes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/993
    Fixes: 0816e8fc linux: Make platform device probe less fragile
    Reviewed-by: Zoltán Böszörményi <zboszor@gmail.com>
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit d4b38e111946b934d0f8438dc295dd9f7316318c
Author: Olivier Certner <olce.freedesktop@certner.fr>
Date:   Tue Feb 9 10:49:00 2021 +0100

    os: Properly report failure to link lock file
    
    Stop assuming that a failure to link always means that the file indeed
    exists. In case of other failure (e.g., permissions), the user would get an
    inconsistent "Can't read lock file" message.
    
    Signed-off-by: Olivier Certner <olce.freedesktop@certner.fr>

commit d66b7ec12986efd4f32fcc84cdaacbd04ec98ccb
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Wed Jun 23 15:26:23 2021 +0200

    xfree86: Fix out of array bound access to xf86Entities
    
    Signed-off-by: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>

commit 0d93bbfa2cfacbb73741f8bed0e32fa1a656b928
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Fri Mar 26 00:51:02 2021 +0200

    xfree86: Fix potentially NULL reference to platform device's PCI device
    
    xf86_platform_devices[i].pdev may be NULL in cases we fail to parse the
    busid in config_udev_odev_setup_attribs() (see also [1], [2]) such as
    when udev does not give use ID_PATH. This in turn leads to
    platform_find_pci_info() being not called and pdev being NULL.
    
    [1]: https://gitlab.freedesktop.org/xorg/xserver/-/issues/993
    [2]: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1076
    
    Reviewed-by: Zoltán Böszörményi <zboszor@gmail.com>
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 303763941f9941e2e215a3c978b72de495478033
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Fri Mar 26 00:51:01 2021 +0200

    xfree86: Consistently check for reference to primaryBus pci_device
    
    This is the only place where we don't check whether
    primaryBus.id.plat->pdev is not NULL before accessing its members.
    
    It may be NULL in cases we fail to parse the busid in
    config_udev_odev_setup_attribs() (see also [1], [2]) such as when udev
    does not give use ID_PATH. This in turn leads to
    platform_find_pci_info() being not called and pdev being NULL in one of
    the items within the xf86_platform_devices array. For this to cause a
    crash we only need it to become the primaryBus device.
    
    [1]: https://gitlab.freedesktop.org/xorg/xserver/-/issues/993
    [2]: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1076
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit b9722d39cd619ac55c2cfbb5644eabb84ff57f1b
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Thu Jun 17 18:00:50 2021 +0300

    configure.ac: Switch project version to 20.x.y style
    
    Reviewed-by: Zoltán Böszörményi <zboszor@gmail.com>
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit ef89b6648e2a806237a6d2fa598e1b9c83f128b4
Author: Zoltán Böszörményi <zboszor@pr.hu>
Date:   Mon Jun 21 12:12:41 2021 +0200

    xfree86: Fix NULL pointer dereference crash
    
    screenp->displays[count] (passed to configDisplay() in
    configScreen()) is NULL if there is no Virtual setting
    in the configuration.
    
    Fixes: f8a6be04d0c7e6a99824ff888ad6c010960c5c21 ("xfree86: Change
    displays array to pointers array to fix invalid pointer issues
    after table reallocation")
    
    Signed-off-by: Zoltán Böszörményi <zboszor@gmail.com>

commit aad61e8e03311eb8bae4f7db59e65634733eadc2
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Jun 18 14:52:55 2021 +0200

    glx: Fix use after free in MakeCurrent
    
    The fix from commit c468d34c7 - "glx: Set ContextTag for all contexts"
    is actually incomplete, it correctly sets the context tag for direct
    contexts as well, but would fail to mark the context's currentClient.
    
    As a result, when the context is destroyed, it would be freed
    immediately rather than being just scheduled for deletion, even though
    it is still current for some client. leading to a use-after-free.
    
    Make sure to also set the context's currentClient for direct contexts as
    well, not just indirect ones.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Fixes: c468d34c7 - "glx: Set ContextTag for all contexts"
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1186
    Reviewed-by: Adam Jackson <ajax@redhat.com>

commit 021b3c2f778e718338f232b94880fc3ae9092085
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Tue Jun 15 12:40:47 2021 +0300

    configure.ac: Bump inputproto dep to 2.3.99.1
    
    This should have been part of 6cbcbc81525b131b5b94409ea870af663d5c28bb.
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 05b3c681ea2f478c0cb941c2f8279919cf78de6d
Author: Daniel Strnad <strnadda@gmail.com>
Date:   Tue May 19 15:52:35 2020 +0200

    hw/xfree86: Propagate physical dimensions from DRM connector
    
    Physical dimmension of display can be obtained not just by configuration or
    DDC, but also directly from kernel via drmModeGetConnector(). Until now
    xserver silently discarded these values even when no configuration nor EDID
    were present and fallbacked to default DPI.

commit f8a6be04d0c7e6a99824ff888ad6c010960c5c21
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Tue Jun 8 20:02:21 2021 +0200

    xfree86: Change displays array to pointers array to fix invalid pointer issues after table reallocation
    
    There are rare cases when xf86SetDepthBpp is resizing displays array in confScreen.
    As that array is shared between set of ScrnInfoRec's then realloc might invalidate chached DispPtr display values in
    otheres ScrnInfoRec objects.
    
    If we will change displays array as an array of pointers to DispRec then cached DispRec pointers in ScrnInfoRec
    won't be invalid after reallocation of displays array.
    
    Signed-off-by: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>

commit 1a1bd5cf7a1a3364afb625f020e1c013fbabfbb6
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Fri Apr 16 16:15:35 2021 +0300

    modesetting: Add a limit on async page flip error log frequency
    
    In certain circumstances we will have a lot of flip errors without a
    reasonable way to prevent them. In such case we reduce the number of
    logged messages to at least not fill the error logs.
    
    The details are as follows:
    
    At least on i915 hardware support for async page flip support depends on
    the used modifiers which themselves can change dynamically for a screen.
    This results in the following problems:
    
    - We can't know about whether a particular CRTC will be able to do an
    async flip without hardcoding the same logic as the kernel as there's no
    interface to query this information.
    
    - There is no way to give this information to an application, because
    the protocol of the present extension does not specify anything about
    changing of the capabilities on runtime or the need to re-query them.
    
    Even if the above was solved, the only benefit would be avoiding a
    roundtrip to the kernel and reduced amount of error logs. The former
    does not seem to be a good enough benefit compared to the amount of work
    that would need to be done. The latter is solved in this commit.
    
    Reviewed-by: Eero Tamminen <eero.t.tamminen@intel.com>
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 9992245c5f7821de1fbd866f43f0afe55080ed67
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Fri Apr 16 16:15:34 2021 +0300

    modesetting: Extract flip failure logging to a single place
    
    Reviewed-by: Eero Tamminen <eero.t.tamminen@intel.com>
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 9adb13e296baead53112a268ddfd291195742c71
Author: Jose Maria Casanova Crespo <jmcasanova@igalia.com>
Date:   Tue Jun 8 14:52:17 2021 +0200

    glamor: Avoid using GL_QUADS on V3D
    
    Like in 0e3f1252dacdc3194 ("glamor: Avoid using GL_QUADS on VC4")
    this will avoid mesa to fallback doing conversion for QUADS primitives.
    
    Signed-off-by: Jose Maria Casanova Crespo <jmcasanova@igalia.com>
    Reviewed-by: Emma Anholt <emma@anholt.net>

commit 104c7c50485238a1e8c2090dc96126e9624ef870
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Tue May 18 18:02:59 2021 +0200

    xwayland/present: Move wl_buffer check into xwl_glamor_check_flip
    
    Keeps the glamor specific code together more.
    
    Reviewed-by: Olivier Fourdan <ofourdan@redhat.com>

commit 3641c24bd012d032ec289cde312a9a5a3ba8c3bf
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Tue May 18 17:56:50 2021 +0200

    xwayland/eglstream: Handle xwl_pixmap_get returning NULL
    
    In xwl_glamor_eglstream_get_wl_buffer_for_pixmap. This can likely be hit
    now with an SHM pixmap via the Present flip path. There might be other
    corner cases.
    
    Fixes: f3eb1684fa50 "xwayland: enable MIT-SHM shared pixmaps"
    Reviewed-by: Olivier Fourdan <ofourdan@redhat.com>

commit d163e0a1d5ec54cc726d45a239a0777d0a84d610
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Fri Jun 11 18:25:01 2021 +0200

    ci: Fix UPSTREAM_REPO -> FDO_UPSTREAM_REPO
    
    The latter is what ci-templates expect.
    
    Fixes: ab73c16930d6 "ci: Update to the latest templates"
    Reviewed-by: Simon Ser <contact@emersion.fr>

commit 7e7c147105ac704a7b33bdee0f85dc9ccdd8f747
Author: Lukasz Spintzyk <lukasz.spintzyk@gmail.com>
Date:   Mon Jun 7 09:30:46 2021 +0200

    modesetting: Disable reverse prime offload mode for displays running on evdi,udl
    
    This mode for displays running on evdi/udl as side effect of failed glamor_egl_init
    reverse_prime_offload_mode was initialized to FALSE
    
    After Mesa upgrade to 21.0.0 GL_RENDERER is not llvmpipe that results in successful glamor_egl_init
    and reverse_prime_offload_mode enabled.
    
    This commit is explicitly disabling reverse_prime_offload_mode for evdi and udl drivers
    
    Signed-off-by: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>

commit c468d34c7208c9041f9c077b54a00ae9cccad6a3
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu Jun 3 17:51:01 2021 +0200

    glx: Set ContextTag for all contexts
    
    Currently, xorgGlxMakeCurrent() would set the context tag only for
    indirect GLX contexts.
    
    However, several other places expect to find a context for the tag or
    they would raise a GLXBadContextTag error, such as WaitGL() or WaitX().
    
    Set the context tag for direct contexts as well, to avoid raising an
    error and possibly killing the client.
    
    Thanks to Erik Kurzinger <ekurzinger@nvidia.com> for spotting the issue.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Adam Jackson <ajax@redhat.com>

commit 6b47321bc6138bcd737b36e038aba904d56f1cf6
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Wed Apr 28 13:33:29 2021 +0200

    dix: Add optional terminate delay
    
    When the command line option "-terminate" is used, it could be
    interesting to give it an optional grace period to let the Xserver
    running for a little longer in case a new connection occurs.
    
    This adds an optional parameter to the "-terminate" command line option
    for this purpose.
    
    v2: Use a delay in seconds instead of milliseconds
        (Martin Peres <martin.peres@mupuf.org>)
    v3: Clarify man page entry, ensure terminateDelay is always >= 0,
        simplify TimerFree(). (Peter Hutterer <peter.hutterer@who-t.net>)
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit e167299f6050d85778e62ed2a1e544ceef6452fc
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Feb 19 12:03:39 2021 +0100

    xfixes: Add ClientDisconnectMode
    
    With Wayland compositors now being able to start Xwayland on demand, the
    next logical step is to be able to stop Xwayland when there is no more
    need for it.
    
    The Xserver itself is capable of terminating itself once all X11 clients
    are gone, yet in a typical full session, there are a number of X11
    clients running continuously (e.g. the Xsettings daemon, IBus, etc.).
    
    Those always-running clients will prevent the Xserver from terminating,
    because the actual number of X11 clients will never drop to 0. Worse,
    the X11 window manager of a Wayland compositor also counts as an X11
    client, hence also preventing Xwayland from stopping.
    
    Some compositors such as mutter use the XRes extension to query the X11
    clients connected, match their PID with the actual executable name and
    compare those with a list of executables that can be ignored when
    deciding to kill the Xserver.
    
    But that's not just clumsy, it is also racy, because a new X11 client
    might initiate a connection the X11 server right when the compositor is
    about to kill it.
    
    To solve this issue directly at the Xserver level, this add new entries
    to the XFixes extension to let the X11 clients themselves specify the
    disconnect mode they expect.
    
    Typically, those X11 daemon clients would specify the disconnect mode
    XFixesClientDisconnectFlagTerminate to let the Xserver know that they
    should not be accounted for when checking the remaining clients prior
    to terminate.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit b7a85e44da91d1663d5b4eabac06327c92a80f91
Author: Erik Kurzinger <ekurzinger@nvidia.com>
Date:   Thu Dec 10 14:24:32 2020 -0800

    glx: don't create implicit GLXWindow if one already exists
    
    If a GLXMakeCurrent request specifies an X window as its drawable,
    __glXGetDrawable will implicitly create a GLXWindow for it. However,
    the client may have already explicitly created a GLXWindow for that X
    window. If that happens, two __glXDrawableRes resources will be added
    to the window.
    
    If the explicitly-created GLXWindow is later destroyed by the client,
    DrawableGone will call FreeResourceByType on the X window, but this
    will actually free the resource for the implicitly-created GLXWindow,
    since that one would be at the head of the list.
    
    Then if the X window is destroyed after that, the resource for the
    explicitly-created GLXWindow will be freed. But that GLXWindow was
    already destroyed above. This crashes the server when it tries to call
    the destroyed GLXWindow's destructor. It also means the
    implicitly-created GLXWindow would have been leaked since the
    FreeResourceByType call mentioned above skips calling the destructor.
    
    To fix this, if __glXGetDrawable is given an X window, it should check
    if there is already a GLXWindow associated with it, and only create an
    implicit one if there is not.
    
    Signed-off-by: Erik Kurzinger <ekurzinger@nvidia.com>
    Reviewed-by: Adam Jackson <ajax@redhat.com>

commit 8274dd664335cd72739a1107f174e7a974a9ea24
Author: Jan Beich <jbeich@FreeBSD.org>
Date:   Sun May 30 19:49:43 2021 +0000

    meson: provide fallback for *proto dependencies
    
    Meson has a built-in facility to use bundled versions of dependencies
    if system packages are too old. Enable for xorgproto after 8e504d8b36eb:
    
    Run-time dependency xproto found: YES 7.0.33
    Run-time dependency randrproto found: YES 1.6.0
    Run-time dependency renderproto found: YES 0.11.1
    Run-time dependency xextproto found: YES 7.3.0
    Dependency inputproto found: NO found 2.3.2 but need: '>= 2.3.99.1'
    Found CMake: /usr/local/bin/cmake (3.20.2)
    Run-time dependency inputproto found: NO (tried pkgconfig and cmake)
    Looking for a fallback subproject for the dependency inputproto
    
    meson.build:73:0: ERROR: Neither a subproject directory nor a xorgproto.wrap file was found.

commit 34a58d7714025bc1043bf5282358406eb10e4b8e
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu May 20 16:46:33 2021 +0200

    xwayland/eglstream: Log when GL_OES_EGL_image is missing
    
    That will dramatically affect performance, might as well log when we
    cannot use GL_OES_EGL_image with the NVIDIA closed-source driver.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>

commit fae58e9b03696a3890f9c876306c68ffa6f9ff30
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Mon May 17 18:20:57 2021 +0200

    xwayland/eglstream: Use "nvidia" for GLVND
    
    If the EGLStream backend is able to use hardware acceleration with the
    NVIDIA closed source driver, we should use the "nvidia" GLX
    implementation instead of the one from Mesa to take advantage of the
    NVIDIA hardware accelerated rendering.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>

commit 24fc8aea1e4bbaba780f1a316fba797a0198f603
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu May 20 12:11:42 2021 +0200

    xwayland: Add preferred GLVND vendor to xwl_screen
    
    If Xwayland's EGLstream backend supports hardware acceleration with the
    NVIDIA closed-source driver, the GLX library also needs to be one
    shipped by NVIDIA, that's what GLVND is for.
    
    Add a new member to the xwl_screen that the backend can optionally set
    to the preferred GLVND vendor to use.
    
    If not set, "mesa" is assumed.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>

commit 2de5ded3c6d73c1672d2cb14d603cb23fcd477e5
Author: Niveditha Rau <niveditha.rau@oracle.com>
Date:   Tue May 11 15:08:41 2021 -0700

    glx: Check for byte-swapping in SetReplyHeader
    
    Check for the need to byte-swap when attempting to display
    GL apps between a big-endian server and little-endian client
    or vice versa.
    
    Fixes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1127

commit bcb1de600a7656e4ee6434a8d2e2772ca9fd0473
Author: Adam Jackson <ajax@redhat.com>
Date:   Thu Apr 22 11:47:29 2021 -0400

    glx: Fix error return code in GLXGetDrawableAttributes
    
    This should only ever throw GLXBadDrawable, says the protocol spec.

commit eb6f8daca5dc15af321d0bcc54cd6cb8b6779257
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:48 2021 +0300

    Xi: Work around broken libxcb that doesn't ignore unknown device classes
    
    libxcb 14.1 and older are not forwards-compatible with new device
    classes as it does not properly ignore unknown device classes. Since
    breaking libxcb would break quite a lot of applications, we instead
    report Gesture device class only if the client advertised support for XI
    2.4.
    
    Clients may still not work in cases when a client advertises XI 2.4
    support and then a completely separate module within the client uses
    broken libxcb to call XIQueryDevice.
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 7e692633fb9ab8e1ed2a88c3abb4fe04144c0a80
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:47 2021 +0300

    Xi: Implement gesture support for XIQueryDevice

commit 0886254f96f40e59193ccbb0e3acbd5ae92dbaa3
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:46 2021 +0300

    xfree86: Bump input minor ABI due to addition touchpad gestures
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 1cdc3b5d146818993c5a9436d17e1d0888054c38
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:45 2021 +0300

    xfree86: Implement gesture support for test input driver

commit dccc0275f4f3740cc625fb60ab1d014d6ec10709
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:44 2021 +0300

    Bump XI protocol version to 2.4

commit 75feb1366809bfb6d50734c10ab11258783a2e9d
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:43 2021 +0300

    Xi: Include gestures among events that may freeze device

commit 5163fc8bc28ce8bc2703cddcd9f2775ebc311766
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:42 2021 +0300

    Implement gesture processing logic

commit d3c52df16105de5ac37e196a49b173e426caf417
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:41 2021 +0300

    hw/xfree86: Implement public APIs to submit gesture events

commit 100a2ad6da4ba90f8d489c7a2ed3f3f0ac879a6f
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:40 2021 +0300

    dix: Implement gesture event submission code path

commit 7656a9c8dddbc57adfd4fd05f8e26b1845ac8738
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:39 2021 +0300

    dix: Implement internal gesture state handling

commit 0bf4123fd3bc945d150884e6ea38bd2b81c0994b
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:38 2021 +0300

    dix: Implement gesture event fixups before delivery

commit 227f601de31aabf6aaa897477e42e6b7f8f7c963
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:37 2021 +0300

    xi: Implement conversions from internal to Xi2 gesture event structs

commit f3462178caf09a8777b8671eb03949b75c8ee07a
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:36 2021 +0300

    test/xi2: Verify that XI_GestureSwipeEnd is ignored when outside mask

commit 407a2234b32d9cb3fed2cc7e8069bb41b98e143f
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:35 2021 +0300

    test/xi2: Update tests for gesture event types

commit f83f7dbb1c1be406b82da9bca12be3c43d6bfeee
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:34 2021 +0300

    xi: Bump max supported XI2 event type

commit 81909546397eb180ed8983bdb80f5673dbae71ac
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:33 2021 +0300

    xi: Implement selection logic for gesture event types

commit 080bac39c844bd16b7e1493797c6e7644badf0ab
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:32 2021 +0300

    xi: Implement grab support for new gesture event types

commit b544a1fdb8fa7e7efc7dde66089e901d957061d9
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:31 2021 +0300

    xi: Implement internal gesture event struct

commit 22fa31ed561ed1e78bf3651f28e11882b1eac51f
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:30 2021 +0300

    dix: Add new internal event enums for gesture events

commit 8e504d8b36eb8f23bf8cfa46143d046cc6b8ea51
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:29 2021 +0300

    meson: Depend on inputproto 2.3.99.1
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 2acde60147797393e0ee9428cff0f74cdc0a9227
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun May 30 13:26:28 2021 +0300

    .gitlab-ci: Install xorgproto 2021.4.99.2 from git
    
    This is required for the support of upcoming XI 2.4 protocol.
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 236d1775509404b0dcf44873422dd8652b1e9588
Author: Claes Nästén <pekdon@gmail.com>
Date:   Fri May 14 13:57:10 2021 +0000

    os: include unistd.h when HAVE_PSTACK is defined
    
    On Solaris when HAVE_PSTACK is defined unistd.h needs to be included to
    avoid implicit declarations of pipe, read, execle etc.

commit 7515c23a416825f0db51f9b445279b12d5918ebf
Author: Erik Kurzinger <ekurzinger@nvidia.com>
Date:   Tue May 11 17:00:21 2021 -0400

    xwayland/eglstream: flush stream after eglSwapBuffers
    
    When eglSwapBuffers inserts a new frame into a window's stream, there may be a
    delay before the state of the consumer end of the stream is updated to reflect
    this. If the subsequent wl_surface_attach, wl_surface_damage, wl_surface_commit
    calls are received by the compositor before then, it will (typically) re-use
    the previous frame acquired from the stream instead of the latest one.
    
    This can leave the window displaying out-of-date contents, which might never be
    updated thereafter.
    
    To fix this, after calling eglSwapBuffers, xwl_glamor_eglstream_post_damage
    should call eglStreamFlushNV. This call will block until it can be guaranteed
    that the state of the consumer end of the stream has been updated to reflect
    that a new frame is available.
    
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1171
    
    Signed-off-by: Erik Kurzinger <ekurzinger@nvidia.com>

commit f3eb1684fa5008ad7c881f798a5efb7441b23035
Author: Simon Ser <contact@emersion.fr>
Date:   Mon Apr 19 22:49:56 2021 +0200

    xwayland: enable MIT-SHM shared pixmaps
    
    Allow X11 clients to create shared pixmaps via the MIT-SHM
    extension under Xwayland. Tested with a wlroots patch [1].
    
    Also add a few assertions to make sure we have wl_buffers where we
    need them.
    
    [1]: https://github.com/swaywm/wlroots/pull/2875
    
    Signed-off-by: Simon Ser <contact@emersion.fr>
    Acked-by: Michel Dänzer <mdaenzer@redhat.com>

commit 3d33d885fcd1215a74c1819278cf6f9557c9860b
Author: Erik Kurzinger <ekurzinger@nvidia.com>
Date:   Fri May 14 08:26:49 2021 -0400

    xwayland/eglstream: allow commits to dma-buf backed pixmaps
    
    As of commit 098e0f52 xwl_glamor_eglstream_allow_commits will not allow commits
    if the xwl_pixmap does not have an EGLSurface. This is valid for pixmaps backed
    by an EGLStream, however pixmaps backed by a dma-buf for OpenGL or Vulkan
    rendering will never have an EGLSurface.  Unlike EGLStream backed pixmaps,
    though, glamor will render directly to the buffer that Xwayland passes to the
    compositor. Hence, they don't require the intermediate copy in
    xwl_glamor_eglstream_post_damage that EGLStream backed pixmaps do, so there is
    no need for an EGLSurface.
    
    Signed-off-by: Erik Kurzinger <ekurzinger@nvidia.com>
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>

commit 012350e3db47fef0404346f55968032e62004fcf
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Apr 30 16:23:10 2021 +0200

    xwayland/eglstream: Set ALU to GXCopy for blitting
    
    The EGLstream backend's post damage function uses a shader and
    glDrawArrays() to copy the data from the glamor's pixmap texture prior
    to do the eglSwapBuffers().
    
    However, glDrawArrays() can be affected by the GL state, and therefore
    not reliably produce the expected copy, causing the content of the
    buffer to be corrupted.
    
    Make sure to set the ALU to GXCopy prior to call glDrawArrays() to get
    the expected result.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Suggested-by: Michel Dänzer <mdaenzer@redhat.com>

commit d85bfa6ab7495281516f3a4b05dc1ff0b2c4bf91
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Tue May 4 10:56:38 2021 +0200

    xwayland/eglstream: Do not always increment pixmap refcnt on commit
    
    Currently, the EGLstream backend would increment the pixmap refcount for
    each commit, and decrease that refcount on the wl_buffer release
    callback.
    
    But that's relying on the compositor sending us a release callback for
    each commit, otherwise the pixmap refcount will keep increasing and the
    pixmap will be leaked.
    
    So instead, increment the refcount on the pixmap only when we have not
    received a release notification for the wl_buffer, to avoid increasing
    the pixmap refcount more than once without a corresponding release
    event.
    
    This way, if the pixmap is still in use when released on the X11 side,
    the EGL stream will be kept until the compositor releases it.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Suggested-by: Michel Dänzer <mdaenzer@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>

commit b583395cd38ad101c7541bd8b0e91143ced44703
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Apr 30 09:02:29 2021 +0200

    xwayland/eglstream: Check eglSwapBuffers()
    
    EGLstream's post_damage() would unconditionally return success
    regardless of the actual status of the eglSwapBuffers().
    
    Yet, if eglSwapBuffers() fails, we should not post the corresponding
    damage as they wouldn't match the actual content of the buffer.
    
    Use the eglSwapBuffers() return value as the return value for
    post_damage() and do not take a refrence on the pixmap if it fails.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>

commit a45799971083c47082d085d3732a5b12692cf75b
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Mon Apr 19 14:52:38 2021 +0200

    xwayland/eglstream: Fix calloc/malloc
    
    Use calloc() instead of malloc() like the rest of the code.
    
    Also fix the arguments of calloc() calls to match the definition which
    is calloc(size_t nmemb, size_t size).
    
    This is a cleanup patch, no functional change.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>

commit 098e0f52c088c6eb52c7e54c5a11cefabd480908
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Mon Apr 19 18:11:19 2021 +0200

    xwayland/eglstream: Do not commit without surface
    
    The EGL surface for the xwl_pixmap is created once the stream is ready
    and valid.
    
    If the pixmap's EGL surface fails, for whatever reason, the xwl_pixmap
    will be unusable and will end up as an invalid wl_buffer.
    
    Make sure we do not allow commits in that case and recreate the
    xwl_pixmap/stream.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    https://gitlab.freedesktop.org/xorg/xserver/-/issues/1156

commit bee2ebb29f0999862ab39af26c673c00af40b082
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Tue Apr 27 14:17:19 2021 +0200

    xwayland/eglstream: Drop the list of pending streams
    
    Now that the pending stream is associated with the xwl_pixmap for
    EGLStream and the xwl_pixmap itself is associated to the pixmap, we have
    a reliable way to get to those data from any pending stream.
    
    As a result, the list of pending streams that we keep in the EGLStream
    global structure becomes useless.
    
    So we can drop the pending stream's xwl_pixmap and also the list of
    pending streams altogether, and save us a walk though that list for each
    callback.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Suggested-by: Michel Dänzer <mdaenzer@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>

commit e19bf86c17ef9c802fea24410cc6b1f51a19ce7f
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Wed Apr 14 17:31:08 2021 +0200

    xwayland/eglstream: Keep a reference to the pixmap
    
    Commit affc47452 - "xwayland: Drop the separate refcount for the
    xwl_pixmap" removed the separate reference counter for the xwl_pixmap
    which holds the EGLStream.
    
    While that works fine for the common case, if the window's pixmap is
    changed before the stream is ready, the older pixmap will be destroyed
    and the xwl_pixmap along with it, even if the compositor is still using
    the stream.
    
    The code that was removed with commit affc47452 was taking care of that
    by increasing the separate reference counter for the xwl_pixmap, but it
    no longer the case.
    
    As a result, we may end up with the EGL stream in the wrong state when
    trying to use it, which will cascade down into all sort of issues.
    
    To avoid the problem, increase the reference count on the pixmap when it
    is marked as invalid in EGLStream's SetWindowPixmap().
    
    This way, the xwl_pixmap and the EGLStream are kept until released by
    the compositor, even when the pixmap changes before stream is ready.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    Fixes: affc47452 xwayland: Drop the separate refcount for the xwl_pixmap
    https://gitlab.freedesktop.org/xorg/xserver/-/issues/1156

commit cb61ecc7291cfbed2f76d4437cd7450b8e4dab00
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Apr 16 10:38:23 2021 +0200

    xwayland/eglstream: Dissociate pending stream from window
    
    Previously, we would have pending streams associated with top level X11
    windows, keeping temporary accounting for the pending streams before
    they get fully initialized for the xwl_pixmap which would be associated
    with X11 pixmaps.
    
    If the window content changes before the stream is ready, the
    corresponding pending stream would be marked as invalid and the pending
    stream would be eventually removed once the stream becomes ready.
    
    Since commit affc47452 - "xwayland: Drop the separate refcount for the
    xwl_pixmap", we no longer keep a separate reference counter for the
    xwl_pixmap, but rather tie it to the X11 pixmap lifespan. Yet, the
    pending stream would still be associated with the X11 toplevel window.
    
    Dissociate the pending streams from the X11 toplevel window, to keep it
    tied only to the xwl_pixmap so that we can have:
    
     - pixmap <-> xwl_pixmap
     - xwl_pixmap <-> pending stream
    
    Of course, the pending streams remain temporary and get removed as soon
    as the ready callback is triggered, but the pending streams are not
    linked to the X11 window anymore which can change their content, and
    therefore their X11 pixmap at any time.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    https://gitlab.freedesktop.org/xorg/xserver/-/issues/1156

commit cc596bcfb273eeab82ac3d59867668af8bad2abf
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu Apr 1 08:46:52 2021 +0200

    xwayland/eglstream: Add more error checking
    
    eglCreateStreamKHR() can fail and return EGL_NO_STREAM_KHR, in which
    case there is no point in trying to create a buffer from it.
    
    Similarly, eglCreateStreamProducerSurfaceKHR() also fail and return
    EGL_NO_SURFACE, which in turn will be used in eglMakeCurrent() as
    draw/read surface, and therefore would mean no draw/read buffer.
    
    In those cases, log the error, and bail out early. That won't solve the
    issue but will help with investigating the root cause of issues with
    EGLStream backend.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    https://gitlab.freedesktop.org/xorg/xserver/-/issues/1156

commit 823f3254fabd16e5e721da57cd260beac9b8f8bd
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu Apr 15 10:59:36 2021 +0200

    xwayland/eglstream: Small refactoring
    
    Some functions are called "callback" whereas they are not longer
    callback functions or "unref" while they no longer deal with a reference
    counter anymore, which is quite confusing. Rename those functions to be
    more explicit.
    
    Also, the pending streams can be destroyed in different places, move the
    common code to separate function to avoid duplicating code and help with
    readability of the code.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Acked-by: Michel Dänzer <mdaenzer@redhat.com>

commit 85244d2a2081d61a2e4a06e847041f638de01e3f
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Wed Mar 31 09:49:35 2021 +0200

    xwayland/eglstream: Check framebuffer status
    
    The EGLStream backend would sometime generate GL errors trying to draw
    to the framebuffer, which gives an invalid buffer, which in turn would
    generate a Wayland error from the compositor which is fatal to the
    client.
    
    Check the framebuffer status and bail out early if it's not complete,
    to avoid getting into trouble later.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    https://gitlab.freedesktop.org/xorg/xserver/-/issues/1156

commit 252cbad316f43edc08aa5c844789398a58ba270c
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Wed Mar 31 13:57:45 2021 +0200

    xwayland/glamor: Add return status to post_damage
    
    If the glamor backend failed to post damage, the caller should do the
    same to avoid a failure to attach the buffer to the Wayland surface.
    
    Change the API of Xwayland's glamor backend post_damage() to return a
    status so that xwl_window_post_damage() can tell whether the callee
    failed.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    https://gitlab.freedesktop.org/xorg/xserver/-/issues/1156

commit 3b265c59a6456f6e4abfb9e1694237bc56f1776a
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Tue Mar 30 08:48:25 2021 +0200

    glamor: Dump backtrace on GL error
    
    Currrently, when a GL error is triggered, glamor would log the error
    which may not be sufficient to trace it back to the cause of the error.
    
    Also dump the backtrace which may give more information as to where the
    error comes from.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Martin Peres <martin.peres@mupuf.org>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    https://gitlab.freedesktop.org/xorg/xserver/-/issues/1156

commit 25d2f4948f0abd39e099b8ac69b7cb1dab38a10a
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Mon Mar 29 15:01:15 2021 +0200

    xwayland: Check buffer prior to attaching it
    
    If the buffer is NULL, do not even try to attach it, and risk a Wayland
    protocol error which would be fatal to us.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Martin Peres <martin.peres@mupuf.org>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    https://gitlab.freedesktop.org/xorg/xserver/-/issues/1156

commit 4f0889e98306d30a37aba0fadb1fd3790c13205a
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Mon Mar 29 14:22:56 2021 +0200

    xwayland/eglstream: Check buffer creation
    
    EGLStream wl_eglstream_display_create_stream() may fail, yet Xwayland
    would try to attach the buffer which may cause a fatal Wayland protocol
    error raised by the compositor.
    
    Check if the buffer creation worked, and fail gracefully otherwise (like
    wayland-eglsurface does).
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Martin Peres <martin.peres@mupuf.org>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    https://gitlab.freedesktop.org/xorg/xserver/-/issues/1156

commit 4f6fbd5009ae533cf0b3bbe382502254f9276a01
Author: Erik Kurzinger <ekurzinger@nvidia.com>
Date:   Tue Apr 27 07:23:44 2021 -0400

    xwayland-eglstream: fix X11 rendering to flipping GL / VK window
    
    If a window is being used for direct rendering with OpenGL or Vulkan, and is
    using the flipping path for presentation, it's pixmap will be set to a dma-buf
    backed pixmap created by the client-side GL driver. However, this means that
    xwl_glamor_eglstream_post_damage won't work since it requires that the pixmap
    has an EGLSurface that it can render to, which dma-buf backed pixmaps do not.
    
    In this case, though, xwl_glamor_eglstream_post_damage is not necessary since
    glamor will have rendered directly to the pixmap, so we can simply pass it
    directly to the compositor. There's no need for the intermediate copy we
    normally do in that function.
    
    Therefore, this change adds an early-return case to post_damage for dma-buf
    backed pixmaps, and removes the corresponding asserts from that function and
    allow_commits.
    
    Signed-off-by: Erik Kurzinger <ekurzinger@nvidia.com>
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>

commit a50a0e348542bf32fb4239ee05a485772837f2f3
Author: qarmin <mikrutrafal54@gmail.com>
Date:   Tue Apr 28 22:05:02 2020 +0200

    glxcmds: Fix possible out of bounds

commit 3ea46f9336693d713ab63f422fffce42f9060a2c
Author: Mazlan, Hazwan Arif <hazwan.arif.mazlan@intel.com>
Date:   Thu Jul 30 10:12:27 2020 +0800

    dri2: Sync i965_pci_ids.h from mesa iris_pci_ids.h
    
    Copied TGL PCI ID from MESA iris_pci_ids.h
    This update brings in a significant number of new platform ID's
    Sync up until commit f02ae698
    
    Signed-off-by: Mazlan, Hazwan Arif <hazwan.arif.mazlan@intel.com>

commit d3933a24d1abdcb56f45e6076cb84a1110674a8a
Author: Jon Turney <jon.turney@dronecode.org.uk>
Date:   Tue Apr 23 17:59:29 2019 +0100

    CI: Add an x86 MinGW-w64 cross build
    
    Only cross-build for x86 MinGW-w64, as x64 MinGW-w64 will probably
    require fixing LLP64 issues.
    
    I don't know any source for pre-built cross-dependencies of the X
    server, so build these from git.
    
    Don't build with GLX enabled, so I don't have to deal with
    cross-building mesa and it's dependencies, for the moment.

commit 7e142cb2a848acb6af986fa91d254d4c23963b24
Author: luporl <luporl@FreeBSD.org>
Date:   Wed Dec 9 11:11:15 2020 -0300

    xserver: fix RGB mask handling
    
    On FreeBSD 13.0-CURRENT for PowerPC64 big-endian (BE), X was
    crashing in some cases. For instance, when twm was started
    and the background was clicked to open its menu, X crashed
    with a segmentation fault, trying to dereference a null pointer
    at CreatePicture().
    
    There were 2 issues with xorg-server handling of RGB masks that
    caused the pointer above to be null and thus the crash:
    - wrong use of ffs() to get the RGB offsets from the masks
    - overflow when shifting a 16-bit integer
    
    This change fixes both issues. They happen when the system is BE
    but has a video adapter using a little-endian (LE) ARGB32
    framebuffer. In order to display the correct colors, this setup
    requires a BE RGBA32 color format to be used by X, by setting
    the RGB masks appropriately, that didn't work properly because of
    the issues above.

commit 5be3b80b8d084ca5721be8791910d5827d1b6014
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Fri Sep 18 14:32:01 2020 +0200

    modesetting: Remove few common functions from ms namespace
    
    A lot of that code is the same as in xf86-amdgpu and xf86-nouveau drivers. By removing that functions from
    ms namespace we can move that code to common implementation.
    
    Signed-off-by: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>

commit c282be503e267afdd050df837d4cf61e0e7287b7
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Fri Sep 18 14:31:53 2020 +0200

    modesetting: remove unnecessary ms_covering_xf86_crtc dup of ms_covering_randr_crtc
    
    Signed-off-by: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>

commit b923364c5ec8251e81b4aa5fd451d9d7bb038009
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Fri Sep 18 14:31:47 2020 +0200

    modesetting: Find crtc on secondary outputs as fallback instead of returning primary crtc
    
    Signed-off-by: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>

commit d2dce22b6775c772282ac2c0e224ef9685ab34fa
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Fri Sep 18 14:31:34 2020 +0200

    present: fix msc offset calculation in screen mode
    
    Instead of getting the current msc value from the window crtc,
    which not exist take the last saved msc value saved in
    the window_priv struct
    
    Signed-off-by: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>

commit 908deb0895f9fe345d70be933d251ea10511d30a
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Fri Sep 18 14:31:25 2020 +0200

    present: Use crtc's screen present operation for syncing
    
    Signed-off-by: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>

commit d03c0de77ba36bb5221d00ac84dcdd6aae0df453
Author: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>
Date:   Fri Sep 18 14:29:25 2020 +0200

    modesetting: Initialize present extension despite glamor is disabled
    
    Signed-off-by: Łukasz Spintzyk <lukasz.spintzyk@synaptics.com>

commit 7aaf54a1884f71dc363f0b884e57bcb67407a6cd
Author: Matthieu Herrb <matthieu@herrb.eu>
Date:   Sun Mar 21 18:38:57 2021 +0100

    Fix XChangeFeedbackControl() request underflow
    
    CVE-2021-3472 / ZDI-CAN-1259
    
    This vulnerability was discovered by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Matthieu Herrb <matthieu@herrb.eu>

commit 66ce61983db0a067e48143750c4d5557d5638b1c
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 18 09:59:17 2021 +1000

    xkb: silence a compiler warning
    
    xkb.c: In function ‘ProcXkbSetMap’:
    xkb.c:2747:5: warning: ISO C90 forbids mixed declarations and code [-Wdeclaration-after-statement]
     2747 |     DeviceIntPtr master = GetMaster(dev, MASTER_KEYBOARD);
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit f6b8f8c071a575e54645aeb0bd3cb37377b0e4d3
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Thu Mar 18 09:44:53 2021 +1000

    xkb: don't require a trailing slash for the XKM output dir
    
    Rework the function to use a single snprintf call instead of a mix of
    strcpy/strcats. This now also appends a trailing slash where needed so we
    don't rely on the build system to set this for us.
    
    Also, since /tmp/ is the fallback and we never check if everything succeeded,
    assert if we can't use /tmp/. This will never be triggered anyway, the only
    caller to OutputDirectory() uses sizeof(PATH_MAX-sized array).
    
    Follow-up from 6c51818a0f55282cbe5a870f58ca82ca45ee472d
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>

commit eceafd4a2d159f5c2b789ad77ee283c2aa848a59
Author: Jan Beich <jbeich@FreeBSD.org>
Date:   Fri Apr 9 14:44:13 2021 +0000

    meson: switch getpeer* checks to autotools style
    
    Checking for function "getpeereid" : YES
    Checking for function "getpeerucred" : NO
    [...]
    include/meson.build:182:7: ERROR: Argument to "not" is not a boolean.
    
    Fixes: 68c2cfadd6d3 ("meson: Make sure defines are either set to 1 or not defined")

commit 9f8421af637942e5d9963828f4ce55f456410603
Author: Jan Beich <jbeich@FreeBSD.org>
Date:   Fri Apr 9 15:22:22 2021 +0000

    meson: check pthread_setname_np like autotools
    
    FreeBSD < 12.2 and OpenBSD only have pthread_set_name_np.
    As libpthread isn't in scope use -Werror to trip the check.
    
    Header <pthread.h> has symbol "PTHREAD_MUTEX_RECURSIVE" : YES
    Checking if "pthread_setname_np(tid, name)" compiles: YES
    
    os/inputthread.c:326:5: error: implicit declaration of function 'pthread_setname_np' is invalid in C99 [-Werror,-Wimplicit-function-declaration]
        pthread_setname_np (pthread_self(), "InputThread");
        ^
    os/inputthread.c:447:5: error: implicit declaration of function 'pthread_setname_np' is invalid in C99 [-Werror,-Wimplicit-function-declaration]
        pthread_setname_np (pthread_self(), "MainThread");
        ^
    
    Fixes: c20e7b5e2222 ("meson: Automatically detect HAVE_PTHREAD_SETNAME_NP")

commit 38e875904b039ec1889e7c81eb1d577a4f69b26d
Author: Erik Kurzinger <ekurzinger@nvidia.com>
Date:   Thu Dec 3 14:57:51 2020 -0800

    xwayland: implement pixmap_from_buffers for the eglstream backend
    
    Provides an implementation for the pixmap_from_buffers DRI3 function for
    xwayland's eglstream backend. This will be used by the NVIDIA GLX driver
    to pass buffers from client applications to the server. These can then
    be presented using the PRESENT extension.
    
    To hopefully make this less error-prone, we also introduce a "type"
    field for this struct to distinguish between xwl_pixmaps for the new
    DRI3-created pixmaps and those for the existing glamor-created pixmaps.
    
    Additionally, the patch enables wnmd present mode with the eglstream backend.
    This involves creating a wl_buffer for the provided dma-buf before importing it
    into EGL and passing this to the compositor so it can be scanned out directly
    if possible.
    
    Since both backends now support this present mode, the HAS_PRESENT_FLIP flag is
    no longer needed, so it can be removed.
    
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>
    Signed-off-by: Erik Kurzinger <ekurzinger@nvidia.com>

commit bc99dd2127f12f1aae55971c09a2792eeaa98444
Author: Erik Kurzinger <ekurzinger@nvidia.com>
Date:   Wed Mar 3 11:56:41 2021 +0100

    xwayland: Add check_flip() glamor backend function
    
    This is preliminary work for hardware accelerated rendering with the
    NVIDIA driver.
    
    This exposes a new glamor backend function, check_flip, which can be
    used to control whether flipping is supported for the given pixmap.
    
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>
    Signed-off-by: Erik Kurzinger <ekurzinger@nvidia.com>

commit 400d4d0fdd55192f394e1a8273dfb2423c895ec0
Author: Erik Kurzinger <ekurzinger@nvidia.com>
Date:   Fri Feb 12 12:09:27 2021 -0800

    xwayland: move formats and modifiers functions to common glamor code
    
    This is preliminary work for hardware accelerated rendering with the
    NVIDIA driver.
    
    This moves the modifiers and formats functions previously only available
    to the GBM backend to the common glamor code so that it can be used by
    both the GBM and EGLStream backends.
    
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>
    Signed-off-by: Erik Kurzinger <ekurzinger@nvidia.com>

commit ae225417c0a0828ffb24e11eb4b968c34692e25a
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Wed Mar 3 09:55:12 2021 +0100

    xwayland: Move dmabuf interface to common glamor code
    
    This is preliminary work for hardware accelerated rendering with the
    NVIDIA driver.
    
    The EGLStream backend can possibly also use the dmabuf interface, so
    move the relevant code from the GBM specific source to the common bits.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>

commit d231ce2d9ce9644e77e8dbe8c5a23eeb11e85b55
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Wed Apr 7 22:16:43 2021 +0300

    meson: Disable LTO for tests
    
    `-flto=auto` together with `-Wl,-wrap` causes link errors at least in
    certain compilers (e.g. GCC 10.2.0). Since this is reoccurring issue
    (internet search shows similar problems with GCC 4.6 a decade ago) let's
    disable LTO for tests even if it's disabled elsewhere.
    
    Fixes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1116
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 68c2cfadd6d31f0787bc35dbafe32d7dfd638e27
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Mon Apr 5 16:24:47 2021 +0300

    meson: Make sure defines are either set to 1 or not defined
    
    This will make the behavior of meson consistent with autotools. The
    configuration macros are exposed to public headers so any inconsistency
    is likely to break code for anyone who's not careful to use #ifdef
    instead of #if.
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit faff5bbdf5dec53101a9d8f624f45262016154c1
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Mon Apr 5 16:24:46 2021 +0300

    meson: Sync the name of INPUTTHREAD conf macro with autotools build
    
    The rest of dix code uses INPUTTHREAD, so having a different name in
    meson configuration was an oversight.
    
    Fixes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/936
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit b25795462f4754ec2e3c677a41dea33ed1be79da
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Mon Apr 5 16:24:48 2021 +0300

    meson: Add missing pthread dependency for libxserver_os library
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 9582ef4efc72afa9f84b6469b5f81ce5dd8eb15d
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Mon Apr 5 16:24:45 2021 +0300

    meson: Fix typo in libxserver_os dependencies for openbsd
    
    This has not been tested, but os_deps is not used anywhere in the file,
    so it's likely this was a typo.
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 689496ed657ef055869f5eda7e09ff35edff30cc
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Wed Apr 7 21:55:03 2021 +0300

    meson: Switch project version to 20.x.y style

commit 2df55813d0f553050ff06065a67e90f678db593a
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Wed Apr 7 21:55:02 2021 +0300

    meson: Drop version subpatch handling

commit 5d3679104aaeabac585894606ad317b433b65238
Author: Adam Jackson <ajax@redhat.com>
Date:   Wed Apr 7 21:55:01 2021 +0300

    meson.build: Keep the protocol version looking like xserver 1.20.x did
    
    This effectively changes the versioning to be as if xserver 21.0 was
    xserver 1.21.0. This should keep any client-side version checks that
    know about the Xorg 7.0 -> xserver 1.0 epoch from getting confused.

commit 3e4e70db10a4b2d531ccd649c18317ea2a49d256
Author: George Matsumura <gmmatsumura01@bvsd.org>
Date:   Wed Apr 7 17:28:46 2021 -0600

    meson: Fix DragonFly BSD identifier in meson build files
    
    This changes the operating system identifier tested against
    host_machine.system() in meson build files from "dragonflybsd"
    to the officially stable "dragonfly".
    
    Signed-off-by: George Matsumura <gmmatsumura01@bvsd.org>

commit 199f278a1b7570b1cb6e24b8bedb4d721b3c9938
Author: Edouard Gaulué <edouard@e-gaulue.com>
Date:   Tue Mar 16 20:59:17 2021 +0100

    French text in Preferences Pane Review

commit 65b27d82f2c6c3eecbc7370765ee7c036b245b2f
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sun Apr 4 16:10:28 2021 -0700

    xquartz: Call PseudoramiXExtensionInit() through InitOutput() just like xwin
    
    Fixes: https://github.com/XQuartz/XQuartz/issues/140
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 34e2a64ce00c219d64b8169b774661d5727c45c7
Author: Pascal VITOUX <vitoux.pascal@gmail.com>
Date:   Fri Nov 27 16:54:59 2020 +0000

    xfree86: fix gtf support detection for EDID 1.4
    
    According to the "VESA Enhanced EDID Standard", all GTF compliant
    displays are continuous frequency.
    
    The GTF support flags in 'Display Range Limits Descriptor' cannot be
    used if the display is a non-continuous frequency multi-mode display.
    
    Closes #1105
    Signed-off-by: Pascal VITOUX <vitoux.pascal@gmail.com>
    Fixes: 6a79a737 ("xfree86: add drm modes on non-GTF panels")
    Reviewed-by: Aaron Ma aaron.ma@canonical.com

commit b75d0cca28aaae5cd21ad76ad2822138fac2882a
Author: Aaron Plattner <aplattner@nvidia.com>
Date:   Fri Feb 19 11:47:13 2021 -0800

    modesetting: Defer crtc gamma size upgrade to drmmode_setup_colormap
    
    Rather than trying to create a gamma ramp array of the appropriate size in
    drmmode_crtc_init when the GAMMA_LUT property should be used, just flag the crtc
    as wanting to use the GAMMA_LUT property and then replace the gamma ramp later,
    right before calling xf86HandleColormaps. This avoids a problem during initial
    startup where xf86RandR12CreateObjects12 hard-codes a gamma ramp size of 256,
    causing xf86RandR12CrtcSetGamma to read past the end of the DIX layer's RandR
    gamma ramp array:
    
      PreInit
        drmmode_pre_init
          drmmode_crtc_init
            crtc->gamma_size = 1024
    
      ScreenInit
        xf86CrtcScreenInit
          xf86RandR12Init
            xf86RandR12Init12
              xf86RandR12CreateObjects12
                RRCrtcCreate
                  randr_crtc->gammaSize = 0
              xf86RandR12InitGamma(pScrn, 256)
                RRCrtcGammaSetSize
                  randr_crtc->gammaSize = 256
              xf86RandR12InitGamma
                xf86RandR12CrtcInitGamma
                  RRCrtcGammaSet
                    xf86RandR12CrtcSetGamma
                      // crtc->gamma_size is 1024 here, while randr_crtc->gammaRed
                      // is a 256-element array.
                      memcpy(crtc->gamma_red, randr_crtc->gammaRed, crtc->gamma_size * sizeof(crtc->gamma_red[0]));
        drmmode_setup_colormap
          xf86HandleColormaps
            xf86RandR12InitGamma
              RRCrtcGammaSetSize
                randr_crtc->gammaSize = 1024
    
    Fixes: 245b9db0 - modesetting: Use GAMMA_LUT when available
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1126
    Signed-off-by: Aaron Plattner <aplattner@nvidia.com>
    Reviewed-by: Robert Morell <rmorell@nvidia.com>

commit ab8f8c98418db6954b17d93280b7b526fc1d3f7c
Author: Jeremie Courreges-Anglas <jca@wxcvbn.org>
Date:   Thu Jan 21 23:52:15 2021 +0100

    xserver/os: safer IPv6 "kame hack" fix, only override sin6_scope_id if zero
    
    This helps on KAME-based systems which want to get rid of this hack.
    The assumption is that if sin6_scope_id is set, then the interface index
    is no longer embedded in the address.
    
    Signed-off-by: Jeremie Courreges-Anglas <jca@wxcvbn.org>

commit aeed57d722f2eb978c17fd7e859334d34af38d05
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Fri Mar 26 00:09:41 2021 +0200

    xkb: Fix parsing of XkbSA_DeviceValuator action type
    
    The xkb spec defines that the 7th element of the DeviceValuator key
    action description is "valuator 2 value".
    
    This error most likely was accidentally introduced as a copy-paste error
    in edeb033f29ae2d52e86c543ccbf22fb7ae1fdb7f.
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit a3931ec6f43857aeed7feac5d223d7db6728145e
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Thu Mar 25 22:46:33 2021 +0200

    xfree86: Create a symlink X -> Xorg when installing using meson
    
    This brings the behavior closer than what we currently have with
    autotools-based build system.
    
    Meson does not currently have native support for symlinks.
    See https://github.com/mesonbuild/meson/issues/1602.
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 09cd65233e0f5c04e7e3d063decf357f239a65f6
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Thu Mar 25 22:48:56 2021 +0200

    xfree86: Set appropriate install_mode for suid_wrapper

commit 88b5e1a219a16dd66be6302dbf88ec93d317f991
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Thu Mar 25 22:48:55 2021 +0200

    meson: Bump min meson version to 0.47 to get install_mode support

commit 82d2156ba7b4e592a2ceb5da767b690862852caa
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Thu Mar 25 22:51:39 2021 +0200

    xfree86: Fix meson overwriting suid wrapper with the wrapped executable
    
    Meson gets confused when there are two targets of the same name within
    the same directory, so we use a different intermediate name.
    
    This is a problem with the Xorg SUID wrapper which has the same filename
    as the real Xorg executable and is configured in the same meson.build
    file. This commit works around this by using a different filename in
    build stage and renaming only when installing.
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit ba51acb1de752924c389cedbca39b5dc63679ee6
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Thu Mar 25 22:57:56 2021 +0200

    miext: Remove if check which is always true
    
    In both cases we check for width > 0 just above, and the variable is not
    modified between the checks, so the condition is always true.
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 99e7ccffb38b4c93ff0c73586ec72a7fb78cae53
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Thu Mar 25 23:18:14 2021 +0200

    dix: Fix URL to description of focus in/out model
    
    The current URL points to an unrelated patch for acpid.
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 1b7dca27eb44eac9cb0a8d1463d968872c76f4d5
Author: Simon Ser <contact@emersion.fr>
Date:   Thu Feb 18 12:04:48 2021 +0100

    xwayland: remove wl_log_set_handler_client workaround
    
    This bumps the minimum Wayland version to 1.5 (released in 2014).
    
    Signed-off-by: Simon Ser <contact@emersion.fr>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    Reviewed-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Martin Peres <martin.peres@mupuf.org>

commit 6c51818a0f55282cbe5a870f58ca82ca45ee472d
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Fri Mar 5 15:23:53 2021 +0100

    meson: Make sure XKM_OUTPUT_DIR has a trailing slash
    
    RunXkbComp passes an invalid file path to xkbcomp if there's no
    trailing slash.
    
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1146
    Suggested-by: Dylan Baker <dylan.c.baker@intel.com>

commit 376eaadde36f80fcbe6b0391a3385e77b4602854
Author: Jan Beich <jbeich@FreeBSD.org>
Date:   Fri Mar 5 22:50:51 2021 +0000

    meson: hide C API if Xorg is disabled (like autotools)
    
    When building only Xwayland using Meson some files are always installed.
    This causes package conflict if Xwayland is built separately from Xorg.
    
      include/xorg/compositeext.h
      include/xorg/damage.h
      include/xorg/damagestr.h
      include/xorg/dbestruct.h
      include/xorg/dri3.h
      include/xorg/fb.h
      include/xorg/fboverlay.h
      include/xorg/fbpict.h
      include/xorg/fbrop.h
      include/xorg/geext.h
      include/xorg/geint.h
      include/xorg/glyphstr.h
      include/xorg/mi.h
      include/xorg/micmap.h
      include/xorg/micoord.h
      include/xorg/migc.h
      include/xorg/miline.h
      include/xorg/mioverlay.h
      include/xorg/mipict.h
      include/xorg/mipointer.h
      include/xorg/mipointrst.h
      include/xorg/mistruct.h
      include/xorg/misync.h
      include/xorg/misyncfd.h
      include/xorg/misyncshm.h
      include/xorg/misyncstr.h
      include/xorg/mizerarc.h
      include/xorg/panoramiX.h
      include/xorg/panoramiXsrv.h
      include/xorg/picture.h
      include/xorg/picturestr.h
      include/xorg/present.h
      include/xorg/presentext.h
      include/xorg/randrstr.h
      include/xorg/rrtransform.h
      include/xorg/shadow.h
      include/xorg/shmint.h
      include/xorg/syncsdk.h
      include/xorg/vndserver.h
      include/xorg/wfbrename.h
      include/xorg/xace.h
      include/xorg/xacestr.h
      include/xorg/xorg-server.h
      include/xorg/xvdix.h
      include/xorg/xvmcext.h
      share/aclocal/xorg-server.m4
    
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>

commit 4ae36f418ed683532b0b6991e4a1e7d56740b845
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Mon Mar 8 21:02:40 2021 -0800

    xquartz: Ensure the mouse pointer is shown when switching to a native macOS alert or window
    
    Fixes: https://github.com/XQuartz/XQuartz/issues/100
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit b2d96b5cd459963a9587ee9c86afc9266ba3d02b
Author: Matthieu Herrb <matthieu.herrb@laas.fr>
Date:   Sat Feb 27 11:30:18 2021 +0100

    Avoid sequences of malloc(0) / free() by checking the length.
    
    This has an impact on heap fragmentation.
    
    Signed-off-by: Matthieu Herrb <matthieu.herrb@laas.fr>

commit 15a413e11d186a9206a39a9b2fe4b72c065d5918
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Mon Feb 22 23:02:42 2021 -0800

    xquartz: Update meson build to remove deleted files
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit e59848548a462f1a0ac751bb8bb6afe56258cf4e
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Fri Mar 5 22:57:24 2021 -0800

    xquartz: Fix appFlags build failure with macOS 10.15+ SDKs
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 69e087caa4fdfcc303080c021ba463afcf4290c7
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Feb 5 11:36:15 2021 +0100

    xwayland: Fix path in pkg-config with autoconf
    
    When using autoconf/automake to build Xwayland, the actual path to
    Xwayland is not fully qualified and refers to the "exec_prefix".
    
    As a result, the path provided by the generated pkg-config file is wrong
    when using autoconf to build the Xserver.
    
    Fix the xwayland.pc file to also set the variable "prefix" and
    "exec_prefix" so that the path to Xwayland is fully resolved.
    
    Add those variables to the meson build as well for good measure.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Acked-by: Michel Dänzer <mdaenzer@redhat.com>

commit d7391f383ddca5089586b4d04fede56169a1a85e
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu Mar 4 14:13:41 2021 +0100

    xwayland: Fix LeaveNotify for relative pointer
    
    Since commit 20c78f38, we use the relative pointer for enter/leave
    events.
    
    However, sprite_check_lost_focus() which verifies whether the pointer has
    left an Xwayland surface still explicitly check for the absolute
    pointer.
    
    As a result, no LeaveNotify event is emitted anymore now when the
    pointer crosses from an Xwayland surface to a Wayland native one.
    
    Make sure to check the last slave device against get_pointer_event() as
    well, not just the absolute pointer.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Acked-by: Martin Peres <martin.peres@mupuf.org>
    Acked-by: Roman Gilg <subdiff@gmail.com>
    Tested-by: Roman Gilg <subdiff@gmail.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Fixes: 20c78f38 - xwayland: use get_pointer_device() for enter/leave
                      handling too

commit a5367face12d8e4162bc49a60b5d13955a7fb293
Author: Jacob Cherry <jcherry@nvidia.com>
Date:   Wed Mar 3 17:50:31 2021 +0000

    xfree86: Fix autoconfig secondary GPU devices
    
    The code path added by commit 69e4b8e6 (xfree86: attempt to autoconfig
    gpu slave devices (v3)) assumes that it will only be run if the primary
    device on the screen is the first device in xf86configptr->conf_device_lst.
    While this is true most of the time, there are two specific cases where
    this assumption fails.
    
    First, if the first device in conf_device_lst is assigned to a different
    seat than the running X server, it will be skipped by the previous
    FIND_SUITABLE macro usage. Second, if the primary device was explicitly
    assigned to the screen but auto_gpu_device is still set and no secondary
    devices were explicitly listed, that device may not be the first device
    in conf_device_lst.
    
    When the first device in conf_device_lst is not the primary device
    assigned to the screen, two problems emerge. First, the first device in
    conf_device_lst will never be assigned to the screen as a secondary
    device. Second, the primary device is additionally assigned to the
    screen as a secondary device. The combination of these problems causes
    certain otherwise valid configurations to be invalid. For example, if a
    primary device is assigned to a screen and a secondary device is listed
    in the config but not explicitly assigned to the screen, then one order
    of the device sections results in a usable PRIME or Reverse PRIME setup
    and the other order does not.
    
    This commit removes the assumption that the primary device is the first
    device in conf_device_lst by starting the loop from the start of
    conf_device_lst and skipping the primary device when it is encountered.
    
    Signed-off-by: Jacob Cherry <jcherry@nvidia.com>

commit 97ed0048e45f4909a0c164b27e768af8c9364068
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Dec 18 17:53:33 2020 +0100

    xwayland: Delay cursor visibility update
    
    Xwayland won't emulate XWarpPointer requests if the cursor is visible,
    this is to avoid having the cursor jumping on screen and preventing
    random X11 clients from controlling the pointer in Wayland, while
    allowing games which use that mechanism with a hidden cursor to work in
    Xwayland.
    
    There are, however, games which tend to do it in the wrong order, i.e.
    show the cursor before moving the pointer, and because Xwayland will not
    allow an X11 client to move the pointer while the cursor is visible, the
    requests will fail.
    
    Add a workaround for such X11 clients, when the cursor is being shown,
    keep it invisible until the cursor is actually moved. This way, X11
    clients which show their cursor just before moving it would still have a
    chance to succeed.
    
    v2: Add a timeout to show the cursor for well behaved clients.
    v3: Some cleanup (Michel)
    v4: Do not cancel cursor delay when updating the cursor to avoid
        delaying cursor visibility indefinitely if the client keeps
        settings different cursors (Michel)
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Tested-by: Jaap Buurman jaapbuurman@gmail.com
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/734

commit 9d329a0fb17c1a7840408d329ee2e2a04d357387
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sun Feb 21 21:49:58 2021 -0800

    xquartz: Remove a check for NSAppKitVersionNumber >= NSAppKitVersionNumber10_7
    
    This check is always true on our supported systems.
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 839b49ac05c3285434d8487b48d8b52323187e44
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sun Feb 21 21:49:14 2021 -0800

    xquartz: Don't include strndup.c any more since we no longer support 10.8 and older
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 677eb6827bd68bdf29e3539d1e10e9872896efec
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sun Feb 21 20:58:42 2021 -0800

    xquartz: Add a launch trampoline to better integrate with modern versions of macOS
    
    Fixes: https://github.com/XQuartz/XQuartz/issues/6
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 25035229b73742f9e6a96ac3e535b30b5c6196a8
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Fri Feb 19 23:16:56 2021 -0800

    xquartz: Don't process AppKit events if we haven't finished initializing
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 487286d47260782d331229af10df17711cbca1ea
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sat Feb 20 17:24:14 2021 -0800

    xquartz: Allocate each fbconfig separately
    
    A change during the 1.20 development cycle resulted in fbconfigs being walked
    and deallocated individually during __glXScreenDestroy.  This change
    now avoids a use-after-free caused by that change.
    
    ==50859==ERROR: AddressSanitizer: heap-use-after-free on address 0x00010d3819c8 at pc 0x0001009d4230 bp 0x00016feca7a0 sp 0x00016feca798
    READ of size 8 at 0x00010d3819c8 thread T5
        #0 0x1009d422c in __glXScreenDestroy glxscreens.c:448
        #1 0x10091cc98 in __glXAquaScreenDestroy indirect.c:510
        #2 0x1009d2734 in glxCloseScreen glxscreens.c:169
        #3 0x100740a24 in dix_main main.c:325
        #4 0x10023ed50 in server_thread quartzStartup.c:65
        #5 0x199ae7fd0 in _pthread_start+0x13c (libsystem_pthread.dylib:arm64e+0x6fd0)
        #6 0x199ae2d38 in thread_start+0x4 (libsystem_pthread.dylib:arm64e+0x1d38)
    
    0x00010d3819c8 is located 200 bytes inside of 12800-byte region [0x00010d381900,0x00010d384b00)
    freed by thread T5 here:
        #0 0x101477ba8 in wrap_free+0x98 (libclang_rt.asan_osx_dynamic.dylib:arm64e+0x3fba8)
        #1 0x1009d4240 in __glXScreenDestroy glxscreens.c:449
        #2 0x10091cc98 in __glXAquaScreenDestroy indirect.c:510
        #3 0x1009d2734 in glxCloseScreen glxscreens.c:169
        #4 0x100740a24 in dix_main main.c:325
        #5 0x10023ed50 in server_thread quartzStartup.c:65
        #6 0x199ae7fd0 in _pthread_start+0x13c (libsystem_pthread.dylib:arm64e+0x6fd0)
        #7 0x199ae2d38 in thread_start+0x4 (libsystem_pthread.dylib:arm64e+0x1d38)
    
    previously allocated by thread T5 here:
        #0 0x101477e38 in wrap_calloc+0x9c (libclang_rt.asan_osx_dynamic.dylib:arm64e+0x3fe38)
        #1 0x100925a40 in __glXAquaCreateVisualConfigs visualConfigs.c:116
        #2 0x10091cb24 in __glXAquaScreenProbe+0x224 (X11.bin:arm64+0x100730b24)
        #3 0x1009cd840 in xorgGlxServerInit glxext.c:528
        #4 0x10074539c in _CallCallbacks dixutils.c:743
        #5 0x100932a70 in CallCallbacks callback.h:83
        #6 0x100932478 in GlxExtensionInit vndext.c:244
        #7 0x10020a364 in InitExtensions miinitext.c:267
        #8 0x10073fe7c in dix_main main.c:197
        #9 0x10023ed50 in server_thread quartzStartup.c:65
        #10 0x199ae7fd0 in _pthread_start+0x13c (libsystem_pthread.dylib:arm64e+0x6fd0)
        #11 0x199ae2d38 in thread_start+0x4 (libsystem_pthread.dylib:arm64e+0x1d38)
    
    Regressed-in: 4b0a3cbab131eb453e2b3fc0337121969258a7be
    CC: Giuseppe Bilotta <giuseppe.bilotta@gmail.com>
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 6a83fb51b7a8b2e167e7d6380229b69e5452f91f
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Sat Feb 20 15:17:18 2021 -0800

    xquartz: Fix a compiler warning about const incompatible pointer assignment
    
    driWrap.c:541:30: error: assigning to 'GCOps *' (aka 'struct _GCOps *') from 'const GCOps *' (aka 'const struct _GCOps *') discards
          qualifiers [-Werror,-Wincompatible-pointer-types-discards-qualifiers]
            pGCPriv->originalOps = pGC->ops;
                                 ^ ~~~~~~~~
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit a3ddcdd56c246e2226c7cdf372c2a1294eb6d888
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 23:16:15 2021 -0800

    xquartz: Fix build with sparkle enabled
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 279bcbd9cf9e557a6789d6e4cede8e8799c3788e
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 12:43:53 2021 -0800

    xquartz: Silence a compiler warning about missing internal methods on NSApplication
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit fe89c70e472a9da0541b798eea60c5362b49a99d
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 22:19:21 2021 -0800

    xquartz: Rewrite Window menu handling to not depend on X11App.windowsMenu.numberOfItems being correct in -awakeFromNib
    
    Fixes: https://github.com/XQuartz/XQuartz/issues/56
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 41aed8f69634ec61ea0e40fff1cfdaf868be843e
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 15:41:29 2021 -0800

    xquartz: Convert X11Controller ivars into @properties
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit c2750e1fab774c8e6675ecf284124ff55b5be9cf
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 14:39:46 2021 -0800

    xquartz: Convert X11Application ivars into @properties
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit f51b97b0de2e562e341f2d72c5f00a74c71a159f
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 14:47:50 2021 -0800

    xquartz: Fold quartzCommon.h into quartz.h
    
    Everything declared in it comes from quartz.c, so match reality.
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 4b4500c48f06e7ef41cd94f417e49b3f4f1412ae
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 13:00:43 2021 -0800

    xquartz: Fold away some unnecessary hops to X11Controller through X11Application
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 39c0e1c0ab6a0a89a71f26446973c779ca7fd927
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 09:41:30 2021 -0800

    xquartz: Fold away array_with_strings_and_numbers and simplify with more modern Objective-C
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 87f8fe1f74f10faf0ffc84f03539799ad4c2465e
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 09:33:56 2021 -0800

    xqaurtz: Remove message_kit_thread() and use dispatch instead
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 94e4e173486c2a94ddcfd2d0515e1ee6731f6656
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Feb 17 23:58:53 2021 -0800

    xquartz: Use objc_autoreleasePoolPush / objc_autoreleasePoolPop directly in QuartzBlockHandler
    
    It violates @autoreleasepool best practices, and this helps collapse quartzCocoa.m into quartz.c
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit fba421f700498fa382089df47942df36a2d75ce6
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Feb 17 22:04:55 2021 -0800

    xquartz: Minor code modernization -- @autoreleasepool adoption
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 318f8a4a8a47a0ce4bbbf4290469e933602c9b30
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Feb 17 20:55:06 2021 -0800

    xquartz: Remove some dead code for compatibility with older nibs
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 72a39dccf99191fbfbb4b399c446fd017d55f24e
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Thu Feb 18 16:05:34 2021 -0800

    xquartz: Remove a workaround for AppKit versions older than Lion
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 7e2875035800887f3f41f75cba4299088daf939a
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Feb 17 15:45:45 2021 -0800

    xquartz: Fix applications menu table background color for dark mode
    
    Fixes: https://github.com/XQuartz/XQuartz/issues/32
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 85beee9885a8e65960fbbde2de9aa28598b4d6ae
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Feb 17 15:16:26 2021 -0800

    xquartz: Apply Xcode 12.4 automatic updates to nibs
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 4e892aa6e132447e43d7bae7e3aca4f1fb172f93
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Feb 17 13:38:31 2021 -0800

    xquartz: Update the about box copyright to 2021
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit c9a3b14c1472632afaff340f73a77a2b961f195a
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Mon Feb 1 16:27:38 2021 -0800

    xquartz: Ensure we call into TIS on the main thread
    
    There is a place where this code was called on the main thread.
    
    We're using a rather nasty anti-pattern to just call a block inline rather
    than synchonously calling it on the main thread if we're already on the main
    thread.  This code could use a good overhaul, but I don't have time to rip
    it apart right now.  This will address the immediate issue.
    
    Fixes: https://github.com/XQuartz/XQuartz/issues/40
    Fixes: https://github.com/XQuartz/XQuartz/issues/48
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit af17b5c499ded807395c7ef02254d5af8ddc4667
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Mon Feb 15 14:52:32 2021 +0200

    dix: Use correct listener to deliver touch end events
    
    This fixes an problem left in f682e0563f736ed2c2c612ed575e05b6e3db945e
    due to an incorrect cherry-pick.
    
    We must use old listener->listener to deliver the touch event. Otherwise
    grab won't let the event through and the abovementioned commit has no
    effect.
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 20c78f38a0b33b88bc82a2bcd54d2e6c74a4c132
Author: Peter Hutterer <peter.hutterer@who-t.net>
Date:   Tue Feb 16 14:48:13 2021 +1000

    xwayland: use get_pointer_device() for enter/leave handling too
    
    In Weston, clicking the window decoration of an Xwayland client gives us a
    wl_pointer.button event immediately followed by a wl_pointer.leave event.
    The leave event does not contain any button state information, so the button
    remains logically down in the DIX.
    
    Once the pointer button is released, a wl_pointer.enter event is sent with
    the current button state (zero). This needs to trigger a ButtonRelease event
    but for that we need to ensure that the device is the same as the one we send
    ButtonPress events through.
    
    Fixes a regression introduced in a4095162ca923992a8cfae6d0f09ff9f8144762a.
    
    Signed-off-by: Peter Hutterer <peter.hutterer@who-t.net>
    Reviewed-by: Olivier Fourdan <ofourdan@redhat.com>

commit dee2bb033e78e2f4aae7f5708c3d4fc74a9957de
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Mon Feb 15 11:33:56 2021 +0100

    dix: Guard against non-existing PtrFeedbackPtr
    
    Trying to change the pointer control settings on a device without
    PtrFeedbackPtr would be a bug and a crash in the Xserver.
    
    Guard against that case by returning early with a BadImplementation
    error, that might kill the X11 client but the Xserver would survive.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Related: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1137

commit ab76272a7d2bff997985893c89147412a7360310
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Mon Feb 15 11:23:59 2021 +0100

    xwayland: Add PtrFeedback to the touch device
    
    Trying to change the acceleration/threshold on Xwayland cannot work, and
    the corresponding handler xwl_pointer_control() is a no-op.
    
    Yet, an X11 client trying to change those on the touch device may
    possibly cause a crash because the touch device in Xwayland doesn't set
    that.
    
    Initialize the touch device's PtrFeedback to make sure that just cannot
    happen.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1137

commit a4095162ca923992a8cfae6d0f09ff9f8144762a
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu Feb 11 11:42:01 2021 +0100

    xwayland: Use relative device for buttons/axis
    
    We are using the relative pointer for motion events, but buttons and
    axis events still go through the absolute pointer device.
    
    That means additional DeviceChanged events that could be avoided if the
    buttons and axis events were coming from the same device as motion
    events.
    
    Route those events to the relative pointer if available so that motion,
    buttons and axis events come from the same device (most of the time).
    
    Suggested-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Related: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1130

commit 1abab61dc23d585860bc847bcecb1b0315977c27
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu Feb 11 15:32:34 2021 +0100

    xwayland: Add wheel axis to relative pointer
    
    The relative pointer only has 2 axis, if we want to route the mouse
    wheel events to that device, we need to add the axis definition, similar
    to what is done for the absolute pointer.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Related: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1130

commit 71817928247971566903d56c0571db61b7933747
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Tue Feb 9 13:33:05 2021 +0100

    xwayland: Split dispatch_pointer_motion_event
    
    This is a cleanup patch, no functional change.
    
    Split the function dispatch_pointer_motion_event() into three separate
    simpler functions, relative motion with a warp emulator, relative motion
    and absolute motion.
    
    This makes the code a lot easier to read for me, rather than having
    everything in a single function with nested if/else conditions.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>

commit c5c5322ad69b0751f16c785a479b2989b8794235
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Tue Feb 9 13:04:59 2021 +0100

    xwayland: Use relative values for raw events
    
    Xwayland supports relative motion events from the Wayland compositor via
    the relative-pointer protocol, and converts those to the absolute range
    in device units for raw events.
    
    Some X11 clients however wrongly assume relative values in the axis
    values even for devices explicitly labeled as absolute. While this is a
    bug in the client, such applications would work fine in plain Xorg but
    not with Xwayland.
    
    To avoid that issue, use the relative values for raw events without
    conversion, so that such application continue to work in Xwayland.
    
    Thanks Peter for figuring out the root cause.
    
    v2: Don't duplicate relative and absolute events (Peter)
    v3: Use POINTER_RAWONLY (Peter)
    
    Suggested-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1130

commit ebdb2e264676c3b27a708328348efe73e0d3c8c2
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Tue Feb 9 13:01:21 2021 +0100

    xwayland: Use a resolution of 0 for relative motion
    
    That's what evdev/libinput drivers do.
    
    Suggested-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Related: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1130

commit b5e1f13681090fc327dc2cabee1dc123273e785b
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu Feb 11 09:48:12 2021 +0100

    dix: Add POINTER_RAWONLY flag
    
    This add a new flag POINTER_RAWONLY for GetPointerEvents() which does
    pretty much the opposite of POINTER_NORAW.
    
    Basically, this tells GetPointerEvents() that we only want the
    DeviceChanged events and any raw events for this motion but no actual
    motion events.
    
    This is preliminary work for Xwayland to be able to use relative motion
    events for raw events. Xwayland would use absolute events for raw
    events, but some X11 clients (wrongly) assume raw events to be always
    relative.
    
    To allow such clients to work with Xwayland, it needs to switch to
    relative raw events (if those are available from the Wayland
    compositor).
    
    However, Xwayland cannot use relative motion events for actual pointer
    location because that would cause a drift over time, the pointer being
    actually controlled by the Wayland compositor.
    
    So Xwayland needs to be able to send only relative raw events, hence
    this API.
    
    Bump the ABI_XINPUT_VERSION minor version to reflect that API addition.
    
    v2: Actually avoid sending motion events (Peter)
    v3: Keep sending raw emulated events with RAWONLY (Peter)
    
    Suggested-by: Peter Hutterer <peter.hutterer@who-t.net>
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Peter Hutterer <peter.hutterer@who-t.net>
    Related: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1130

commit 213129012bc0fe508a8a4180ffda1ef661894049
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun Dec 20 00:48:22 2020 +0200

    Xi: Deliver pointer emulated touch events to grabbing client
    
    Delivery of emulated events usually happens only to the owning client.
    If there are grabs, only the grabbing client may receive these events.
    
    This logic does not work during the touch event replay in
    DeactivatePointerGrab(), as the previous grab is no longer in the
    listener queue of the touch, so the next owner gets whole emulated event
    sequence. This may trigger implicit grabs. After replay,
    DeactivatePointerGrab() will update the global grab without regard to
    this new implicit grab, which leads to issues down the line.
    
    This change is effectively the same as 35e5a76cc1 except that the change
    is limited to only emulated pointer events. Otherwise, in the case of a
    device grab we end up not sending any touch events to clients that
    selected XI_TouchOwnership event and should get touch events before they
    get ownership of touch sequence.
    
    Fixes #7
    
    https://bugs.freedesktop.org/show_bug.cgi?id=96536

commit 30e11535afb3c4efc3a5cef640de44c7cd9bb561
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun Dec 20 00:48:21 2020 +0200

    Revert "Xi: Use current device active grab to deliver touch events if any"
    
    This reverts commit 98e3db2ac43d4a3f13475cb160c8ce0155ac7d61.

commit f682e0563f736ed2c2c612ed575e05b6e3db945e
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Mon Feb 8 05:21:29 2021 +0200

    dix: Send touch end to clients that do async grab without touch events
    
    If a XI2 client started listening to touches due to a selection and then
    creates an active async grab that does not include touch events, then it
    currently won't get the touch end event which will produce inconsistent
    view of the pending touches.
    
    Note that we only need to consider touch listeners and can ignore
    pointer emulation. Under XI2 if a active grab replaces a passive
    implicit grab and the active grab does not include the button release
    event, the client won't get it either.

commit c7730cfe5577ebde006d408f502766d8c3a73670
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Wed May 13 16:48:55 2020 +0200

    xwayland: Translate keyboard grabs on the root window
    
    When an X11 client issues an active grab on the keyboard, Xwayland
    forward this to the Wayland compositor using the Xwayland specific
    protocol "xwayland-keyboard-grab" if it can find the corresponding
    Xwayland window.
    
    Some X11 clients (typically older games) however try to issue the
    keyboard grab on the X11 root window, which has obviously no matching
    Xwayland window. In such a case, the grab is simply ignored and the game
    will not work as expected.
    
    To workaround that issue, if an X11 client issues a keyboard grab on the
    root window, Xwayland will search for a toplevel window belonging to the
    same X11 client that it can use as the grab window instead.
    
    This way, the grab can be forwarded to the Wayland compositor that can
    either grant or deny the request based on the window and its internal
    policies.
    
    The heuristic picks the first realized toplevel window belonging to the
    client so that the Wayland compositor will send it the keyboard events,
    and the Xserver grab mechanism will then take care of routing the events
    to the expected X11 window by itself.
    
    v2: Make the test more clear (Dor Askayo <dor.askayo@gmail.com>)
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Acked-by: Jonas Ådahl <jadahl@gmail.com>
    See-also: https://gitlab.gnome.org/GNOME/mutter/-/issues/1249

commit 520e7a1310ddc25b30bcaa0ea3eeaa6c4d137c8c
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 15:03:46 2021 -0800

    xquartz: Ensure that NSRunAlertPanel() is run on the main thread
    
    Fixes: https://github.com/XQuartz/XQuartz/issues/30
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 7d0bb7ed061458698ff27856976939b261e73b23
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:46:02 2021 -0800

    xquartz: Remove support for older versions of libXplugin
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 5e7c0762e6fdaefc9b8257c0f875432b1877c49e
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:43:01 2021 -0800

    xquartz: Remove unused include of AvailabilityMacros.h from various sources
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 59f22341a8b4cd468d6f37fb17dd7fde347e430b
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:40:48 2021 -0800

    xquartz: Remove support for building for i386
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit aea15a76593f98205e44f20632178dc384c02d57
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:35:17 2021 -0800

    xquartz: Remove support for Mountain Lion and earlier versions of macOS
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit c0b2d3e099a60f55b18ca9c30373000f12d40fe2
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:33:22 2021 -0800

    xquartz: Remove support for Lion and earlier versions of macOS
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit cc9cf6f085be6e8264f925a11d67a12ad47a042b
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:29:52 2021 -0800

    xquartz: Remove support for SnowLeopard and earlier versions of macOS
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit f699aac2ea2cf6a3e2d3bdcb2d8179e103de1d4e
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:09:50 2021 -0800

    xquartz: Remove check for libdispatch now that we don't support pre-SnowLeopard
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 5ad49102722274f53b9b011082d9e0f202fcd9a4
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:23:18 2021 -0800

    xquartz: Remove support for Leopard and earlier versions of macOS
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 6e6db055f8b517ae9d63351d4c00fd480cb6b54a
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:18:35 2021 -0800

    xquartz: Remove support for Tiger and earlier versions of macOS
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 20b86c4060c1d4fbc099675d5100fe17e4ac0147
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:12:34 2021 -0800

    os: Remove support for Tiger and earlier versions of macOS
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 74aef85bd88a1fdb22d445ad14975232a7bebdd7
Author: Jeremy Huddleston Sequoia <jeremyhu@apple.com>
Date:   Wed Jan 27 13:25:54 2021 -0800

    xquartz: Remove support for Panther and earlier versions of macOS
    
    Signed-off-by: Jeremy Huddleston Sequoia <jeremyhu@apple.com>

commit 0e272ac458fbd530787273073473e566b0ac306e
Author: Jim DeLaHunt <from.github@jdlh.com>
Date:   Mon Dec 11 00:08:52 2017 -0800

    Fix typo "XQaurtz" in Xquartz.man

commit 5429791b1cf7f6cabf6c64aad0a4b1b5418253c9
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu Jan 28 17:11:44 2021 +0100

    Revert "mi: Shortcut miDoCopy/miCopyArea based on clipList"
    
    This reverts commit f665a9c9e6c8643f3050378249db3088ae3057be.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Acked-by: Martin Peres <martin.peres@mupuf.org>
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1108
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1128

commit 3cdac5ba07a79761652d960e0e907601f82718bc
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Wed Sep 9 10:51:24 2020 +0200

    mi: List extensions in usage message
    
    Not all extensions can be enabled or disabled at runtime, list the
    extensions which can from the help message rather than on error only.
    
    v2:
     * Print the header message in the ListStaticExtensions() (Peter
       Hutterer)
     * Do not export ListStaticExtensions() as Xserver API
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>

commit a81c98e42a954580ca0d43c89169dc2069c87b96
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Tue Sep 8 18:34:48 2020 +0200

    mi: Don't log the full extension list on disable
    
    When enabling or disabling an extension which is not known to the
    Xserver, it will log an error message and list the extensions it knows
    about.
    
    That clutters the logs when the Xserver is Xwayland spawned by the
    Wayland compositor who doesn't actually know the list of extensions
    enabled at build time in the Xserver.
    
    Considering that disabling a non-existing extension is a no-op anyway,
    list all the extensions available only when attempting to enable an
    extension which the Xserver doesn't know about.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>

commit 4341f1da728e4c67187b48865faf06c1312bcdff
Author: Misha Gusarov <dottedmag@dottedmag.net>
Date:   Wed Jan 27 12:37:51 2021 +0000

    xwayland: Add -verbose option as in xfree86
    
    Makes it easier to debug Xwayland problems.
    
    Signed-off-by: Misha Gusarov <dottedmag@dottedmag.net>

commit 0148a15da1616a868d71abe1b56e3f28cc79533c
Author: Julien Cristau <jcristau@debian.org>
Date:   Wed Jan 6 10:20:53 2021 +0100

    compiler.h: don't define inb/outb and friends on mips
    
    The definition relies on IOPortBase, which is only ever set in
    hw/xfree86/os-support/bsd/arm_video.c
    
    This caused build failures on linux/mips with GCC 10, due to this
    change (from https://gcc.gnu.org/gcc-10/changes.html#c):
    
    "GCC now defaults to -fno-common. As a result, global variable accesses
    are more efficient on various targets. In C, global variables with
    multiple tentative definitions now result in linker errors. With
    -fcommon such definitions are silently merged during linking."
    
    As a result anything including compiler.h would get its own definition
    of IOPortBase and the linker would error out.

commit f08ab719df921e1269691553daf56853380fb241
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Thu Dec 17 18:58:28 2020 +0100

    ci: Test ninja dist in meson jobs
    
    While this isn't critical yet, it might become so at some point, so
    let's make sure it keeps working.
    
    Don't set the PIGLIT/XTEST_DIR variables for ninja dist, testing XTS
    once against each DDX is enough (as part of ninja test).
    
    Requires git in the docker image.
    
    v2:
    * Drop /usr/local/bin/xkbcomp symlink, no longer needed with xkbcomp
      1.4.1 (Peter Hutterer)

commit 099eb6261cfb4a7a674ead467a8a9dfb2ee173d8
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Fri Jan 15 18:32:30 2021 +0100

    ci: Build xkbcomp 1.4.1 for the docker image
    
    This is a requirement for testing meson dist in CI.

commit 9716c4193fd4db7cdf3c6d7fb32d4ad2919cbe46
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Fri Jan 22 10:29:29 2021 +0100

    xwayland: Add new pkg-config variable for listenfd
    
    Since commit b3f3d65e, xwayland now supports the command line option
    "-listenfd" for passing file descriptors and marked "-listen" as
    deprecated for this specific purpose.
    
    Add a new pkg-config variable "have_listenfd" to the xwayland.pc so that
    compositors can know this is available and use listenfd in place of the
    deprecated option.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    Reviewed-by: Jonas Ådahl <jadahl@gmail.com>

commit a9269808f394955f213e34303c2c14fd61c35ab5
Author: Erik Kurzinger <ekurzinger@nvidia.com>
Date:   Thu Jan 7 07:00:33 2021 -0800

    xwayland: remove unused parameter of xwl_glamor_pixmap_get_wl_buffer
    
    There are currently no callers that make use of the "created" output parameter
    of xwl_glamor_pixmap_get_wl_buffer. Remove it, along with the corresponding
    argument of the associated EGL backend entrypoint.

commit 532245798085a67b5ff906778f88373d5bcd2e4c
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Tue Dec 22 07:30:46 2020 +0200

    xfree86/inputtest: Drop extraneous linux-specific include
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 3ab3083cc20534c83a5a35f0af1f2779f8df0b7b
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sun Dec 20 01:11:43 2020 +0200

    xi: Don't deliver emulated motion when there's no owner for touch end
    
    Pointer-emulated touch events should only be delivered to the client
    that owns the sequence even if it's a core client that became the
    effective owner of the sequency by selecting for pointer press and
    movement.
    
    Currently the emulated events are delivered like this already (see
    TouchResourceIsOwner() check in DeliverEmulatedMotionEvent()), except in
    the case of TouchEnd, in which case the generated motion event is still
    delivered to some client that's not necessarily the owner of the touch
    sequence.
    
    We already know whether a touch sequence that is about to emulate a
    pointer event has an owner, we just need to check that. This further
    allows to simplify DeliverEmulatedMotionEvent() as it won't ever be
    called for non-owned touch events.
    
    https://bugs.freedesktop.org/show_bug.cgi?id=60394
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 365cbbfc4b99f7d9937d1b8b61f1483556a5b57a
Author: Adam Jackson <ajax@redhat.com>
Date:   Fri Dec 18 09:36:30 2020 -0500

    os, shm: fcntl()'s third argument is integer, not pointer
    
    All of these uses were attempting to set FD_CLOEXEC, which happens to be
    (1<<0). Since flags is going to be aligned in memory, its address is
    never going to have the low bit set, so we were never actually setting
    what we meant to.
    
    Fixes: xorg/xserver#1114

commit 5e3900904ddc27f3d5580ce3a07929469d82fb5e
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Fri Dec 18 04:39:07 2020 +0200

    xfree86: Use different scroll increment than libinput in inputtest drv
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 58465a3dd90c3bc698ba9ebb2c4a516df6ff7dfd
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Thu Dec 17 03:08:06 2020 +0200

    xfree86: Add scroll axes to touch devices in inputtest driver
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 91a8013990a967bfd8c4145c4a79b86cc495a205
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Thu Dec 17 03:08:05 2020 +0200

    xfree86: Add support for pressure valuator axis in inputtest driver
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit 742b87f7ee5abd1406a77ac1baacbc43759bd275
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Thu Dec 17 03:08:04 2020 +0200

    xfree86: Fix axis labels for PointerAbsolute input of inputtest driver
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit e4a9f0bb4e36cffe4f7021bfa27753a9f42df2ff
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Mon Dec 14 15:38:42 2020 +0100

    xwayland: Remove unneeded variable
    
    Just a small code cleanup, there is no need to allocate a variable only
    to check the return value of eglInitialize().
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    Reviewed-by: Tony Lindgren <tony@atomide.com>

commit 95be87db986470c8fce5ea91af0bbf3177f1de36
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Mon Dec 14 10:06:12 2020 +0100

    xwayland: Refactor glamor EGL init
    
    Glamor requires at least big GL 2.1 or GLES2, therefore Xwayland tries
    to initialize first GL and then GLES2 if that fails.
    
    It does that all in one single function which makes the code slightly
    complicated, move the initialization of big-GL and GLES2 to separate
    functions to help with readability of the code.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    Reviewed-by: Tony Lindgren <tony@atomide.com>

commit 65673b02ef28884da3267fe1be579c20e2cddfa6
Author: Tony Lindgren <tony@atomide.com>
Date:   Tue Dec 1 12:54:36 2020 +0200

    xwayland: fix GL version check for GLES only devices
    
    We currently bail out early for GLES only devices, and call
    epoxy_gl_version() too early for GLES only that will make GLES only
    devices return NULL for glGetString(GL_RENDERER).
    
    Let's also add a check to see if we need to recreate the context to
    avoid pointless warnings for GLES only devices as suggested by
    Olivier Fourdan <ofourdan@redhat.com>.
    
    Fixes: a506b4ec - xwayland: make context current to check GL version
    Signed-off-by: Tony Lindgren <tony@atomide.com>

commit 5d73a8b59e0d01d1ee4cb484e4b43563cec2eee9
Author: Fabrice Fontaine <fontaine.fabrice@gmail.com>
Date:   Thu Dec 10 22:32:59 2020 +0100

    meson.build: KMS support also depends on dri2
    
    Kernel modesettings support also depends on dri2, see
    ./hw/xfree86/drivers/modesetting/meson.build
    
    So update meson.build to reflect the changes made in configure.ac by
    commit 9c81b8f5b5d7bc987f73e8ef01a81e61205e58ee
    
    Signed-off-by: Fabrice Fontaine <fontaine.fabrice@gmail.com>

commit 8c0afc9eb26a0866301072dec30717885fd14305
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sat Oct 10 02:09:05 2020 +0300

    xfree86: Implement a test input driver
    
    Signed-off-by: Povilas Kanapickas <povilas@radix.lt>

commit f95d81e88be07f43c91660e675d077ccd9ee47a9
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Mon Dec 7 14:21:56 2020 +0100

    xwayland: Hold window buffer until released
    
    The window buffer mechanism would free the pixmap and its corresponding
    Wayland buffer as soon as window buffers are disposed.
    
    Typically when the X11 window is unrealized, the current window buffer
    is still used by the Wayland compositor and yet Xwayland will destroy
    the buffer.
    
    As a matter of fact, Xwayland should not destroy the Wayland buffer
    before the wl_buffer.release event is received.
    
    Add a reference counter to the window buffer similar to the to pixmap
    reference counter to keep the buffer around until the release callback
    is received.
    
    Increase that reference counter on the buffer which will be attached to
    the surface, and drop that reference when receiving the release callback
    notification.
    
    v2: Use a specific reference counter on the buffer rather than relying
        on the pixmap refcnt (Michel Dänzer <mdaenzer@redhat.com>)
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    Acked-by: Martin Peres <martin.peres@mupuf.org>

commit 85d8eac4bcf44c077bb82aaae10ae45feb9c4e72
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Mon Dec 7 14:09:58 2020 +0100

    xwayland: Hold cursor buffer until released
    
    The cursor code would destroy the buffer as soon as the cursor is
    unrealized on X11 side.
    
    Yet, the Wayland compositor may still be using the buffer as long as a
    released callback has not been received.
    
    Increase the reference counter on the pixmap to hold a reference on the
    pixmap when attaching it to the surface and use the new pixmap release
    callback mechanism to release that reference when the buffer is
    released.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Acked-by: Martin Peres <martin.peres@mupuf.org>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>

commit 79afbd608b7e6abc5d6d0f7e1fb6e460500c7934
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu Dec 10 10:10:05 2020 +0100

    xwayland: Factorize common cursor code
    
    The seat and tablet cursor functions are very similar, factorize the
    commonalities to simplify the code and reduce the copy/paste.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>

commit 36e353bcf428c4e6a31292ffa749ea6395cba4a3
Author: Prabhu Sundararaj <prabhu.sundararaj@nxp.com>
Date:   Wed Nov 25 08:02:41 2020 +0100

    Remove check for useSIGIO option
    
    Commit 6a5a4e60373c1386b311b2a8bb666c32d68a9d99 removed the option to
    configure useSIGIO option. Indeed, the xfree86 SIGIO support was
    reworked to use internal versions of OsBlockSIGIO and OsReleaseSIGIO.
    
    As a result, useSIGIO is no longer needed and can dropped
    
    Fixes: 6a5a4e60 - Remove SIGIO support for input [v5]
    Closes: xorg/xserver#1107
    Reviewed-by: Adam Jackson <ajax@redhat.com>
    Signed-off-by: Prabhu Sundararaj <prabhu.sundararaj@nxp.com>
    Signed-off-by: Mylène Josserand <mylene.josserand@free-electrons.com>
    Signed-off-by: Fabrice Fontaine <fontaine.fabrice@gmail.com>

commit 95539ab37baa1292d1f2daaa552f9741b0364cad
Author: Mariusz Ceier <mceier+freedesktop@gmail.com>
Date:   Wed Dec 2 12:29:15 2020 +0100

    xwayland: Replace LogMessage with LogMessageVerb
    
    LogMessage logs only when the XLOG_VERBOSITY is >= 1, but by default
    XLOG_VERBOSITY is 0, so for example warning about deprected -listen
    parameter is never shown when running "Xwayland -listen 32 -help".
    
    Signed-off-by: Mariusz Ceier <mceier+freedesktop@gmail.com>

commit 74627d13c75cab7aa73c0e713feae0934e780ba0
Author: Michal Srb <msrb@suse.com>
Date:   Thu Jun 21 13:44:04 2018 +0200

    xkb: Fix heap overflow caused by optimized away min.
    
    Calling strlen on char[4] that does not need to contain '\0' is wrong and X
    server may end up running into uninitialized memory.
    
    In addition GCC 8 is clever enough that it knows that strlen on char[4] can
    return 0, 1, 2, 3 or cause undefined behavior. With this knowledge it can
    optimize away the min(..., 4). In reality it can cause the memcpy to be called
    with bigger size than 4 and overflow the destination buffer.
    
    Fixes: 83913de25d35 (xkb: Silence some compiler warnings)
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/288
    Signed-off-by: Matt Turner <mattst88@gmail.com>

commit 446ff2d3177087b8173fa779fa5b77a2a128988b
Author: Matthieu Herrb <matthieu@herrb.eu>
Date:   Thu Nov 12 19:15:07 2020 +0100

    Check SetMap request length carefully.
    
    Avoid out of bounds memory accesses on too short request.
    
    ZDI-CAN 11572 /  CVE-2020-14360
    
    This vulnerability was discovered by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Matthieu Herrb <matthieu@herrb.eu>

commit 87c64fc5b0db9f62f4e361444f4b60501ebf67b9
Author: Matthieu Herrb <matthieu@herrb.eu>
Date:   Sun Oct 11 17:05:09 2020 +0200

    Fix XkbSetDeviceInfo() and SetDeviceIndicators() heap overflows
    
    ZDI-CAN 11389 / CVE-2020-25712
    
    This vulnerability was discovered by:
    Jan-Niklas Sohn working with Trend Micro Zero Day Initiative
    
    Signed-off-by: Matthieu Herrb <matthieu@herrb.eu>

commit 11652706b0aa7d2609b710db0bd1262c5f6ed596
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Fri Nov 20 16:54:02 2020 +0100

    present/wnmd: Translate update region to screen space
    
    The region as passed in is in the source pixmap's coordinate space, so
    intersecting it with the clipList (which is in screen space) resulted in
    disappointment.
    
    Fixes Firefox popups such as the hamburger menu when using the EGL
    backend.
    
    v2:
    * Drop vblank->x/y_off from RegionTranslate call, since they're always
      0 here (present_wnmd_check_flip rejects flips for x/y_off != 0).
    
    Reported-by: Robert Mader <robert.mader@posteo.de>
    Tested-by: Robert Mader <robert.mader@posteo.de>
    Reviewed-by: Olivier Fourdan <ofourdan@redhat.com>
    Tested-by: Joakim Tjernlund <joakim.tjernlund@infinera.com> # v1

commit b0530fe42286f340032566ce0bf22a5e9ddfe67f
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Tue Jan 28 18:51:53 2020 +0100

    glx: Remove unused bswap_CARD64
    
    GCC warned about it:
    
    ../../../glx/indirect_dispatch_swap.c:85:1: warning: ‘bswap_CARD64’ defined but not used [-Wunused-function]
       85 | bswap_CARD64(const void *src)
          | ^~~~~~~~~~~~

commit 3ce05a44f3d9b114af936f39e3f44552c5bf2c43
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu Nov 26 14:39:32 2020 +0100

    modesetting: Fix build with DebugPresent() enabled
    
    By default, the macro DebugPresent() is a no-op but it can be enabled
    at build time for debugging purpose.
    
    However, doing so prevents the code to build because one debug statement
    tries to make use of a non-existent variable:
    
      present.c: In function ‘ms_present_queue_vblank’:
      present.c:147:18: error: ‘vbl’ undeclared (first use in this function)
        147 |                  vbl.request.sequence));
            |                  ^~~
      present.c:49:32: note: in definition of macro ‘DebugPresent’
        49 | #define DebugPresent(x) ErrorF x
           |                                ^
    
    Fix the build with DebugPresent() by removing the vbl variable from the
    debug message.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>

commit 95b79aa907789a16f736097abe959e906f86f63a
Author: Erik Kurzinger <ekurzinger@nvidia.com>
Date:   Fri Nov 13 14:36:14 2020 -0800

    GLX: fix context render type queries
    
    Querying the GLX_RENDER_TYPE of a GLX context via glXQueryContext will
    currently return the render type of the context's FB config, which is
    a bitmask of GLX_RGBA_BIT / GLX_COLOR_INDEX_BIT / ... values. However,
    this query should really return the render type that was specified
    when creating the context, which is one of GLX_RGBA_TYPE /
    GLX_COLOR_INDEX_TYPE / .... To enable this, save the render type when
    creating a new context (defaulting to GLX_RGBA_TYPE if unspecified),
    and then include this value in the context attributes sent to clients.

commit 9c81b8f5b5d7bc987f73e8ef01a81e61205e58ee
Author: Fabrice Fontaine <fontaine.fabrice@gmail.com>
Date:   Wed Jan 8 22:51:42 2020 +0100

    configure.ac: KMS support also depends on dri2
    
    Kernel modesettings support also depends on dri2, see
    http://cgit.freedesktop.org/xorg/xserver/tree/hw/xfree86/drivers/modesetting/Makefile.am#n46
    
    Fix #479
    
    Signed-off-by: Bernd Kuhls <bernd.kuhls@t-online.de>
    [Patch retrieved (with a small update of commit message) from:
    https://git.buildroot.net/buildroot/tree/package/x11r7/xserver_xorg-server/1.20.6/0001-modesettings-needs-dri2.patch]
    Signed-off-by: Fabrice Fontaine <fontaine.fabrice@gmail.com>

commit 682167475c1930f80a68de58e522ac08dbb35fa8
Author: Böszörményi Zoltán <zboszor@pr.hu>
Date:   Thu Nov 14 09:29:20 2019 +0100

    Introduce and use BUS_USB
    
    With !155, the device bus ID received via udev is constructed
    properly with the "usb:" prefix. But, it is not enough to
    make the following line to work in Section "Device":
    
        BusID  "usb:0:1.2:1.0"
    
    Introduce BUS_USB, so the prefix can be distinguished from BUS_PCI
    and check the supplied BusID value against device->attribs->busid
    in xf86PlatformDeviceCheckBusID().
    
    Signed-off-by: Böszörményi Zoltán <zboszor@pr.hu>

commit c0dcadad6c18b06ddc6e349d7c58bfccb715ff55
Author: Reza Arbab <arbab@linux.ibm.com>
Date:   Wed Mar 27 11:45:02 2019 -0500

    linux: Fix udev ID_PATH parsing for udl devices
    
    The ID_PATH for a udl device looks like this:
    
      $ udevadm info /dev/dri/card2 | grep -w ID_PATH
      E: ID_PATH=pci-0000:00:14.0-usb-0:9.1:1.0
    
    The parsing added in 0816e8fca6194 ("linux: Make platform device probe
    less fragile"), sets OdevAttributes::busid to "pci:0000:00:14.0", where
    drmGetBusid() would have returned "3-9.1:1.0".
    
    Identifying this as a "pci:*" device eventually causes the vendor/device
    id check in probeSingleDevice() to fail, because a USB controller isn't
    a supported device:
    
      $ udevadm info --path=/devices/pci0000:00/0000:00:14.0 | grep -e VENDOR -e ID_PCI_CLASS
      E: ID_PCI_CLASS_FROM_DATABASE=Serial bus controller
      E: ID_VENDOR_FROM_DATABASE=Intel Corporation
    
    Instead of parsing out "pci:0000:00:14.0" in this case, use
    "usb:0:9.1:1.0" so the device probe will succeed.
    
    Fixes: 0816e8fca6194 ("linux: Make platform device probe less fragile")
    Signed-off-by: Reza Arbab <arbab@linux.ibm.com>

commit af4622d3f90382225afb83e3896cb6f236f30c0a
Author: Aaron Plattner <aplattner@nvidia.com>
Date:   Fri Nov 20 19:43:25 2020 -0800

    modesetting: Add missing copyright notices
    
    I forgot to add these in commits 4fefe73fe, b6985d6b3, 245b9db03, and 4e670f128.
    
    Signed-off-by: Aaron Plattner <aplattner@nvidia.com>

commit 07e6935030c8f0a757bce0a90c54b59d8bf47df6
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sat Oct 10 02:51:40 2020 +0300

    test/xi2: Fix mask size in XISelectEvents test
    
    XI2LASTEVENT identifies the bit number, not the mask size in bits. The
    mask size in bits is XI2LASTEVENT + 1 and the mask size in bytes is
    (XI2LASTEVENT + 8) / 8 or XI2MASKSIZE.

commit f5220117e970a40c09babe199709bb2db69c4311
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sat Oct 10 02:51:39 2020 +0300

    dix: Extract FreezeThisEventIfNeededForSyncGrab()

commit 36f8dacc0652ddc5657e70942269f1f9e22710c6
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sat Oct 10 02:51:37 2020 +0300

    dix: Extract ActivateGrabNoDeliver()

commit 23a8b62d34344575f9df9d057fb74bfefa94a77b
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sat Oct 10 02:51:36 2020 +0300

    dix: Store replayed event into GrabInfoRec struct as InternalEvent*

commit 8bd8b3af1931629db548d39bb390edbef4315b0b
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sat Oct 10 02:51:35 2020 +0300

    dix: Rename LISTENER_* to TOUCH_LISTENER_*

commit f6e0bf68333f7edb02e3b937bc164f6591da2320
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sat Oct 10 02:51:34 2020 +0300

    Xi: Make check_for_touch_selection_conflicts() more generic

commit 56d720592155c55617728e8ddf1ba8192fe5d46c
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sat Oct 10 02:51:33 2020 +0300

    dix: Extract DeliverDeviceClassesChangedEvent() utility function

commit 5b0c5344b7131f0812bcbf070194adaa2175d150
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sat Oct 10 02:51:32 2020 +0300

    dix: Extract CopySprite() utility

commit acd819ac07bf66165f5d44af4a224f68c31bc30d
Author: Povilas Kanapickas <povilas@radix.lt>
Date:   Sat Oct 10 02:51:31 2020 +0300

    dix: Extract FixUpXI2DeviceEventFromWindow()

commit bb7aab6afe8655fc40ecff49791889b6512bb6a0
Author: Jon Turney <jon.turney@dronecode.org.uk>
Date:   Sat Nov 21 15:45:49 2020 +0000

    hw/xwin: Fix building with -fno-common
    
    Provide an actual definition of noDriExtension where used, rather than a
    tentative definition in a header, to fix compilation with -fno-common
    (the default with gcc 10).

commit d18dcecbe08a9ff22e43f12b6b7679a6ef1a6eb0
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Mon Nov 2 10:24:45 2020 +0100

    xwayland: Clean up pending eglstream on pixmap destroy
    
    EGLStream implementation in Xwayland keeps a list of pending streams for
    a window.
    
    If the windows's pixmap is destroyed while there is a pending stream,
    the pending stream will point to freed memory once the callback is
    triggered.
    
    Make sure to cancel the pending stream if there's one when the pixmap is
    destroyed.
    
    v2:
     * Use xorg_list_for_each_entry() instead of the safe variant (Michel
       Dänzer <mdaenzer@redhat.com>)
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Tested-by: Karol Szuster <karolsz9898@gmail.com>
    Acked-by: Michel Dänzer <mdaenzer@redhat.com>
    Closes https://gitlab.freedesktop.org/xorg/xserver/-/issues/1096

commit 662b2bcb84d5782aff1b93732eb010b0b43e5706
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Tue Sep 22 09:54:15 2020 +0200

    xwayland: Use the pixmap release callback with EGLStream
    
    Commit 77658741 - "xwayland: Add buffer release callback" added an API
    to deal with Wayland buffer release callbacks.
    
    The EGLstream implementation has its own wl_buffer callback, move that
    to the buffer release API instead so we don't have to deal with Wayland
    buffers directly and match the other Xwayland pixmap backend
    implementations.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    Tested-by: Erik Kurzinger <ekurzinger@nvidia.com>

commit e538601128c1a8bb4247a817da2bbb3f671811b3
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Nov 1 15:52:48 2020 -0800

    int10: wrap entire V_ADDR_R* macros in parens for safer expansion
    
    Resolves warnings from Oracle Parfait static analyser:
    
    Error: Misleading macro
       Misleading macro [misleading-macro]:
          misleading evaluation of ternary '?:' operator in expansion of macro V_ADDR_RB due to missing parentheses
            at line 392 of hw/xfree86/int10/generic.c.
            '|' operator has higher precedence than ternary '?:' operator inside macro body at line 431
            low precedence ternary '?:' operator is hidden by expansion of macro V_ADDR_RB at line 431
       Misleading macro [misleading-macro]:
          misleading evaluation of ternary '?:' operator in expansion of macro V_ADDR_RB due to missing parentheses
            at line 392 of hw/xfree86/int10/generic.c.
            '<<' operator has higher precedence than ternary '?:' operator inside macro body at line 431
            low precedence ternary '?:' operator is hidden by expansion of macro V_ADDR_RB at line 431
       Misleading macro [misleading-macro]:
          misleading evaluation of ternary '?:' operator in expansion of macro V_ADDR_RB due to missing parentheses
            at line 392 of hw/xfree86/int10/generic.c.
            '<<' operator has higher precedence than ternary '?:' operator inside macro body at line 442
            low precedence ternary '?:' operator is hidden by expansion of macro V_ADDR_RB at line 442
       Misleading macro [misleading-macro]:
          misleading evaluation of ternary '?:' operator in expansion of macro V_ADDR_RB due to missing parentheses
            at line 392 of hw/xfree86/int10/generic.c.
            '<<' operator has higher precedence than ternary '?:' operator inside macro body at line 443
            low precedence ternary '?:' operator is hidden by expansion of macro V_ADDR_RB at line 443
       Misleading macro [misleading-macro]:
          misleading evaluation of ternary '?:' operator in expansion of macro V_ADDR_RB due to missing parentheses
            at line 392 of hw/xfree86/int10/generic.c.
            '|' operator has higher precedence than ternary '?:' operator inside macro body at line 443
            low precedence ternary '?:' operator is hidden by expansion of macro V_ADDR_RB at line 441
       Misleading macro [misleading-macro]:
          misleading evaluation of ternary '?:' operator in expansion of macro V_ADDR_RB due to missing parentheses
            at line 392 of hw/xfree86/int10/generic.c.
            '<<' operator has higher precedence than ternary '?:' operator inside macro body at line 443
            low precedence ternary '?:' operator is hidden by expansion of macro V_ADDR_RB at line 443
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit a6574033f464c7cde02bce8f1b130ff6b2b2d9eb
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Nov 1 15:45:08 2020 -0800

    xkb: always set *mask_rtrn in XkbVirtualModsToReal
    
    Resolves warning from Oracle Parfait static analyser:
    
    Error: Uninitialised memory
       Uninitialised memory variable [uninitialised-mem-var] (CWE 457):
          Possible access to uninitialised memory referenced by variable 'mask'
            at line 721 of xkb/XKBMisc.c in function 'XkbUpdateKeyTypeVirtualMods'.
            Path in callee avoiding write at line 720
              mask allocated at line 718
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 034e792662a1c0c6ab52190e457b1f017bec01c6
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Nov 1 13:55:59 2020 -0800

    dmx: example code should set a good example
    
    Resolves warning from Oracle Parfait static analyser:
    
    Error: Unchecked result
       Unchecked result [unchecked-result-call-X]:
          Unchecked return value from call to XOpenDisplay. Value display must be ch
    ecked to ensure this function was successful.
            at line 73 of hw/dmx/examples/xbell.c in function 'main'.
    
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit d00594ebc7941a5491ad5583d6890ab7dc2ffc43
Author: Alan Coopersmith <alan.coopersmith@oracle.com>
Date:   Sun Nov 1 13:38:21 2020 -0800

    AddInputDevice: only need to check once if we failed to calloc dev
    
    Resolves warning from Oracle Parfait static analyser:
    
    Warning: Impossible or redundant condition
       Impossible or redundant condition [impossible-redundant-condition]:
          Condition 'dev != NULL' of branch is determined by previous branch
            at line 270 of dix/devices.c in function 'AddInputDevice'.
              Condition 'dev != NULL' from this branch implies following branch is always true at line 262
    
    Fixes: commit 493ad83323
    Signed-off-by: Alan Coopersmith <alan.coopersmith@oracle.com>

commit 250db8708ac7ab11356b42faa493b6f1ba753013
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Tue Sep 15 11:49:20 2020 +0200

    xwayland: Add and hook up test script
    
    It runs XTS via piglit on (non-rootless) Xwayland on weston using the
    headless backend.
    
    Xwayland might use glamor if enabled in the build, but we're making sure
    it uses software rendering.
    
    v2:
    * Use weston-info to wait for weston to be ready, instead of just a
      fixed sleep. (Martin Peres)
    v3:
    * Build wayland 1.18 & weston 9.0 locally, since the packages in Debian
      buster are too old for current Xwayland.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 821399a9c920323e4934a2fd6375b86a151fa83c
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Wed Nov 11 12:45:36 2020 +0100

    ci: Base docker image on Debian buster instead of testing
    
    By its nature, testing incurs a risk of breaking something every time
    we bump the image.
    
    This requires building wayland-protocols locally, since the package in
    buster is too old for current Xwayland.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit ab73c16930d67e5c80a23727804850406309b787
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Wed Sep 16 16:32:02 2020 +0200

    ci: Update to the latest templates
    
    They now ensure the image is up to date in forked projects, and we no
    longer need to reconstruct the image name.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 852d6d49109a3f0a9a73c86f5d5165d2c8dc5cbe
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Thu Nov 12 12:19:09 2020 +0100

    ci: Explicitly list packages needed to build xserver
    
    Instead of relying on apt-get build-dep.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 8469935fe26659219560f425c7b35d564ad77324
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Thu Nov 12 12:01:45 2020 +0100

    ci: Use a variable for ephemeral packages
    
    So that they only need to be listed once.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 996ba1b99a7212471d3c24359056c412de70c28d
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Wed Nov 11 18:22:28 2020 +0100

    ci: Remove rendercheck Git tree
    
    Noticed this was missing while making changes in this area.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 8fc84a00254f642947397276e14d7740f502895d
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Wed Nov 11 19:02:50 2020 +0100

    ci: Set GIT_STRATEGY=none for the container build job
    
    It doesn't need a full checkout of the xserver Git tree, so this can
    save some time and resources.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 9a7515943f5a9b70567512cdc48cb2f688b3284b
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Wed Sep 16 12:55:35 2020 +0200

    ci: Use $FDO_CI_CONCURRENT if set
    
    To take advantage of more than 4 CPU cores available to the container.
    
    Acked-by: Olivier Fourdan <ofourdan@redhat.com>

commit 28ed4b95e90fb225fc32cfdce16df603ab600fcd
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Tue Nov 10 10:40:05 2020 +0100

    xwayland: Add a man page
    
    Xwayland was missing a man page, add one.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Martin Peres <martin.peres@mupuf.org>

commit d14cef853af52408e7ddba31b72cf5ac14389754
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Tue Nov 10 10:02:39 2020 +0100

    xwayland: Do not list option "-eglstream" if not supported
    
    As Xwayland is usually spawned by the Wayland server/compositor, its
    command line options are not always adjustable.
    
    Yet, if EGLStream is not supported in a given Xwayland build, the option
    will do nothing (yet we must still accept it otherwise Xwayland would
    refuse to run if the Wayland compositor uses it).
    
    If Xwayland was built without support for EGLStream, there is not point
    in showing the option in the help message though.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Martin Peres <martin.peres@mupuf.org>

commit d163f938a00c177c5ff28e779993f18ee69476d4
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Tue Nov 10 09:53:57 2020 +0100

    xwayland: Add help entry for -shm
    
    The command line options "-shm" is used to instruct Xwayland to prefer
    shared-memory for passing buffers to the Wayland server, rather than
    using glamor and DRI3.
    
    The option was there from the beginning, yet not documented in the
    "-help" message.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Martin Peres <martin.peres@mupuf.org>

commit df3aa4922fd7e256169e541188b724f67ca948e1
Author: Michel Dänzer <mdaenzer@redhat.com>
Date:   Fri Nov 6 10:14:19 2020 +0100

    xwayland: Make window_get_client_toplevel non-recursive
    
    Noticed while reading the code.
    
    Reviewed-by: Olivier Fourdan <ofourdan@redhat.com>

commit 899cebb76ab7754fea49f7babcd64a7e94052cc8
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Tue Oct 27 16:33:55 2020 +0100

    configure: Build hashtable for Xres and glvnd
    
    With autoconf, hashtable support is built along with Xres support.
    
    Yet, glvnd also use it, so when disabling Xres from configure, the
    build will fail at link time because hashtable functions are not
    available.
    
    Untie the build of hashtable from Xres support, just like meson build
    does.
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Closes: https://gitlab.freedesktop.org/xorg/xserver/-/issues/1091

commit 606ba7fc51e5420646f75c4e672fbe61eb7c7e6e
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Thu Nov 5 18:35:54 2020 +0100

    xwayland: Create an xwl_window for toplevel only
    
    One general assumption in Xwayland is that the xwl_window remains the
    same for all the child windows of the toplevel window.
    
    When mapping a new X11 window, ensure_surface_for_window() checks for an
    existing xwl_window by using xwl_window_get() which will just check for
    the registered xwl_window for the window.
    
    That means that a client mapping a child window of an existing window
    with a xwl_window will get another different xwl_window.
    
    If an X11 client issues a Present request on the parent window, hence
    placed underneath its child window of the same size, the Wayland
    compositor may not send the frame callback event for the parent's
    Wayland surface which is reckoned to be not visible, obscured behind
    the other Wayland surface for the child X11 window.
    
    That bug affects some games running in wine which may get 1 fps because
    the repaint occurs only on timeout with a long interval (as with, e.g.
    https://bugs.winehq.org/show_bug.cgi?id=47066)
    
    Fix ensure_surface_for_window() by using xwl_window_from_window() which
    will walk the window tree, so that a child window won't get another
    xwl_window than its parent.
    
    https://gitlab.freedesktop.org/xorg/xserver/-/issues/1099
    See-also: https://bugs.winehq.org/show_bug.cgi?id=47066
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>

commit ffd02d9b26bd560849c407a6dd4f5c4d7d2c1736
Author: Olivier Fourdan <ofourdan@redhat.com>
Date:   Mon Nov 2 15:44:31 2020 +0100

    xwayland: non-rootless requires the XDG-WM-Base protocol
    
    When running non-rootless, Xwayland requires that the Wayland compositor
    supports the XDG-WM-Base protocol.
    
    Check for XDG-WM-Base protocol support at startup and exit cleanly if
    missing rather than segfaulting later in ensure_surface_for_window()
    while trying to use xdg_wm_base_get_xdg_surface().
    
    Signed-off-by: Olivier Fourdan <ofourdan@redhat.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>
    Reviewed-by: Simon Ser <contact@emersion.fr>

commit 7a7e55c5c1d6461a9f4d9a4e0129c1c6e1fd3d66
Author: Alex Goins <agoins@nvidia.com>
Date:   Mon Oct 5 18:19:52 2020 -0500

    glamor: Update pixmap's devKind when making it exportable
    
    When making a pixmap exportable, glamor will currently create a temporary
    exported pixmap backed by a GBM bo, with the devKind updated to the stride of
    the bo. However, when the backing of the exported pixmap is swapped into the
    original, the devKind of the original is not updated.
    
    Some GBM bos may get implicitly padded, in which case the devKind of the pixmap
    will not match the stride of the backing bo. For example, an 800x600 pixmap will
    have a devKind of 3200, but the bo's stride will be 3328. This can cause
    corruption with PRIME, when the sink uses the wrong stride to display the shared
    pixmap.
    
    This commit changes glamor_make_pixmap_exportable() to update the devKind of the
    original pixmap after it swaps exported pixmap's backing into it, keeping
    everything consistent.
    
    Fixes issue #1018.
    
    Signed-off-by: Alex Goins <agoins@nvidia.com>
    Signed-off-by: Aaron Plattner <aplattner@nvidia.com>
    Reviewed-by: Michel Dänzer <mdaenzer@redhat.com>

commit affc47452507d7e4605fd8c9a16db078e4f2aea2
Author: Adam Jackson <ajax@redhat.com>
Date:   Tue Sep 22 16:13:00 2020 -0400

    xwayland: Drop the separate refcount for the xwl_pixmap
    
    Instead, bump the pixmap's refcount at the bottom of post_damage to
    reflect the compositor's hold on the buffer, and "destroy" the pixmap in
    the buffer release callback (which will dec the pixmap's refcount and
    free if necessary).
    
